# Copyright (C) 2023  The CivRealm project
#
# This program is free software: you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the Free
# Software Foundation, either version 3 of the License, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#
# You should have received a copy of the GNU General Public License along
# with this program.  If not, see <http://www.gnu.org/licenses/>.

freeciv_wiki_docs = {
    "A.Smith's Trading Co.": {
        "image": "Adam Smith.jpg",
        "summary": "Adam Smith  (16 June 1723 NS (5 June 1723 OS) \u2013 17 July 1790) was a Scottish economist, philosopher and author as well as a moral philosopher, a pioneer of political economy and a key figure during the Scottish Enlightenment era. Smith is best known for two classic works: The Theory of Moral Sentiments (1759) and An Inquiry into the Nature and Causes of the Wealth of Nations (1776). The latter, usually abbreviated as The Wealth of Nations, is considered his magnum opus and the first modern work of economics.\nSmith studied social philosophy at the University of Glasgow and at Balliol College, Oxford, where he was one of the first students to benefit from scholarships set up by fellow Scot, John Snell. After graduating, he delivered a successful series of public lectures at Edinburgh, leading him to collaborate with David Hume during the Scottish Enlightenment. Smith obtained a professorship at Glasgow teaching moral philosophy and during this time wrote and published The Theory of Moral Sentiments. In his later life, he took a tutoring position that allowed him to travel throughout Europe, where he met other intellectual leaders of his day.\nSmith laid the foundations of classical free market economic theory. The Wealth of Nations was a precursor to the modern academic discipline of economics. In this and other works, he developed the concept of division of labour and expounded upon how rational self-interest and competition can lead to economic prosperity. Smith was controversial in his own day and his general approach and writing style were often satirised by Tory writers in the moralising tradition of William Hogarth and Jonathan Swift. In 2005, The Wealth of Nations was named among the 100 Best Scottish Books of all time. The minor planet 12838 Adamsmith was named in his memory.",
        "title": "Adam Smith"
    },
    "AEGIS Cruiser": {
        "image": "Ticonderoga-class cruiser.jpg",
        "summary": "The Ticonderoga class of guided missile cruisers is a class of warships in the United States Navy, first ordered and authorized in the 1978 fiscal year. The class uses passive phased-array radar and was originally planned as a class of destroyers. However, the increased combat capability offered by the Aegis Combat System and the AN/SPY-1 radar system, together with the capability of operating as a flagship, were used to justify the change of the classification from DDG (guided missile destroyer) to CG (guided-missile cruiser) shortly before the keels were laid down for Ticonderoga and Yorktown.\nTiconderoga-class guided-missile cruisers are multi-role warships. Their Mk 41 VLS can launch Tomahawk cruise missiles to strike strategic or tactical targets, or fire long-range antiaircraft Standard Missiles for defense against aircraft or anti-ship missiles. Their LAMPS III helicopters and sonar systems allow them to perform antisubmarine missions. Ticonderoga-class ships are designed to be elements of carrier battle groups or amphibious ready groups, as well as performing missions such as interdiction or escort. With upgrades to their to AN/SPY-1 phased radar systems and their associated missile payloads as part of the Aegis Ballistic Missile Defense System, members of this class have also begun to demonstrate some promise as mobile anti-ballistic missile and anti-satellite weaponry platforms.\nOf the 27 completed vessels, 19 were built by Ingalls Shipbuilding and eight by Bath Iron Works (BIW). All but one (Thomas S. Gates) of the ships in the class are named for noteworthy events in U.S. military history, and at least twelve\u2014Ticonderoga, Cowpens, Anzio, Yorktown, Valley Forge, Bunker Hill, Antietam, San Jacinto, Lake Champlain, Philippine Sea, Princeton, Monterey, and Vella Gulf\u2014share their names with World War II aircraft carriers. 22 ships were active in 2016, and expected to serve for 35 years since commissioning.\n\n",
        "title": "Ticonderoga-class cruiser"
    },
    "AWACS": {
        "image": "Boeing E-3 Sentry.jpg",
        "summary": "The Boeing E-3 Sentry, commonly known as AWACS, is an American airborne early warning and control (AEW&C) aircraft developed by Boeing. Derived from the Boeing 707, it provides all-weather surveillance, command, control, and communications, and is used by the United States Air Force, NATO, Royal Air Force, French Air Force, and Royal Saudi Air Force. The E-3 is distinguished by the distinctive rotating radar dome above the fuselage. Production ended in 1992 after 68 aircraft had been built.\nIn the mid-1960s, the US Air Force (USAF) was seeking an aircraft to replace its piston-engined Lockheed EC-121 Warning Star, which had been in service for over a decade. After issuing preliminary development contracts to three companies, the USAF picked Boeing to construct two airframes to test Westinghouse Electric and Hughes's competing radars. Both radars used pulse-Doppler technology, with Westinghouse's design emerging as the contract winner. Testing on the first production E-3 began in October 1975.\nThe first USAF E-3 was delivered in March 1977, and during the next seven years, a total of 34 aircraft were manufactured. NATO, as a single identity, also had 18 aircraft manufactured, basing them in Germany. The E-3 was also sold to the United Kingdom (seven) and France (four) and Saudi Arabia (five, plus eight E-3-derived tanker aircraft). In 1991, when the last aircraft had been delivered, E-3s participated in Operation Desert Storm, playing a crucial role of directing coalition aircraft against the enemy. Throughout the aircraft's service life, numerous upgrades were performed to enhance its capabilities. In 1996, Westinghouse Electric's Defense & Electronic Systems division, was acquired by Northrop Corporation before its being renamed Northrop Grumman Electronic Systems, which currently supports the E-3's radar.",
        "title": "Boeing E-3 Sentry"
    },
    "Advanced Flight": {
        "image": "Aeronautics.jpg",
        "summary": "Aeronautics (from the ancient Greek words \u1f70\u03ae\u03c1 \u0101\u0113r, which means \"air\", and \u03bd\u03b1\u03c5\u03c4\u03b9\u03ba\u03ae nautik\u0113 which means \"navigation\", i.e. \"navigation into the air\") is the science or art involved with the study, design, and manufacturing of air flight capable machines, and the techniques of operating aircraft and rockets within the atmosphere. The British Royal Aeronautical Society identifies the aspects of \"aeronautical Art, Science and Engineering\" and \"the profession of Aeronautics (which expression includes Astronautics).\" \nWhile the term\u2014literally meaning \"sailing the air\"\u2014originally referred solely to the science of operating the aircraft, it has since been expanded to include technology, business, and other aspects related to aircraft. The term \"aviation\" is sometimes used interchangeably with aeronautics, although \"aeronautics\" includes lighter-than-air craft such as airships, and includes ballistic vehicles while \"aviation\" technically does not.\nA significant part of aeronautical science is a branch of dynamics called aerodynamics, which deals with the motion of air and the way that it interacts with objects in motion, such as an aircraft.",
        "title": "Aeronautics"
    },
    "Airport": {
        "image": "Airport.jpg",
        "summary": "An airport is an aerodrome with extended facilities, mostly for commercial air transport. Airports often have facilities to store and maintain aircraft, and a control tower. An airport consists of a landing area, which comprises an aerially accessible open space including at least one operationally active surface such as a runway for a plane to take off or a helipad, and often includes adjacent utility buildings such as control towers, hangars and terminals. Larger airports may have fixed-base operator services, airport aprons, taxiway bridges, air traffic control centres, passenger facilities such as restaurants and lounges, and emergency services.\nAn airport with a helipad for rotorcraft but no runway is called a heliport. An airport for use by seaplanes and amphibious aircraft is called a seaplane base. Such a base typically includes a stretch of open water for takeoffs and landings, and seaplane docks for tying-up.\nAn international airport has additional facilities for customs and passport control.\nIn warfare, airports can become the focus of intense fighting, for example the Battle of Tripoli Airport or the Battle for Donetsk Airport, both taking place in 2014. An airport primarily for military use is called an airbase or air station.\nMost of the world's airports are owned by local, regional, or national government bodies.",
        "title": "Airport"
    },
    "Alphabet": {
        "image": "Alphabet.jpg",
        "summary": "An alphabet is a standard set of letters (basic written symbols or graphemes) that is used to write one or more languages based upon the general principle that the letters represent phonemes (basic significant sounds) of the spoken language. This is in contrast to other types of writing systems, such as syllabaries (in which each character represents a syllable) and logographies (in which each character represents a word, morpheme, or semantic unit).\nThe Proto-Canaanite script, later known as the Phoenician alphabet, is the first fully phonemic script. Thus the Phoenician alphabet is considered to be the first alphabet. The Phoenician alphabet is the ancestor of most modern alphabets, including Arabic, Greek, Latin, Cyrillic, Hebrew, and possibly Brahmic. Under a terminological distinction promoted by Peter T. Daniels, an \"alphabet\" is a script that represents both vowels and consonants as letters equally. In this narrow sense of the word the first \"true\" alphabet was the Greek alphabet, which was developed on the basis of the earlier Phoenician alphabet. In other alphabetic scripts such as the original Phoenician, Hebrew or Arabic, letters predominantly or exclusively represent consonants such a script is also called an abjad. A third type, called abugida or alphasyllabary, is one where vowels are shown by diacritics or modifications of consonantal base letters, as in Devanagari and other South Asian scripts. The Khmer alphabet (for Cambodian) is the longest, with 74 letters.\nThere are dozens of alphabets in use today, the most popular being the Latin alphabet (which was derived from the Greek). Many languages use modified forms of the Latin alphabet, with additional letters formed using diacritical marks. While most alphabets have letters composed of lines (linear writing), there are also exceptions such as the alphabets used in Braille.\nAlphabets are usually associated with a standard ordering of letters. This makes them useful for purposes of collation, specifically by allowing words to be sorted in alphabetical order. It also means that their letters can be used as an alternative method of \"numbering\" ordered items, in such contexts as numbered lists and number placements.",
        "title": "Alphabet"
    },
    "Alpine Troops": {
        "image": "Mountain warfare.jpg",
        "summary": "Mountain warfare refers to warfare in the mountains or similarly rough terrain. This type of warfare is also called Alpine warfare, after the Alps mountains. Mountain warfare is one of the most dangerous types of combat as it involves surviving not only combat with the enemy but also the extreme weather and dangerous terrain.\nMountain ranges are of strategic importance since they often act as a natural border, and may also be the origin of a water source (e.g. Golan Heights \u2013 water conflict). Attacking a prepared enemy position in mountain terrain requires a greater ratio of attacking soldiers to defending soldiers than a war conducted on level ground. Mountains at any time of year are dangerous \u2013 lightning, strong gusts of wind, rock falls, avalanche, snow pack, ice, extreme cold, glaciers with their crevasses and the general uneven terrain and the slow pace of troop and material movement are all additional threats to combatants. Movement, reinforcements, and medical evacuation up and down steep slopes and areas where even pack animals cannot reach involves an enormous exertion of energy.\n\n",
        "title": "Mountain warfare"
    },
    "Amphibious Warfare": {
        "image": "Amphibious warfare.jpg",
        "summary": "Amphibious warfare is a type of offensive military operation that today uses naval ships to project ground and air power onto a hostile or potentially hostile shore at a designated landing beach. Through history the operations were conducted using ship's boats as the primary method of delivering troops to shore. Since the Gallipoli Campaign specialised watercraft were increasingly designed for landing troops, materiel and vehicles, including by landing craft and for insertion of commandos, by fast patrol boats, zodiacs (rigid inflatable boats) and from mini-submersibles.\nThe term amphibious first emerged in the UK and the USA during the 1930s with introduction of vehicles such as Vickers-Carden-Loyd Light Amphibious Tank or the Landing Vehicle Tracked.\nAmphibious warfare includes operations defined by their type, purpose, scale and means of execution. In the British Empire at the time these were called combined operations which were defined as \"...operations where naval, military or air forces in any combination are co-operating with each other, working independently under their respective commanders, but with a common strategic object.\" All armed forces that employ troops with special training and equipment for conducting landings from naval vessels to shore agree to this definition.\nSince the 20th century an amphibious landing of troops on a beachhead is acknowledged as the most complex of all military maneuvers. The undertaking requires an intricate coordination of numerous military specialties, including air power, naval gunfire, naval transport, logistical planning, specialized equipment, land warfare, tactics, and extensive training in the nuances of this maneuver for all personnel involved.\n\n",
        "title": "Amphibious warfare"
    },
    "Anarchy": {
        "image": "Anarchy.jpg",
        "summary": "Anarchy is the condition of a society, entity, group of people, or a single person that rejects hierarchy. The word originally meant leaderlessness, but in 1840 Pierre-Joseph Proudhon adopted the term in his treatise What Is Property? to refer to a new political philosophy: anarchism, which advocates stateless societies based on voluntary associations. In practical terms, anarchy can refer to the curtailment or abolition of traditional forms of government and institutions. It can also designate a nation (or anywhere on earth that is inhabited) that has no system of government or central rule.",
        "title": "Anarchy"
    },
    "Apollo Program": {
        "image": "Apollo program.jpg",
        "summary": "The Apollo program, also known as Project Apollo, was the third United States human spaceflight program carried out by the National Aeronautics and Space Administration (NASA), which accomplished landing the first humans on the Moon from 1969 to 1972. First conceived during Dwight D. Eisenhower's administration as a three-man spacecraft to follow the one-man Project Mercury which put the first Americans in space, Apollo was later dedicated to President John F. Kennedy's national goal of \"landing a man on the Moon and returning him safely to the Earth\" by the end of the 1960s, which he proposed in an address to Congress on May 25, 1961.\nKennedy's goal was accomplished on the Apollo 11 mission when astronauts Neil Armstrong and Buzz Aldrin landed their Lunar Module (LM) on July 20, 1969, and walked on the lunar surface, while Michael Collins remained in lunar orbit in the Command/Service Module (CSM), and all three landed safely on Earth on July 24. Five subsequent Apollo missions also landed astronauts on the Moon, the last in December 1972. In these six spaceflights, twelve men walked on the Moon.\nApollo ran from 1961 to 1972, with the first manned flight in 1968. It achieved its goal of manned lunar landing, despite the major setback of a 1967 Apollo 1 cabin fire that killed the entire crew during a prelaunch test. After the first landing, sufficient flight hardware remained for nine follow-on landings with a plan for extended lunar geological and astrophysical exploration. Budget cuts forced the cancellation of three of these. Five of the remaining six missions achieved successful landings, but the Apollo 13 landing was prevented by an oxygen tank explosion in transit to the Moon, which damaged the CSM's propulsion and life support. The crew returned to Earth safely by using the Lunar Module as a \"lifeboat\" for these functions. Apollo used Saturn family rockets as launch vehicles, which were also used for an Apollo Applications Program, which consisted of Skylab, a space station that supported three manned missions in 1973\u201374, and the Apollo\u2013Soyuz Test Project, a joint Earth orbit mission with the Soviet Union in 1975.\nApollo set several major human spaceflight milestones. It stands alone in sending manned missions beyond low Earth orbit. Apollo 8 was the first manned spacecraft to orbit another celestial body, while the final Apollo 17 mission marked the sixth Moon landing and the ninth manned mission beyond low Earth orbit. The program returned 842 pounds (382 kg) of lunar rocks and soil to Earth, greatly contributing to the understanding of the Moon's composition and geological history. The program laid the foundation for NASA's subsequent human spaceflight capability, and funded construction of its Johnson Space Center and Kennedy Space Center. Apollo also spurred advances in many areas of technology incidental to rocketry and manned spaceflight, including avionics, telecommunications, and computers.",
        "title": "Apollo program"
    },
    "Aqueduct": {
        "image": "Aqueduct (water supply).jpg",
        "summary": "An aqueduct is a watercourse constructed to convey water. In modern engineering, the term aqueduct is used for any system of pipes, ditches, canals, tunnels, and other structures used for this purpose. The term aqueduct also often refers specifically to a bridge on an artificial watercourse. The word is derived from the Latin aqua (\"water\") and ducere (\"to lead\"). Aqueducts were used in ancient Greece, ancient Egypt, and ancient Rome. In modern times, the largest aqueducts of all have been built in the United States to supply the country's biggest cities. The simplest aqueducts are small ditches cut into the earth. Much larger channels may be used in modern aqueducts. Aqueducts sometimes run for some or all of their path through tunnels constructed underground. Modern aqueducts may also use pipelines. Historically, agricultural societies have constructed aqueducts to irrigate crops and supply large cities with drinking water.",
        "title": "Aqueduct (water supply)"
    },
    "Archers": {
        "image": "Archery.jpg",
        "summary": "Archery is the sport, practice or skill of using a bow to propel arrows. The word comes from the Latin arcus. Historically, archery has been used for hunting and combat. In modern times, it is mainly a competitive sport and recreational activity. A person who participates in archery is typically called an archer or a bowman, and a person who is fond of or an expert at archery is sometimes called a toxophilite.",
        "title": "Archery"
    },
    "Armor": {
        "image": "Armoured fighting vehicle.jpg",
        "summary": "An armoured fighting vehicle (AFV) is an armed combat vehicle protected by armour, generally combining operational mobility with tactical offensive and defensive capabilities. AFVs can be wheeled or tracked. Tanks, armoured cars, armoured self-propelled guns, and armoured personnel carriers are all examples of AFVs. It is not uncommon for AFVs in general to be simply referred to as \"armour\".\nThe concept of a highly mobile and protected fighting unit has been around for centuries from Hannibal's war elephants to Leonardo's war machines, military strategists endeavoured to maximize the mobility and survivability of their soldiers. Armoured fighting vehicles are classified according to their intended role on the battlefield and characteristics. This classification is not absolute at different times different countries will classify the same vehicle in different roles. For example, armoured personnel carriers were generally replaced by infantry fighting vehicles in a similar role, but the latter has some capabilities lacking in the former. There may also be hybrid vehicles, such as the Stryker family of AFVs the M1128 Mobile Gun System, an armoured car which mounts a large 105 mm gun normally used in tank destroyers and tanks, but can theoretically be reconfigured to the M1126 Infantry Carrier Vehicle.\nSuccessful general-purpose armoured fighting vehicles often also serve as the base of a whole family of specialized vehicles, for example, the M113 and MT-LB tracked carriers, and the MOWAG Piranha wheeled AFV.",
        "title": "Armoured fighting vehicle"
    },
    "Artillery": {
        "image": "Artillery.jpg",
        "summary": "Artillery is a class of large military weapons built to fire munitions far beyond the range and power of infantry's small arms. Early artillery development focused on the ability to breach fortifications, and led to heavy, fairly immobile siege engines. As technology improved, lighter, more mobile field artillery developed for battlefield use. This development continues today modern self-propelled artillery vehicles are highly mobile weapons of great versatility providing the largest share of an army's total firepower.\nIn its earliest sense, the word artillery referred to any group of soldiers primarily armed with some form of manufactured weapon or armour. Since the introduction of gunpowder and cannon, the word \"artillery\" has largely meant cannon, and in contemporary usage, it usually refers to shell-firing guns, howitzers, mortars, rockets and guided missiles. In common speech, the word artillery is often used to refer to individual devices, along with their accessories and fittings, although these assemblages are more properly called \"equipments\". However, there is no generally recognised generic term for a gun, howitzer, mortar, and so forth: the United States uses \"artillery piece\", but most English-speaking armies use \"gun\" and \"mortar\". The projectiles fired are typically either \"shot\" (if solid) or \"shell\" (if not). \"Shell\" is a widely used generic term for a projectile, which is a component of munitions.\nBy association, artillery may also refer to the arm of service that customarily operates such engines. In some armies one arm has operated field, coast, anti-aircraft artillery and some anti-tank artillery, in others these have been separate arms and in some nations coast has been a naval or marine responsibility. In the 20th Century technology based target acquisition devices, such as radar, and systems, such as sound ranging and flash spotting, emerged to acquire targets, primarily for artillery. These are usually operated by one or more of the artillery arms. The widespread adoption of indirect fire in the early 20th century introduced the need for specialist data for field artillery, notably survey and meteorological, in some armies provision of these are the responsibility of the artillery arm.\nArtillery originated for use against ground targets\u2014against infantry, cavalry and other artillery. An early specialist development was coastal artillery for use against enemy ships. The early 20th Century saw the development of a new class of artillery for use against aircraft: anti-aircraft guns.\nArtillery is arguably the most lethal form of land-based armament currently employed, and has been since at least the early Industrial Revolution. The majority of combat deaths in the Napoleonic Wars, World War I, and World War II were caused by artillery. In 1944, Joseph Stalin said in a speech that artillery was \"the God of War\".",
        "title": "Artillery"
    },
    "Astronomy": {
        "image": "Astronomy.jpg",
        "summary": "Astronomy (from Greek: \u1f00\u03c3\u03c4\u03c1\u03bf\u03bd\u03bf\u03bc\u03af\u03b1) is a natural science that studies celestial objects and phenomena. It applies mathematics, physics, and chemistry, in an effort to explain the origin of those objects and phenomena and their evolution. Objects of interest include planets, moons, stars, galaxies, and comets the phenomena include supernova explosions, gamma ray bursts, and cosmic microwave background radiation. More generally, all astronomical phenomena that originate outside Earth's atmosphere are within the purview of astronomy. A related but distinct subject, physical cosmology, is concerned with the study of the Universe as a whole.\nAstronomy is one of the oldest of the natural sciences. The early civilizations in recorded history, such as the Babylonians, Greeks, Indians, Egyptians, Nubians, Iranians, Chinese, Maya, and many ancient Indigenous Peoples of The Americas performed methodical observations of the night sky. Historically, astronomy has included disciplines as diverse as astrometry, celestial navigation, observational astronomy and the making of calendars, but professional astronomy is now often considered to be synonymous with astrophysics.\nDuring the 20th century, the field of professional astronomy split into observational and theoretical branches. Observational astronomy is focused on acquiring data from observations of astronomical objects, which is then analyzed using basic principles of physics. Theoretical astronomy is oriented toward the development of computer or analytical models to describe astronomical objects and phenomena. The two fields complement each other, with theoretical astronomy seeking to explain observational results and observations being used to confirm theoretical results.\nAstronomy is one of the few sciences where amateurs still play an active role, especially in the discovery and observation of transient phenomena. Amateur astronomers have made and contributed to many important astronomical discoveries, such as finding new comets.",
        "title": "Astronomy"
    },
    "Atomic Theory": {
        "image": "Atomic theory.jpg",
        "summary": "In chemistry and physics, atomic theory is a scientific theory of the nature of matter, which states that matter is composed of discrete units called atoms. It began as a philosophical concept in ancient Greece and entered the scientific mainstream in the early 19th century when discoveries in the field of chemistry showed that matter did indeed behave as if it were made up of atoms.\nThe word atom comes from the Ancient Greek adjective atomos, meaning \"indivisible\". 19th century chemists began using the term in connection with the growing number of irreducible chemical elements. While seemingly apropos, around the turn of the 20th century, through various experiments with electromagnetism and radioactivity, physicists discovered that the so-called \"uncuttable atom\" was actually a conglomerate of various subatomic particles (chiefly, electrons, protons and neutrons) which can exist separately from each other. In fact, in certain extreme environments, such as neutron stars, extreme temperature and pressure prevents atoms from existing at all.\nSince atoms were found to be divisible, physicists later invented the term \"elementary particles\" to describe the \"uncuttable\", though not indestructible, parts of an atom. The field of science which studies subatomic particles is particle physics, and it is in this field that physicists hope to discover the true fundamental nature of matter.",
        "title": "Atomic theory"
    },
    "Automobile": {
        "image": "Car.jpg",
        "summary": "A car (or automobile) is a wheeled motor vehicle used for transportation. Most definitions of car say they run primarily on roads, seat one to eight people, have four tires, and mainly transport people rather than goods. Cars came into global use during the 20th century, and developed economies depend on them. The year 1886 is regarded as the birth year of the modern car, when German inventor Karl Benz built his Benz Patent-Motorwagen. Cars did not become widely available until the early 20th century. One of the first cars that was accessible to the masses was the 1908 Model T, an American car manufactured by the Ford Motor Company. Cars were rapidly adopted in the US, where they replaced animal-drawn carriages and carts, but took much longer to be accepted in Western Europe and other parts of the world.\nCars have controls for driving, parking, passenger comfort and safety, and controlling a variety of lights. Over the decades, additional features and controls have been added to vehicles, making them progressively more complex. Examples include rear reversing cameras, air conditioning, navigation systems, and in car entertainment. Most cars in use in the 2010s are propelled by an internal combustion engine, fueled by the combustion of fossil fuels. This causes air pollution and is also blamed for contributing to climate change and global warming. Vehicles using alternative fuels such as ethanol flexible-fuel vehicles and natural gas vehicles are also gaining popularity in some countries. Electric cars, which were invented early in the history of the car, began to become commercially available in 2008.\nThere are costs and benefits to car use. The costs include acquiring the vehicle, interest payments (if the car is financed), repairs and maintenance, fuel, depreciation, driving time, parking fees, taxes, and insurance. The costs to society include maintaining roads, land use, road congestion, air pollution, public health, health care, and disposing of the vehicle at the end of its life. Road traffic accidents are the largest cause of injury-related deaths worldwide.\nThe benefits include on-demand transportation, mobility, independence, and convenience. The societal benefits include economic benefits, such as job and wealth creation from the automotive industry, transportation provision, societal well-being from leisure and travel opportunities, and revenue generation from the taxes. The ability for people to move flexibly from place to place has far-reaching implications for the nature of societies. It was estimated in 2014 that the number of cars was over 1.25 billion vehicles, up from the 500 million of 1986. The numbers are increasing rapidly, especially in China, India and other newly industrialized countries.",
        "title": "Car"
    },
    "Bank": {
        "image": "Bank.jpg",
        "summary": "A bank is a financial institution where we can deposit or withdraw money on demand. Lending activities can be performed either directly or indirectly through capital markets. Due to their importance in the financial stability of a country, banks are highly regulated in most countries. Most nations have institutionalized a system known as fractional reserve banking under which banks hold liquid assets equal to only a portion of their current liabilities. In addition to other regulations intended to ensure liquidity, banks are generally subject to minimum capital requirements based on an international set of capital standards, known as the Basel Accords.\nBanking in its modern sense evolved in the 14th century in the prosperous cities of Renaissance Italy but in many ways was a continuation of ideas and concepts of credit and lending that had their roots in the ancient world. In the history of banking, a number of banking dynasties  \u2013 notably, the Medicis, the Fuggers, the Welsers, the Berenbergs and the Rothschilds  \u2013 have played a central role over many centuries. The oldest existing retail bank is Banca Monte dei Paschi di Siena, while the oldest existing merchant bank is Berenberg Bank.",
        "title": "Bank"
    },
    "Banking": {
        "image": "Bank.jpg",
        "summary": "A bank is a financial institution where we can deposit or withdraw money on demand. Lending activities can be performed either directly or indirectly through capital markets. Due to their importance in the financial stability of a country, banks are highly regulated in most countries. Most nations have institutionalized a system known as fractional reserve banking under which banks hold liquid assets equal to only a portion of their current liabilities. In addition to other regulations intended to ensure liquidity, banks are generally subject to minimum capital requirements based on an international set of capital standards, known as the Basel Accords.\nBanking in its modern sense evolved in the 14th century in the prosperous cities of Renaissance Italy but in many ways was a continuation of ideas and concepts of credit and lending that had their roots in the ancient world. In the history of banking, a number of banking dynasties  \u2013 notably, the Medicis, the Fuggers, the Welsers, the Berenbergs and the Rothschilds  \u2013 have played a central role over many centuries. The oldest existing retail bank is Banca Monte dei Paschi di Siena, while the oldest existing merchant bank is Berenberg Bank.",
        "title": "Bank"
    },
    "Barbarian Leader": {
        "image": "Barbarian.jpg",
        "summary": "A barbarian is a human who is perceived to be either uncivilized or primitive. The designation is usually applied as generalization based on a popular stereotype barbarians can be any member of a nation judged by some to be less civilised or orderly (such as a tribal society), but may also be part of a certain \"primitive\" cultural group (such as nomads) or social class (such as bandits) both within and outside one's own nation. Alternatively, they may instead be admired and romanticised as noble savages. In idiomatic or figurative usage, a \"barbarian\" may also be an individual reference to a brutal, cruel, warlike, insensitive person.\nThe term originates from the Greek: \u03b2\u03ac\u03c1\u03b2\u03b1\u03c1\u03bf\u03c2 (barbaros pl. \u03b2\u03ac\u03c1\u03b2\u03b1\u03c1\u03bf\u03b9 barbaroi), which in turn originates from the incomprehensible languages of early Anatolian nations that were heard by the Greeks as \"bar..bar..\" In ancient times, the Greeks used it mostly for people of different cultures, but there are examples where one Greek city or state would use the word to attack another. In the early modern period and sometimes later, Greeks used it for the Turks, in a clearly pejorative way. Comparable notions are found in non-European civilizations, notably China and Japan. During the Roman Empire, the Romans used the word \"barbarian\" for many people, such as the Germanics, Celts, Gauls, Iberians, Thracians, Illyrians, Parthians, Berbers and Sarmatians.",
        "title": "Barbarian"
    },
    "Barracks": {
        "image": "Barracks.jpg",
        "summary": "A barrack or barracks is a building or group of buildings built to house soldiers. The English word comes via French from an old Catalan word \"barraca\" (hut), originally referring to temporary shelters or huts for various people and animals, but today barracks are usually permanent buildings for military accommodation. The word may apply to separate housing blocks or to complete complexes, and the plural form often refers to a single structure and may be singular in construction.\nThe main object of barracks is to separate soldiers from the civilian population and reinforce discipline, training, and esprit de corps. They have been called \"discipline factories for soldiers\". Like industrial factories, some are considered to be shoddy or dull buildings, although others are known for their magnificent architecture such as Collins Barracks in Dublin and others in Paris, Berlin, Madrid, Vienna, or London. From the rough barracks of 19th-century conscript armies, filled with hazing and illness and barely differentiated from the livestock pens that housed the draft animals, to the clean and Internet-connected barracks of modern all-volunteer militaries, the word can have a variety of connotations.",
        "title": "Barracks"
    },
    "Barracks II": {
        "image": "Barracks.jpg",
        "summary": "A barrack or barracks is a building or group of buildings built to house soldiers. The English word comes via French from an old Catalan word \"barraca\" (hut), originally referring to temporary shelters or huts for various people and animals, but today barracks are usually permanent buildings for military accommodation. The word may apply to separate housing blocks or to complete complexes, and the plural form often refers to a single structure and may be singular in construction.\nThe main object of barracks is to separate soldiers from the civilian population and reinforce discipline, training, and esprit de corps. They have been called \"discipline factories for soldiers\". Like industrial factories, some are considered to be shoddy or dull buildings, although others are known for their magnificent architecture such as Collins Barracks in Dublin and others in Paris, Berlin, Madrid, Vienna, or London. From the rough barracks of 19th-century conscript armies, filled with hazing and illness and barely differentiated from the livestock pens that housed the draft animals, to the clean and Internet-connected barracks of modern all-volunteer militaries, the word can have a variety of connotations.",
        "title": "Barracks"
    },
    "Barracks III": {
        "image": "Barracks.jpg",
        "summary": "A barrack or barracks is a building or group of buildings built to house soldiers. The English word comes via French from an old Catalan word \"barraca\" (hut), originally referring to temporary shelters or huts for various people and animals, but today barracks are usually permanent buildings for military accommodation. The word may apply to separate housing blocks or to complete complexes, and the plural form often refers to a single structure and may be singular in construction.\nThe main object of barracks is to separate soldiers from the civilian population and reinforce discipline, training, and esprit de corps. They have been called \"discipline factories for soldiers\". Like industrial factories, some are considered to be shoddy or dull buildings, although others are known for their magnificent architecture such as Collins Barracks in Dublin and others in Paris, Berlin, Madrid, Vienna, or London. From the rough barracks of 19th-century conscript armies, filled with hazing and illness and barely differentiated from the livestock pens that housed the draft animals, to the clean and Internet-connected barracks of modern all-volunteer militaries, the word can have a variety of connotations.",
        "title": "Barracks"
    },
    "Battleship": {
        "image": "Battleship.jpg",
        "summary": "A battleship is a large armored warship with a main battery consisting of large caliber guns. During the late 19th and early 20th centuries the battleship was the most powerful type of warship, and a fleet of battleships was considered vital for any nation that desired to maintain command of the sea.\nThe word battleship was coined around 1794 and is a contraction of the phrase line-of-battle ship, the dominant wooden warship during the Age of Sail. The term came into formal use in the late 1880s to describe a type of ironclad warship, now referred to by historians as pre-dreadnought battleships. In 1906, the commissioning of HMS Dreadnought heralded a revolution in battleship design. Subsequent battleship designs, influenced by HMS Dreadnought, were referred to as \"dreadnoughts\".\nBattleships were a symbol of naval dominance and national might, and for decades the battleship was a major factor in both diplomacy and military strategy. A global arms race in battleship construction began in Europe in the 1890s and culminated at the decisive Battle of Tsushima in 1905 the outcome of which significantly influenced the design of HMS Dreadnought. The launch of Dreadnought in 1906 commenced a new naval arms race. Three major fleet actions between steel battleships took place: the decisive battles of the Yellow Sea (1904) and Tsushima (1905) during the Russo-Japanese War, and the inconclusive Battle of Jutland (1916) during the First World War. Jutland was the largest naval battle and the only full-scale clash of battleships in the war, and it was the last major battle fought primarily by battleships in world history.\nThe Naval Treaties of the 1920s and 1930s limited the number of battleships, though technical innovation in battleship design continued. Both the Allied and Axis powers built battleships during World War II, though the increasing importance of the aircraft carrier meant that the battleship played a less important role than had been expected.\nThe value of the battleship has been questioned, even during their heyday. There were few of the decisive fleet battles that battleship proponents expected, and used to justify the vast resources spent on building battlefleets. Even in spite of their huge firepower and protection, battleships were increasingly vulnerable to much smaller, cheaper weapons: initially the torpedo and the naval mine, and later aircraft and the guided missile. The growing range of naval engagements led to the aircraft carrier replacing the battleship as the leading capital ship during World War II, with the last battleship to be launched being HMS Vanguard in 1944. Battleships were retained by the United States Navy into the Cold War for fire support purposes before being stricken from the U.S. Naval Vessel Register in the 2000s.\n\n",
        "title": "Battleship"
    },
    "Bomber": {
        "image": "Bomber.jpg",
        "summary": "A bomber is a combat aircraft designed to attack ground and naval targets by dropping air-to-ground weaponry (such as bombs), firing torpedoes and bullets or deploying air-launched cruise missiles.\n\n",
        "title": "Bomber"
    },
    "Bridge Building": {
        "image": "Bridge.jpg",
        "summary": "A bridge is a structure built to span physical obstacles without closing the way underneath such as a body of water, valley, or road, for the purpose of providing passage over the obstacle. There are many different designs that each serve a particular purpose and apply to different situations. Designs of bridges vary depending on the function of the bridge, the nature of the terrain where the bridge is constructed and anchored, the material used to make it, and the funds available to build it.",
        "title": "Bridge"
    },
    "Bronze Working": {
        "image": "Bronze Age.jpg",
        "summary": "The Bronze Age is a historical period characterized by the use of bronze, proto-writing, and other early features of urban civilization. The Bronze Age is the second principal period of the three-age Stone-Bronze-Iron system, as proposed in modern times by Christian J\u00fcrgensen Thomsen, for classifying and studying ancient societies.\nAn ancient civilization is defined to be in the Bronze Age either by producing bronze by smelting its own copper and alloying with tin, arsenic, or other metals, or by trading for bronze from production areas elsewhere. Bronze itself is harder and more durable than other metals available at the time, allowing Bronze Age civilizations to gain a technological advantage.\nCopper-tin ores are rare, as reflected in the fact that there were no tin bronzes in Western Asia before trading in bronze began in the 3rd millennium BC. Worldwide, the Bronze Age generally followed the Neolithic period, with the Chalcolithic serving as a transition. Although the Iron Age generally followed the Bronze Age, in some areas (such as Sub-Saharan Africa), the Iron Age intruded directly on the Neolithic.\nBronze Age cultures differed in their development of the first writing. According to archaeological evidence, cultures in Mesopotamia (cuneiform script) and Egypt (hieroglyphs) developed the earliest viable writing systems.",
        "title": "Bronze Age"
    },
    "Cannon": {
        "image": "Cannon.jpg",
        "summary": "A cannon (plural: cannon or cannons) is a type of gun classified as artillery that launches a projectile using propellant. In the past, gunpowder was the primary propellant before the invention of smokeless powder in the 19th century. Cannon vary in caliber, range, mobility, rate of fire, angle of fire, and firepower different forms of cannon combine and balance these attributes in varying degrees, depending on their intended use on the battlefield. The word cannon is derived from several languages, in which the original definition can usually be translated as tube, cane, or reed. In the modern era, the term cannon has fallen into decline, replaced by \"guns\" or \"artillery\" if not a more specific term such as \"gun\", \"mortar\" or \"howitzer\", except for in the field of aerial warfare, where it is often used as shorthand for autocannon.\nThe earliest known depiction of cannon appeared in Song dynasty China as early as the 12th century, however solid archaeological and documentary evidence of cannon do not appear until the 13th century. In 1288 Yuan dynasty troops are recorded to have used hand cannons in combat, and the earliest extant cannon bearing a date of production comes from the same period. Evidence of cannon next appeared in Europe. By 1326 depictions of cannon had also appeared in Europe and almost immediately recorded usage of cannon began appearing. By the end of the 14th century cannon were widespread throughout Eurasia. Cannon were used primarily as anti-infantry weapons until around 1374 when cannon were recorded to have breached walls for the first time in Europe. Cannon featured prominently as siege weapons and ever larger pieces appeared. In 1464 a 16,000 kg cannon known as the Great Turkish Bombard was created in the Ottoman Empire. Cannon as field artillery became more important after 1453 with the introduction of limber, which greatly improved cannon maneuverability and mobility. European cannon reached their longer, lighter, more accurate, and more efficient \"classic form\" around 1480. This classic European cannon design stayed relatively consistent in form with minor changes until the 1750s.",
        "title": "Cannon"
    },
    "Caravan": {
        "image": "Camel train.jpg",
        "summary": "A camel train or caravan is a series of camels carrying passengers and/or goods on a regular or semi-regular service between points. Although they rarely travelled faster than the walking speed of a man, camels' ability to withstand harsh conditions made them ideal for communication and trade in the desert areas of North Africa and the Arabian Peninsula for centuries, though they could only travel on routes with sufficient sources of food and water. Camel trains were also used sparingly elsewhere around the globe but during the 20th century they have been largely replaced by motorized vehicles or air traffic.\n\n",
        "title": "Camel train"
    },
    "Caravel": {
        "image": "Caravel.jpg",
        "summary": "A caravel (Portuguese: caravela, IPA: [k\u0250\u027e\u0250\u02c8v\u025bl\u0250]) is a small, highly maneuverable sailing ship developed in the 15th century by the Portuguese to explore along the West African coast and into the Atlantic Ocean. The lateen sails gave it speed and the capacity for sailing windward (beating). Caravels were used by the Portuguese for the oceanic exploration voyages during the 15th and 16th centuries in the Age of Discovery. Prince Henry, Vasco da Gama, Christopher Columbus, and Bartolomeu Dias all used caravels.",
        "title": "Caravel"
    },
    "Carrier": {
        "image": "Aircraft carrier.jpg",
        "summary": "An aircraft carrier is a warship that serves as a seagoing airbase, equipped with a full-length flight deck and facilities for carrying, arming, deploying, and recovering aircraft. Typically, it is the capital ship of a fleet, as it allows a naval force to project air power worldwide without depending on local bases for staging aircraft operations. Aircraft carriers are expensive to build and are critical assets. Carriers have evolved since their inception in the early twentieth century from wooden vessels used to deploy balloons to nuclear-powered warships that carry numerous fighter planes, strike aircraft, helicopters, and other types of aircraft. While it is possible to launch heavier aircraft such as fixed-wing gunships and bombers (it has been done) from aircraft carriers, it is virtually impossible to land them.\nThere is no single definition of an \"aircraft carrier,\" and modern navies use several variants of the type. These variants are sometimes categorized as sub-types of aircraft carriers, and sometimes as distinct types of naval aviation-capable ships. Aircraft carriers may be classified according to the type of aircraft they carry and their operational assignments. Admiral Sir Mark Stanhope, RN former First Sea Lord (head) of the British Royal Navy, has said, \"To put it simply, countries that aspire to strategic international influence have aircraft carriers\".\nAs of November 2017, there are 41 active aircraft carriers in the world operated by thirteen navies. The United States Navy has 11 large nuclear-powered fleet carriers (known as supercarriers, carrying up to around 80 fighter jets each), the largest carriers in the world the total combined deckspace is over twice that of all other nations combined. As well as the fleet carrier / supercarrier fleet, the U.S. Navy has nine amphibious assault ships used primarily for helicopters, although these also carry up to 20 vertical or short take-off and landing (V/STOL) fighter jets and are similar in size to medium-sized fleet carriers. China, France, India and Russia each operate a single medium-size carrier, with capacity from 30 to 50 fighter jets. Italy operates two light fleet carriers and Spain operates one. Helicopter carriers are operated by Australia (2), Egypt (2), France (3), Japan (4), South Korea (1), Thailand (1) and the United Kingdom (1). The United Kingdom has a 280 m (920 ft) supercarrier, HMS Queen Elizabeth, undergoing sea trials, scheduled to enter active service in late 2017. Future supercarriers are under construction or in planning by China, India, Russia, the US, and the UK.",
        "title": "Aircraft carrier"
    },
    "Catapult": {
        "image": "Catapult.jpg",
        "summary": "A catapult is a ballistic device used to launch a projectile a great distance without the aid of explosive devices\u2014particularly various types of ancient and medieval siege engines. In use since ancient times, the catapult has proven to be one of the most effective mechanisms during warfare. In modern times the term can apply to devices ranging from a simple hand-held implement (also called a \u201cslingshot\u201d) to a mechanism for launching aircraft from a ship.",
        "title": "Catapult"
    },
    "Cathedral": {
        "image": "Cathedral.jpg",
        "summary": "A cathedral is a Christian church which contains the seat of a bishop, thus serving as the central church of a diocese, conference, or episcopate. The counterpart term for such a church in German is Dom from Latin domus ecclesiae or domus episcopalis also Italian Duomo, Dutch Domkerk and cognates in many other European languages. Churches with the function of \"cathedral\" are usually specific to those Christian denominations with an episcopal hierarchy, such as the Roman Catholic, Anglican, Orthodox, and some Lutheran and Methodist churches. Church buildings embodying the functions of a cathedral first appear in Italy, Gaul, Spain and North Africa in the 4th century, but cathedrals did not become universal within the Western Catholic Church until the 12th century, by which time they had developed architectural forms, institutional structures and legal identities distinct from parish churches, monastic churches and episcopal residences.\nIn respect of the church buildings in the Eastern Orthodox Church, the English word \"cathedral\" commonly translates katholikon (sobor in Slavic languages), meaning of \"assembly\" but this title is also applied to monastic and other major churches without episcopal responsibilities. When the church at which an archbishop or \"metropolitan\" presides is specifically intended, the term kathedrik\u00f3s na\u00f3s (literally: \"cathedral temple\") is used.\nFollowing the Protestant Reformation, the Christian church in several parts of Western Europe, such as Scotland, the Netherlands, certain Swiss Cantons and parts of Germany, adopted a Presbyterian polity that did away with bishops altogether. Where ancient cathedral buildings in these lands are still in use for congregational worship, they generally retain the title and dignity of \"cathedral\", maintaining and developing distinct cathedral functions, but void of hierarchical supremacy. From the 16th century onwards, but especially since the 19th century, churches originating in Western Europe have undertaken vigorous programmes of missionary activity, leading to the founding of large numbers of new dioceses with associated cathedral establishments of varying forms in Asia, Africa, Australasia, Oceania and the Americas. In addition, both the Catholic Church and Orthodox churches have formed new dioceses within formerly Protestant lands for converts and migrant co-religionists. Consequently, it is not uncommon to find Christians in a single city being served by three or more cathedrals of differing denominations.\nIn the Catholic tradition, the term \"cathedral\" correctly applies only to a church that houses the seat of the bishop of a diocese. The abbey church of a territorial abbacy serves the same function (that is, houses the seat of the abbot), but does not acquire the title. In any other jurisdiction canonically equivalent to a diocese but not canonically erected as such (prelature, vicariate, ordinariate, prefecture, apostolic administration), the church which serves this function is correctly called the \"principal church\" of the respective entity\u2014though some have coopted the term \"cathedral\" anyway. The Catholic Church also uses the following terms.\nA pro-cathedral is a parish or other church used temporarily as a cathedral, usually while the cathedral of a diocese is under construction, renovation, or repair. This designation applies only as long as the temporary use continues.\nA co-cathedral is a second cathedral in a diocese that has two sees. This situation can arise in various ways such as a merger of two former dioceses, preparation to split a diocese, or perceived need to perform cathedral functions in a second location due to the expanse of the diocesan territory.\nA proto-cathedral is the former cathedral of a transferred see.\nThe cathedral church of a metropolitan bishop is called the metropolitan cathedral.\nThe term \"cathedral\" actually carries no implication as to the size or ornateness of the building. Nevertheless, most cathedrals are particularly impressive edifices. Thus, the term \"cathedral\" is often applied colloquially to any large and impressive church, regardless of whether it functions as a cathedral, such as the Crystal Cathedral in California or the Arctic Cathedral in Troms\u00f8, Norway. Although the builders of Crystal Cathedral never intended the building to be a true cathedral, the Roman Catholic Diocese of Orange purchased the building and the surrounding campus in February 2012 for use as a new cathedral church. The building is now under renovation and restoration for solemn dedication under the title \"Christ Cathedral\" in 2018.",
        "title": "Cathedral"
    },
    "Cavalry": {
        "image": "Cavalry.jpg",
        "summary": "Cavalry (from French cavalerie, cf. cheval 'horse') or horsemen were soldiers or warriors who fought mounted on horseback. Cavalry were historically the most mobile of the combat arms. An individual soldier in the cavalry is known by a number of designations such as cavalryman, horseman, dragoon or trooper. The designation of cavalry was not usually given to any military forces that used other animals, such as camels, mules or elephants. Infantry who moved on horseback, but dismounted to fight on foot, were known in the 17th and early 18th centuries as dragoons, a class of mounted infantry which later evolved into cavalry proper while retaining their historic title.\nCavalry had the advantage of improved mobility, and a man fighting from horseback also had the advantages of greater height, speed, and inertial mass over an opponent on foot. Another element of horse mounted warfare is the psychological impact a mounted soldier can inflict on an opponent.\nThe speed, mobility and shock value of the cavalry was greatly appreciated and exploited in armed forces in the Ancient and Middle Ages some forces were mostly cavalry, particularly in nomadic societies of Asia, notably the Mongol armies. In Europe cavalry became increasingly armoured (heavy), and eventually became known for the mounted knights. During the 17th century cavalry in Europe lost most of its armor, ineffective against the muskets and cannon which were coming into use, and by the mid-19th century armor had mainly fallen into disuse, although some regiments retained a small thickened cuirass that offered protection against lances and sabres and some protection against shot.\nIn the period between the World Wars, many cavalry units were converted into motorized infantry and mechanized infantry units, or reformed as tank troops. However, some cavalry still served during World War II, notably in the Red Army, the Mongolian People's Army, the Royal Italian Army, the Romanian Army, the Polish Land Forces, and light reconnaissance units within the Waffen SS. Most cavalry units that are horse-mounted in modern armies serve in purely ceremonial roles, or as mounted infantry in difficult terrain such as mountains or heavily forested areas. Modern usage of the term generally refers to specialist units equipped with tanks (\"armored cavalry\") or aircraft (\"air cavalry\").",
        "title": "Cavalry"
    },
    "Ceremonial Burial": {
        "image": "Burial.jpg",
        "summary": "Burial or interment is the ritual act of placing a dead person or animal, sometimes with objects, into the ground. This is accomplished by excavating a pit or trench, placing the deceased and objects in it, and covering it over. Humans have been burying their dead for at least 100,000 years. Burial is often seen as indicating respect for the dead. It has been used to prevent the odor of decay, to give family members closure and prevent them from witnessing the decomposition of their loved ones, and in many cultures it has been seen as a necessary step for the deceased to enter the afterlife or to give back to the cycle of life.\nMethods of burial may be heavily ritualized and can include natural burial (sometimes called \"green burial\") embalming or mummification the use of containers for the dead such as shrouds, caskets, grave liners, and burial vaults all of which can retard decomposition of the body. Sometimes objects or grave goods are buried with the body, which may be dressed in fancy or ceremonial garb. Depending on the culture, the way the body is positioned may have great significance.\nThe location of the burial may be determined taking into account concerns surrounding health and sanitation, religious concerns, and cultural practices. Some cultures keep the dead close to provide guidance to the living, while others \"banish\" them by locating burial grounds at a distance from inhabited areas. Some religions consecrate special ground to bury the dead, and some families build private family cemeteries. Most modern cultures document the location of graves with headstones, which may be inscribed with information and tributes to the deceased. However, some people are buried in anonymous or secret graves for various reasons. Sometimes multiple bodies are buried in a single grave either by choice (as in the case of married couples), due to space concerns, or in the case of mass graves as a way to deal with many bodies at once.\nAlternatives to burial may include cremation, burial at sea, promession, cryopreservation, and others. Some human cultures may bury the remains of beloved animals. Humans are not the only species which bury their dead the practice has been observed in chimpanzees, elephants, and possibly dogs.",
        "title": "Burial"
    },
    "Chariot": {
        "image": "Chariot.jpg",
        "summary": "A chariot is a type of carriage driven by a charioteer using primarily horses to provide rapid motive power. Chariots were used by armies as transport or mobile archery platforms, for hunting or for racing, and as a conveniently fast way to travel for many ancient people.\nThe word \"chariot\" comes from the Latin carrus, itself a loanword from Gaulish. A chariot of war or one used in military parades was called a car. In ancient Rome and some other ancient Mediterranean civilizations, a biga required two horses, a triga three, and a quadriga four.\nThe horse chariot was a fast, light, open, two-wheeled conveyance drawn by two or more horses that were hitched side by side, and was little more than a floor with a waist-high guard at the front and sides. It was initially used for ancient warfare during the Bronze and Iron Ages but, after its military capabilities had been superseded by cavalry, as horses were gradually bred to be bigger, the chariot was used for travel, in processions, for games, and in races.\nThe critical invention that allowed the construction of light, horse-drawn chariots was the spoked wheel. The earliest spoke-wheeled chariots date to ca. 2000 BC. The use of chariots peaked around 1300 BC (see Battle of Kadesh). Chariots had lost their military importance by the 1st century AD, but chariot races continued to be popular in Constantinople until the 6th century.",
        "title": "Chariot"
    },
    "Chemistry": {
        "image": "Chemistry.jpg",
        "summary": "Chemistry is the scientific discipline involved with compounds composed of atoms, i.e. elements, and molecules, i.e. combinations of atoms: their composition, structure, properties, behavior and the changes they undergo during a reaction with other compounds. Chemistry addresses topics such as how atoms and molecules interact via chemical bonds to form new chemical compounds. There are four types of chemical bonds: covalent bonds, in which compounds share one or more electron(s) ionic bonds, in which a compound donates one or more electrons to another compound to produce ions: cations and anions hydrogen bonds and Van der Waals force bonds.\nChemistry occupies an intermediate position in a hierarchy of the sciences by reductive level between physics and biology. It is sometimes called the central science because it provides a foundation for understanding both basic and applied scientific disciplines at a fundamental level. Examples include plant chemistry (botany), the formation of igneous rocks (geology), how atmospheric ozone is formed and how environmental pollutants are degraded (ecology), the properties of the soil on the moon (astrophysics), how medications work (pharmacology), and how to collect DNA evidence at a crime scene (forensics).\nThe history of chemistry represents a time span from ancient history to the present. By 1000 BC, civilizations used technologies that would eventually form the basis of the various branches of chemistry. Examples include extracting metals from ores, making pottery and glazes, fermenting beer and wine, extracting chemicals from plants for medicine and perfume, rendering fat into soap, making glass, and making alloys like bronze. The protoscience of chemistry, alchemy, was unsuccessful in explaining the nature of matter and its transformations. However, by performing experiments and recording the results, alchemists set the stage for modern chemistry. The distinction began to emerge when a clear differentiation was made between chemistry and alchemy by Robert Boyle in his work The Sceptical Chymist (1661). While both alchemy and chemistry are concerned with matter and its transformations, chemists are seen as applying scientific method to their work. Chemistry is considered to have become an established science with the work of Antoine Lavoisier, who developed a law of conservation of mass that demanded careful measurement and quantitative observations of chemical phenomena. The history of chemistry is intertwined with the history of thermodynamics, especially through the work of Willard Gibbs. Chemistry was preceded by its protoscience, alchemy, which is an intuitive but non-scientific approach to understanding the elements, compounds, and their interactions. It was unsuccessful in explaining the nature of matter and its transformations, but by performing experiments and recording the results, alchemists set the stage for modern chemistry. The distinction began to emerge when a clear differentiation between alchemy and chemistry was made by Robert Boyle in 1661: the application of the scientific method in chemistry was the crucial difference.",
        "title": "Chemistry"
    },
    "Chivalry": {
        "image": "Chivalry.jpg",
        "summary": "Chivalry, or the chivalric code, is an informal, varying code of conduct developed between 1170 and 1220, never decided on or summarized in a single document, associated with the medieval institution of knighthood knights\u2019 and gentlewomen's behaviors were governed by chivalrous social codes. The ideals of chivalry were popularized in medieval literature, especially the Matter of Britain and Matter of France, the former based on Geoffrey of Monmouth's Historia Regum Britanniae which introduced the legend of King Arthur, written in the 1130s.\nThe code of chivalry that developed in medieval Europe had its roots in earlier centuries. It arose in the Holy Roman Empire from the idealisation of the cavalryman\u2014involving military bravery, individual training, and service to others\u2014especially in Francia, among horse soldiers in Charlemagne's cavalry. The term \"chivalry\" derives from the Old French term chevalerie, which can be translated to \"horse soldiery\". Gautier states that knighthood emerged from the Moors (Muslims) as well as the Teutonic forests and was nurtured into civilisation and chivalry by the Catholic Church.\nOver time, its meaning in Europe has been refined to emphasise social and moral virtues more generally. The code of chivalry, as it stood by the Late Middle Ages, was a moral system which combined a warrior ethos, knightly piety, and courtly manners, all conspiring to establish a notion of honour and nobility.",
        "title": "Chivalry"
    },
    "City Walls": {
        "image": "Defensive wall.jpg",
        "summary": "A defensive wall is a fortification usually used to protect a city, town or other settlement from potential aggressors. In ancient to modern times, they were used to enclose settlements. Generally, these are referred to as city walls or town walls, although there were also walls, such as the Great Wall of China, Walls of Benin, Hadrian's Wall, Anastasian Wall, the Cyclopean Wall Rajgir and the metaphorical Atlantic Wall, which extended far beyond the borders of a city and were used to enclose regions or mark territorial boundaries. In mountainous terrain, defensive walls such as letzis were used in combination with castles to seal valleys from potential attack. Beyond their defensive utility, many walls also had important symbolic functions \u2013  representing the status and independence of the communities they embraced.\nExisting ancient walls are almost always masonry structures, although brick and timber-built variants are also known. Depending on the topography of the area surrounding the city or the settlement the wall is intended to protect, elements of the terrain such as rivers or coastlines may be incorporated in order to make the wall more effective.\nWalls may only be crossed by entering the appropriate city gate and are often supplemented with towers. The practice of building these massive walls, though having its origins in prehistory, was refined during the rise of city-states, and energetic wall-building continued into the medieval period and beyond in certain parts of Europe.\nSimpler defensive walls of earth or stone, thrown up around hillforts, ringworks, early castles and the like, tend to be referred to as ramparts or banks.\n\n",
        "title": "Defensive wall"
    },
    "Coastal Defense": {
        "image": "Coastal defence and fortification.jpg",
        "summary": "Coastal defence (or defense) and coastal fortification are measures taken to provide protection against military attack at or near a coastline (or other shoreline), for example, fortification and coastal artillery. Because an invading enemy normally requires a port or harbour to sustain operations, such defences are usually concentrated around such facilities, or places where such facilities could be constructed.\nIn littoral warfare, coastal defence counteracts naval offence, such as naval artillery, naval infantry (marines), or both.",
        "title": "Coastal defence and fortification"
    },
    "Code of Laws": {
        "image": "Code of law.jpg",
        "summary": "A code of law, also called a law code or legal code, is a type of legislation that purports to exhaustively cover a complete system of laws or a particular area of law as it existed at the time the code was enacted, by a process of codification. Though the process and motivations for codification are similar in different common law and civil law systems, their usage is different.\nIn a civil law country, a code of law typically exhaustively covers the complete system of law, such as civil law or criminal law. By contrast, in a common law country with legislative practices in the English tradition, a code of law is a less common form of legislation, which differs from usual legislation that, when enacted, modify the existing common law only to the extent of its express or implicit provision, but otherwise leaves the common law intact. A code entirely replaces the common law in a particular area, leaving the common law inoperative unless and until the code is repealed. In a third case of slightly different usage, in the United States and other common law countries that have adopted similar legislative practices, a code of law is a standing body of statute law on a particular area, which is added to, subtracted from, or otherwise modified by individual legislative enactments.",
        "title": "Code of law"
    },
    "Coinage": {
        "image": "Coining (mint).jpg",
        "summary": "In minting, coining or coinage is the process of manufacturing coins using a kind of stamping which is now generically known in metalworking as \"coining\". This process is different from cast coinage, and can be classified in hammered coinage or hammering and milled coinage or milling.\nA coin die is one of the two metallic pieces that are used to strike a coin, one per each side of the coin. A die contains an inverse version of the image to be struck on the coin. Striking a coin refers to pressing an image into the blank metal disc, or planchet, and is a term descended from the days when the dies were struck with hammers to deform the metal into the image of the dies.\nModern dies made out of hardened steel are capable of producing many hundreds of thousands of coins before they are retired and defaced.\n\n",
        "title": "Coining (mint)"
    },
    "Colosseum": {
        "image": "Colosseum.jpg",
        "summary": "The Colosseum or Coliseum ( kol-\u0259-SEE-\u0259m), also known as the Flavian Amphitheatre (Latin: Amphitheatrum Flavium Italian: Anfiteatro Flavio [a\u014bfite\u02c8a\u02d0tro \u02c8fla\u02d0vjo] or Colosseo [kolos\u02c8s\u025b\u02d0o]), is an oval amphitheatre in the centre of the city of Rome, Italy. Built of concrete and sand, it is the largest amphitheatre ever built. The Colosseum is situated just east of the Roman Forum. Construction began under the emperor Vespasian in AD 72, and was completed in AD 80 under his successor and heir Titus. Further modifications were made during the reign of Domitian (81\u201396). These three emperors are known as the Flavian dynasty, and the amphitheatre was named in Latin for its association with their family name (Flavius).\nThe Colosseum could hold, it is estimated, between 50,000 and 80,000 spectators, having an average audience of some 65,000 it was used for gladiatorial contests and public spectacles such as mock sea battles (for only a short time as the hypogeum was soon filled in with mechanisms to support the other activities), animal hunts, executions, re-enactments of famous battles, and dramas based on Classical mythology. The building ceased to be used for entertainment in the early medieval era. It was later reused for such purposes as housing, workshops, quarters for a religious order, a fortress, a quarry, and a Christian shrine.\nAlthough partially ruined because of damage caused by earthquakes and stone-robbers, the Colosseum is still an iconic symbol of Imperial Rome. It is one of Rome's most popular tourist attractions and also has links to the Roman Catholic Church, as each Good Friday the Pope leads a torchlit \"Way of the Cross\" procession that starts in the area around the Colosseum.\nThe Colosseum is also depicted on the Italian version of the five-cent euro coin.\n\nThe Colosseum's original Latin name was Amphitheatrum Flavium, often anglicized as Flavian Amphitheatre. The building was constructed by emperors of the Flavian dynasty, following the reign of Nero. This name is still used in modern English, but generally the structure is better known as the Colosseum. In antiquity, Romans may have referred to the Colosseum by the unofficial name Amphitheatrum Caesareum (with Caesareum an adjective pertaining to the title Caesar), but this name may have been strictly poetic as it was not exclusive to the Colosseum Vespasian and Titus, builders of the Colosseum, also constructed an amphitheater of the same name in Puteoli (modern Pozzuoli).\nThe name Colosseum has long been believed to be derived from a colossal statue of Nero nearby (the statue of Nero was named after the Colossus of Rhodes). This statue was later remodeled by Nero's successors into the likeness of Helios (Sol) or Apollo, the sun god, by adding the appropriate solar crown. Nero's head was also replaced several times with the heads of succeeding emperors. Despite its pagan links, the statue remained standing well into the medieval era and was credited with magical powers. It came to be seen as an iconic symbol of the permanence of Rome.\nIn the 8th century, a famous epigram attributed to the Venerable Bede celebrated the symbolic significance of the statue in a prophecy that is variously quoted: Quamdiu stat Colis\u00e6us, stat et Roma quando cadet colis\u00e6us, cadet et Roma quando cadet Roma, cadet et mundus (\"as long as the Colossus stands, so shall Rome when the Colossus falls, Rome shall fall when Rome falls, so falls the world\"). This is often mistranslated to refer to the Colosseum rather than the Colossus (as in, for instance, Byron's poem Childe Harold's Pilgrimage). However, at the time that the Pseudo-Bede wrote, the masculine noun coliseus was applied to the statue rather than to what was still known as the Flavian amphitheatre.\nThe Colossus did eventually fall, possibly being pulled down to reuse its bronze. By the year 1000 the name \"Colosseum\" had been coined to refer to the amphitheatre. The statue itself was largely forgotten and only its base survives, situated between the Colosseum and the nearby Temple of Venus and Roma.\nThe name further evolved to Coliseum during the Middle Ages. In Italy, the amphitheatre is still known as il Colosseo, and other Romance languages have come to use similar forms such as Coloseumul (Romanian), le Colis\u00e9e (French), el Coliseo (Spanish) and o Coliseu (Portuguese).",
        "title": "Colosseum"
    },
    "Colossus": {
        "image": "Colossus of Rhodes.jpg",
        "summary": "The Colossus of Rhodes  (Ancient Greek: \u1f41 \u039a\u03bf\u03bb\u03bf\u03c3\u03c3\u1f78\u03c2 \u1fec\u03cc\u03b4\u03b9\u03bf\u03c2, translit. ho Koloss\u00f2s Rh\u00f3dios) was a statue of the Greek titan-god of the sun Helios, erected in the city of Rhodes, on the Greek island of the same name, by Chares of Lindos in 280 BC. One of the Seven Wonders of the Ancient World, it was constructed to celebrate Rhodes' victory over the ruler of Cyprus, Antigonus I Monophthalmus, whose son unsuccessfully besieged Rhodes in 305 BC. According to most contemporary descriptions, the Colossus stood approximately 70 cubits, or 33 metres (108 feet) high\u2014the approximate height of the modern Statue of Liberty from feet to crown\u2014making it the tallest statue of the ancient world. It was destroyed during the earthquake of 226 BC, and never rebuilt.\nAs of 2015, there are tentative plans to build a new Colossus at Rhodes Harbour, although the actual location of the original remains in dispute.",
        "title": "Colossus of Rhodes"
    },
    "Combined Arms": {
        "image": "Combined arms.jpg",
        "summary": "Combined arms is an approach to warfare which seeks to integrate different combat arms of a military to achieve mutually complementary effects (for example, using infantry and armor in an urban environment, where one supports the other, or both support each other). According to strategist William S. Lind, combined arms can be distinguished from the concept of \"supporting arms\" as follows:\n\nCombined arms hits the enemy with two or more arms simultaneously in such a manner that the actions he must take to defend himself from one make him more vulnerable to another. In contrast, supporting arms is hitting the enemy with two or more arms in sequence, or if simultaneously, then in such combination that the actions the enemy must take to defend himself from one also defends himself from the other(s).\n\nThough the lower-echelon units of a combined arms team may be of similar types, a balanced mixture of such units are combined into an effective higher-echelon unit, whether formally in a table of organization or informally in an ad hoc solution to a battlefield problem. For example, an armored division\u2014the modern paragon of combined arms doctrine\u2014consists of a mixture of infantry, tank, artillery, reconnaissance, and perhaps even helicopter units, all coordinated and directed by a unified command structure.\nAlso, most modern military units can, if the situation requires it, call on yet more branches of the military, such as fighter or bomber aircraft or naval forces, to support their operations. The mixing of arms is sometimes pushed down below the level where homogeneity ordinarily prevails, for example by temporarily attaching a tank company to an infantry battalion.",
        "title": "Combined arms"
    },
    "Combustion": {
        "image": "Combustion.jpg",
        "summary": "Combustion  or burning is a high-temperature exothermic redox chemical reaction between a fuel (the reductant) and an oxidant, usually atmospheric oxygen, that produces oxidized, often gaseous products, in a mixture termed as smoke. Combustion in a fire produces a flame, and the heat produced can make combustion self-sustaining. Combustion is often a complicated sequence of elementary radical reactions. Solid fuels, such as wood and coal, first undergo endothermic pyrolysis to produce gaseous fuels whose combustion then supplies the heat required to produce more of them. Combustion is often hot enough that light in the form of either glowing or a flame is produced. A simple example can be seen in the combustion of hydrogen and oxygen into water vapor, a reaction commonly used to fuel rocket engines. This reaction releases 242 kJ/mol of heat and reduces the enthalpy accordingly (at constant temperature and pressure):\n:2H\n2(g) + O\n2(g) \u2192 2H\n2O(g)\nCombustion of an organic fuel in air is always exothermic because the double bond in O2 is much weaker than other double bonds or pairs of single bonds, and therefore the formation of the stronger bonds in the combustion products CO2 and H2O results in the release of energy. The bond energies in the fuel play only a minor role, since they are similar to those in the combustion products e.g., the sum of the bond energies of CH4 is nearly the same as that of CO2. The heat of combustion is approximately -418 kJ per mole of O2 used up in the combustion reaction, and can be estimated from the elemental composition of the fuel.\nUncatalyzed combustion in air requires fairly high temperatures. Complete combustion is stoichiometric with respect to the fuel, where there is no remaining fuel, and ideally, no remaining oxidant. Thermodynamically, the chemical equilibrium of combustion in air is overwhelmingly on the side of the products. However, complete combustion is almost impossible to achieve, since the chemical equilibrium is not necessarily reached, or may contain unburnt products such as carbon monoxide, hydrogen and even carbon (soot or ash). Thus, the produced smoke is usually toxic and contains unburned or partially oxidized products. Any combustion at high temperatures in atmospheric air, which is 78 percent nitrogen, will also create small amounts of several nitrogen oxides, commonly referred to as NOx, since the combustion of nitrogen is thermodynamically favored at high, but not low temperatures. Since combustion is rarely clean, flue gas cleaning or catalytic converters may be required by law.\nFires occur naturally, ignited by lightning strikes or by volcanic products. Combustion (fire) was the first controlled chemical reaction discovered by humans, in the form of campfires and bonfires, and continues to be the main method to produce energy for humanity. Usually, the fuel is carbon, hydrocarbons or more complicated mixtures such as wood that contains partially oxidized hydrocarbons. The thermal energy produced from combustion of either fossil fuels such as coal or oil, or from renewable fuels such as firewood, is harvested for diverse uses such as cooking, production of electricity or industrial or domestic heating. Combustion is also currently the only reaction used to power rockets. Combustion is also used to destroy (incinerate) waste, both nonhazardous and hazardous.\nOxidants for combustion have high oxidation potential and include atmospheric or pure oxygen, chlorine, fluorine, chlorine trifluoride, nitrous oxide and nitric acid. For instance, hydrogen burns in chlorine to form hydrogen chloride with the liberation of heat and light characteristic of combustion. Although usually not catalyzed, combustion can be catalyzed by platinum or vanadium, as in the contact process.",
        "title": "Combustion"
    },
    "Communism": {
        "image": "Communism.jpg",
        "summary": "In political and social sciences, communism (from Latin communis, \"common, universal\") is the philosophical, social, political and economic ideology and movement whose ultimate goal is the establishment of the communist society, which is a socioeconomic order structured upon the common ownership of the means of production and the absence of social classes, money and the state.\nOpposed to liberalism, nationalism, capitalism, and populism, communism is usually placed on the far-left within the traditional left\u2013right spectrum. Communism includes a variety of schools of thought, which broadly include Marxism, anarchism (anarchist communism) and the political ideologies grouped around both. All of these share the analysis that the current order of society stems from its economic system, capitalism that in this system there are two major social classes: the working class\u2014who must work to survive and who make up the majority within society\u2014and the capitalist class\u2014a minority who derives profit from employing the working class, through private ownership of the means of production\u2014and that conflict between these two classes will trigger a revolution. The revolution will in turn establish social ownership of the means of production, which according to this analysis is the primary element in the transformation of society towards communism.\nCriticism of communism can be roughly divided into those concerning themselves with the practical aspects of 20th century communist states and those concerning themselves with communist principles and theory.\n\n",
        "title": "Communism"
    },
    "Computers": {
        "image": "Computer.jpg",
        "summary": "A computer is a device that can be instructed to carry out arbitrary sequences of arithmetic or logical operations automatically. The ability of computers to follow generalized sets of operations, called programs, enables them to perform an extremely wide range of tasks.\nSuch computers are used as control systems for a very wide variety of industrial and consumer devices. This includes simple special purpose devices like microwave ovens and remote controls, factory devices such as industrial robots and computer assisted design, but also in general purpose devices like personal computers and mobile devices such as smartphones. The Internet is run on computers and it connects millions of other computers.\nSince ancient times, simple manual devices like the abacus aided people in doing calculations. Early in the Industrial Revolution, some mechanical devices were built to automate long tedious tasks, such as guiding patterns for looms. More sophisticated electrical machines did specialized analog calculations in the early 20th century. The first digital electronic calculating machines were developed during World War II. The speed, power, and versatility of computers has increased continuously and dramatically since then.\nConventionally, a modern computer consists of at least one processing element, typically a central processing unit (CPU), and some form of memory. The processing element carries out arithmetic and logical operations, and a sequencing and control unit can change the order of operations in response to stored information. Peripheral devices include input devices (keyboards, mice, joystick, etc.), output devices (monitor screens, printers, etc.), and input/output devices that perform both functions (e.g., the 2000s-era touchscreen). Peripheral devices allow information to be retrieved from an external source and they enable the result of operations to be saved and retrieved.",
        "title": "Computer"
    },
    "Conscription": {
        "image": "Conscription.jpg",
        "summary": "Conscription, or drafting, is the compulsory enlistment of people in a national service, most often a military service. Conscription dates back to antiquity and continues in some countries to the present day under various names. The modern system of near-universal national conscription for young men dates to the French Revolution in the 1790s, where it became the basis of a very large and powerful military. Most European nations later copied the system in peacetime, so that men at a certain age would serve 1\u20138 years on active duty and then transfer to the reserve force.\nConscription is controversial for a range of reasons, including conscientious objection to military engagements on religious or philosophical grounds political objection, for example to service for a disliked government or unpopular war and ideological objection, for example, to a perceived violation of individual rights. Those conscripted may evade service, sometimes by leaving the country, and seeking asylum in another country. Some selection systems accommodate these attitudes by providing alternative service outside combat-operations roles or even outside the military, such as 'Siviilipalvelus' (alternative civil service) in Finland, Zivildienst (compulsory community service) in Austria and Switzerland. Most post-Soviet countries conscript soldiers not only for armed forces but also for paramilitary organizations which are dedicated to police-like domestic only service (Internal Troops) or non-combat rescue duties (Civil defence troops) \u2013 none of which is considered alternative to the military conscription.\nAs of the early 21st century, many states no longer conscript soldiers, relying instead upon professional militaries with volunteers enlisted to meet the demand for troops. The ability to rely on such an arrangement, however, presupposes some degree of predictability with regard to both war-fighting requirements and the scope of hostilities. Many states that have abolished conscription therefore still reserve the power to resume it during wartime or times of crisis. States involved in wars or interstate rivalries are most likely to implement conscription, whereas democracies are less likely than autocracies to implement conscription. Former British colonies are less likely to have conscription, as they are influenced by British anticonscription norms that can be traced back to the English Civil War.",
        "title": "Conscription"
    },
    "Construction": {
        "image": "Construction.jpg",
        "summary": "Construction is the process of constructing a building or infrastructure. Construction differs from manufacturing in that manufacturing typically involves mass production of similar items without a designated purchaser, while construction typically takes place on location for a known client. Construction as an industry comprises six to nine percent of the gross domestic product of developed countries. Construction starts with planning, design, and financing and continues until the project is built and ready for use.\nLarge-scale construction requires collaboration across multiple disciplines. An architect normally manages the job, and a construction manager, design engineer, construction engineer or project manager supervises it. Those involved with the design and execution must consider zoning requirements, environmental impact of the job, scheduling, budgeting, construction-site safety, availability and transportation of building materials, logistics, inconvenience to the public caused by construction delays and bidding. Large construction projects are sometimes referred to as megaprojects.",
        "title": "Construction"
    },
    "Copernicus' Observatory": {
        "image": "Space telescope.jpg",
        "summary": "A space telescope or space observatory is an instrument located in outer space to observe distant planets, galaxies and other astronomical objects. Space telescopes avoid many of the problems of ground-based observatories, such as light pollution and distortion of electromagnetic radiation (scintillation). In addition, ultraviolet frequencies, X-rays and gamma rays are blocked by the Earth's atmosphere, so they can only be observed from space.\nTheorized by Lyman Spitzer in 1946, the first operational space telescopes were the American Orbiting Astronomical Observatory OAO-2 launched in 1968 and the Soviet Orion 1 ultraviolet telescope aboard space station Salyut 1 in 1971.\nSpace telescopes are distinct from other imaging satellites pointed toward Earth for purposes of espionage, weather analysis and other types of information gathering.",
        "title": "Space telescope"
    },
    "Courthouse": {
        "image": "Courthouse.jpg",
        "summary": "A courthouse (sometimes spelled court house) is a building that is home to a local court of law and often the regional county government as well, although this is not the case in some larger cities. The term is common in North America. In most other English-speaking countries, buildings which house courts of law are simply called \"courts\" or \"court buildings\". In most of Continental Europe and former non-English-speaking European colonies, the equivalent term is a palace of justice (French: palais de justice, Italian: palazzo di giustizia, Portuguese: pal\u00e1cio da justi\u00e7a).",
        "title": "Courthouse"
    },
    "Cruise Missile": {
        "image": "Cruise missile.jpg",
        "summary": "A cruise missile is a guided missile used against terrestrial targets that remains in the atmosphere and flies the major portion of its flight path at approximately constant speed. Cruise missiles are designed to deliver a large warhead over long distances with high precision. Modern cruise missiles are capable of travelling at supersonic or high subsonic speeds, are self-navigating, and are able to fly on a non-ballistic, extremely low-altitude trajectory.",
        "title": "Cruise missile"
    },
    "Cruiser": {
        "image": "Cruiser.jpg",
        "summary": "A cruiser is a type of warship. The term has been in use for several hundred years, and has had different meanings throughout this period. During the Age of Sail, the term cruising referred to certain kinds of missions \u2013 independent scouting, commerce protection, or raiding \u2013 fulfilled by a frigate or sloop, which were the cruising warships of a fleet. Modern cruisers are generally the largest ships in a fleet after aircraft carriers, and can usually perform several roles.\nIn the middle of the 19th century, cruiser came to be a classification for the ships intended for cruising distant waters, commerce raiding, and scouting for the battle fleet. Cruisers came in a wide variety of sizes, from the medium-sized protected cruiser to large armored cruisers that were nearly as big (although not as powerful or as well-armored) as a pre-dreadnought battleship. With the advent of the dreadnought battleship before World War I, the armored cruiser evolved into a vessel of similar scale known as the battlecruiser. The very large battlecruisers of the World War I era that succeeded armored cruisers were now classified, along with dreadnought battleships, as capital ships.\nBy the early 20th century after World War I, the direct successors to protected cruisers could be placed on a consistent scale of warship size, smaller than a battleship but larger than a destroyer. In 1922, the Washington Naval Treaty placed a formal limit on these cruisers, which were defined as warships of up to 10,000 tons displacement carrying guns no larger than 8 inches in calibre heavy cruisers had 8-inch guns, while those with guns of 6.1 inches or less were light cruisers, which shaped cruiser design until the end of World War II. Some variations on the Treaty cruiser design included the German Deutschland-class \"pocket battleships\" which had heavier armament at the expense of speed compared to standard heavy cruisers, and the US Alaska class, which was a scaled-up heavy cruiser design designated as a \"cruiser-killer\".\nIn the later 20th century, the obsolescence of the battleship left the cruiser as the largest and most powerful surface combatant after the aircraft carrier. The role of the cruiser varied according to ship and navy, often including air defense and shore bombardment. During the Cold War, the Soviet Navy's cruisers had heavy anti-ship missile armament designed to sink NATO carrier task forces via saturation attack. The U.S. Navy built guided-missile cruisers upon destroyer-style hulls (some called \"destroyer leaders\" or \"frigates\" prior to the 1975 reclassification) primarily designed to provide air defense while often adding anti-submarine capabilities, being larger and having longer-range surface-to-air missiles (SAMs) than early Charles F. Adams guided-missile destroyers tasked with the short-range air defense role. By the end of the Cold War, the line between cruisers and destroyers had blurred, with the Ticonderoga-class cruiser using the hull of the Spruance-class destroyer but receiving the cruiser designation due to their enhanced mission and combat systems. Indeed, the newest U.S. Navy destroyers (for instance the Arleigh Burke class and Zumwalt class) are more heavily armed than some of the cruisers that they succeeded.\nCurrently only two nations operate cruisers: the United States and Russia. (BAP Almirante Grau was still in service with the Peruvian Navy until 2017, and was the last gun cruiser currently in service in any navy.)",
        "title": "Cruiser"
    },
    "Cure For Cancer": {
        "image": "Cancer research.jpg",
        "summary": "Cancer research is basic research into cancer to identify causes and develop strategies for prevention, diagnosis, treatment, and cure.\nCancer research ranges from epidemiology, molecular bioscience to the performance of clinical trials to evaluate and compare applications of the various cancer treatments. These applications include surgery, radiation therapy, chemotherapy, hormone therapy, immunotherapy and combined treatment modalities such as chemo-radiotherapy. Starting in the mid-1990s, the emphasis in clinical cancer research shifted towards therapies derived from biotechnology research, such as cancer immunotherapy and gene therapy.",
        "title": "Cancer research"
    },
    "Currency": {
        "image": "Currency.jpg",
        "summary": "A currency (from Middle English: curraunt, \"in circulation\", from Latin: currens, -entis), in the most specific use of the word, refers to money in any form when in actual use or circulation as a medium of exchange, especially circulating banknotes and coins. A more general definition is that a currency is a system of money (monetary units) in common use, especially in a nation. Under this definition, US dollars, British pounds, Australian dollars, and European euros are examples of currency. These various currencies are recognized stores of value and are traded between nations in foreign exchange markets, which determine the relative values of the different currencies. Currencies in this sense are defined by governments, and each type has limited boundaries of acceptance.\nOther definitions of the term \"currency\" are discussed in their respective synonymous articles banknote, coin, and money. The latter definition, pertaining to the currency systems of nations, is the topic of this article. Currencies can be classified into two monetary systems: fiat money and commodity money, depending on what guarantees the value (the economy at large vs. the government's physical metal reserves). Some currencies are legal tender in certain political jurisdictions, which means they cannot be refused as payment for debt. Others are simply traded for their economic value. Digital currency has arisen with the popularity of computers and the Internet.",
        "title": "Currency"
    },
    "Darwin's Voyage": {
        "image": "Second voyage of HMS Beagle.jpg",
        "summary": "The second voyage of HMS Beagle, from 27 December 1831 to 2 October 1836, was the second survey expedition of HMS Beagle, under captain Robert FitzRoy who had taken over command of the ship on its first voyage after the previous captain committed suicide. FitzRoy had already thought of the advantages of having an expert in geology on board, and sought a gentleman naturalist to accompany them as a supernumerary. The young graduate Charles Darwin had hoped to see the tropics before becoming a parson, and accepted the opportunity. He was greatly influenced by reading Charles Lyell's Principles of Geology during the voyage. By the end of the expedition, Darwin had already made his name as a geologist and fossil collector, and the publication of his journal which became known as The Voyage of the Beagle gave him wide renown as a writer.\nThe Beagle sailed across the Atlantic Ocean, and then carried out detailed hydrographic surveys around the coasts of the southern part of South America, returning via Tahiti and Australia after having circumnavigated the Earth. While the expedition was originally planned to last two years, it lasted almost five.\nDarwin spent most of this time exploring on land: three years and three months on land, 18 months at sea. Early in the voyage he decided that he could write a book about geology, and he showed a gift for theorising. At Punta Alta he made a major find of gigantic fossils of extinct mammals, then known from only a very few specimens. He ably collected and made detailed observations of plants and animals, with results that shook his belief that species were fixed and provided the basis for ideas which came to him when back in England, and led to his theory of evolution by natural selection.",
        "title": "Second voyage of HMS Beagle"
    },
    "Democracy": {
        "image": "Democracy.jpg",
        "summary": "Democracy (Greek: \u03b4\u03b7\u03bc\u03bf\u03ba\u03c1\u03b1\u03c4\u03af\u03b1 d\u0113mokrat\u00eda, literally \"rule of the people\"), in modern usage, is a system of government in which the citizens exercise power directly or elect representatives from among themselves to form a governing body, such as a parliament. Democracy is sometimes referred to as \"rule of the majority\". Democracy is a system of processing conflicts in which outcomes depend on what participants do, but no single force controls what occurs and its outcomes.\nThe uncertainty of outcomes is inherent in democracy, which makes all forces struggle repeatedly for the realization of their interests, being the devolution of power from a group of people to a set of rules. Western democracy, as distinct from that which existed in pre-modern societies, is generally considered to have originated in city states such as Classical Athens and the Roman Republic, where various schemes and degrees of enfranchisement of the free male population were observed before the form disappeared in the West at the beginning of late antiquity. The English word dates to the 16th century, from the older Middle French and Middle Latin equivalents.\nAccording to political scientist Larry Diamond, democracy consists of four key elements: (a) A political system for choosing and replacing the government through free and fair elections (b) The active participation of the people, as citizens, in politics and civic life (c) Protection of the human rights of all citizens, and (d) A rule of law, in which the laws and procedures apply equally to all citizens.\nThe term appeared in the 5th century BC, to denote the political systems then existing in Greek city-states, notably Athens, to mean \"rule of the people\", in contrast to aristocracy (\u1f00\u03c1\u03b9\u03c3\u03c4\u03bf\u03ba\u03c1\u03b1\u03c4\u03af\u03b1, aristokrat\u00eda), meaning \"rule of an elite\". While theoretically these definitions are in opposition, in practice the distinction has been blurred historically. The political system of Classical Athens, for example, granted democratic citizenship to free men and excluded slaves and women from political participation. In 1906, Finland became the first government to herald a more inclusive democracy at the national level. In virtually all democratic governments throughout ancient and modern history, democratic citizenship consisted of an elite class until full enfranchisement was won for all adult citizens in most modern democracies through the suffrage movements of the 19th and 20th centuries.\nDemocracy contrasts with forms of government where power is either held by an individual, as in an absolute monarchy, or where power is held by a small number of individuals, as in an oligarchy. Nevertheless, these oppositions, inherited from Greek philosophy, are now ambiguous because contemporary governments have mixed democratic, oligarchic, and monarchic elements. Karl Popper defined democracy in contrast to dictatorship or tyranny, thus focusing on opportunities for the people to control their leaders and to oust them without the need for a revolution.",
        "title": "Democracy"
    },
    "Despotism": {
        "image": "Despotism.jpg",
        "summary": "Despotism is a form of government in which a single entity rules with absolute power. Normally, that entity is an individual, the despot, as in an autocracy, but societies which limit respect and power to specific groups have also been called despotic.\nColloquially, the word despot applies pejoratively to those who abuse their power and authority to oppress their populace, subjects, or subordinates. More specifically, the term often applies to a head of state or government. In this sense, it is similar to the pejorative connotations that are associated with the terms tyrant and Dictator.",
        "title": "Despotism"
    },
    "Destroyer": {
        "image": "Destroyer.jpg",
        "summary": "In naval terminology, a destroyer is a fast, maneuverable long-endurance warship intended to escort larger vessels in a fleet, convoy or battle group and defend them against smaller powerful short-range attackers. They were originally developed in the late 19th century as a defence against torpedo boats, and by the time of the Russo-Japanese War in 1904, these \"torpedo boat destroyers\" (TBDs) were \"large, swift, and powerfully armed torpedo boats designed to destroy other torpedo boats.\" Although the term \"destroyer\" had been used interchangeably with \"TBD\" and \"torpedo boat destroyer\" by navies since 1892, the term \"torpedo boat destroyer\" had been generally shortened to simply \"destroyer\" by nearly all navies by the First World War.\nBefore World War II, destroyers were light vessels with little endurance for unattended ocean operations typically a number of destroyers and a single destroyer tender operated together. After the war, the advent of the guided missile allowed destroyers to take on the surface combatant roles previously filled by battleships and cruisers. This resulted in larger and more powerful guided missile destroyers more capable of independent operation.\nAt the start of the 21st century, destroyers are the global standard for surface combatant ships, with only two nations (United States and Russia) operating the heavier class cruisers, with no battleships or true battlecruisers remaining. Modern destroyers, also known as guided missile destroyers, are equivalent in tonnage but vastly superior in firepower to cruisers of the World War II era, and are capable of carrying nuclear tipped cruise missiles. At 510 feet (160 m) long, a displacement of 9200 tons, and with armament of more than 90 missiles, guided missile destroyers such as the Arleigh Burke class are actually larger and more heavily armed than most previous ships classified as guided missile cruisers.\nSome European navies such as the French, Spanish or German ones use the term \"frigate\" for their destroyers, which may lead to some confusion.",
        "title": "Destroyer"
    },
    "Diplomat": {
        "image": "Diplomat.jpg",
        "summary": "A diplomat is a person appointed by a state to conduct diplomacy with one or more other states or international organisations. The main functions of diplomats are: representation and protection of the interests and nationals of the sending state initiation and facilitation of strategic agreements treaties and conventions promotion of information trade and commerce technology and friendly relations. Seasoned diplomats of international repute are used in international organisations (e.g. United Nations) as well as multinational companies for their experience in management and negotiating skills. Diplomats are members of foreign services and diplomatic corps of various nations of the world.\nDiplomats are the oldest form of any of the foreign policy institutions of the state, predating by centuries foreign ministers and ministerial offices. They usually have diplomatic immunity.",
        "title": "Diplomat"
    },
    "Dragoons": {
        "image": "Dragoon.jpg",
        "summary": "Dragoons originally referred to a class of mounted infantry, who used horses for mobility but dismounted to fight on foot. From the early 18th century onward, dragoons were increasingly employed as conventional light or medium cavalry, trained for combat with swords from horseback.\nDragoon regiments were established in most European armies during the late 17th and early 18th centuries.\nThe name is derived from a type of firearm, called a \"dragon\", which was a handgun version of a blunderbuss, carried by dragoons of the French Army.\nThe title has been retained in modern times by a number of armoured or ceremonial mounted regiments.",
        "title": "Dragoon"
    },
    "Economics": {
        "image": "Economics.jpg",
        "summary": "Economics (UK English: ,  US English: , ) is \"a social science concerned chiefly with description and analysis of the production, distribution, and consumption of goods and services\".\nEconomics focuses on the behaviour and interactions of economic agents and how economies work. Microeconomics analyzes basic elements in the economy, including individual agents and markets, their interactions, and the outcomes of interactions. Individual agents may include, for example, households, firms, buyers, and sellers. Macroeconomics analyzes the entire economy (meaning aggregated production, consumption, savings, and investment) and issues affecting it, including unemployment of resources (labour, capital, and land), inflation, economic growth, and the public policies that address these issues (monetary, fiscal, and other policies).\nOther broad distinctions within economics include those between positive economics, describing \"what is\", and normative economics, advocating \"what ought to be\" between economic theory and applied economics between rational and behavioural economics and between mainstream economics and heterodox economics.",
        "title": "Economics"
    },
    "Eiffel Tower": {
        "image": "Eiffel Tower.jpg",
        "summary": "The Eiffel Tower ( EYE-f\u0259l TOW-\u0259r French: tour Eiffel, pronounced [tu\u0281\u203f\u025bf\u025bl]  listen) is a wrought iron lattice tower on the Champ de Mars in Paris, France. It is named after the engineer Gustave Eiffel, whose company designed and built the tower.\nConstructed from 1887\u201389 as the entrance to the 1889 World's Fair, it was initially criticized by some of France's leading artists and intellectuals for its design, but it has become a global cultural icon of France and one of the most recognisable structures in the world. The Eiffel Tower is the most-visited paid monument in the world 6.91 million people ascended it in 2015.\nThe tower is 324 metres (1,063 ft) tall, about the same height as an 81-storey building, and the tallest structure in Paris. Its base is square, measuring 125 metres (410 ft) on each side. During its construction, the Eiffel Tower surpassed the Washington Monument to become the tallest man-made structure in the world, a title it held for 41 years until the Chrysler Building in New York City was finished in 1930. Due to the addition of a broadcasting aerial at the top of the tower in 1957, it is now taller than the Chrysler Building by 5.2 metres (17 ft). Excluding transmitters, the Eiffel Tower is the second-tallest structure in France after the Millau Viaduct.\nThe tower has three levels for visitors, with restaurants on the first and second levels. The top level's upper platform is 276 m (906 ft) above the ground \u2013 the highest observation deck accessible to the public in the European Union. Tickets can be purchased to ascend by stairs or lift (elevator) to the first and second levels. The climb from ground level to the first level is over 300 steps, as is the climb from the first level to the second. Although there is a staircase to the top level, it is usually accessible only by lift.",
        "title": "Eiffel Tower"
    },
    "Electricity": {
        "image": "Electricity.jpg",
        "summary": "Electricity is the set of physical phenomena associated with the presence and motion of electric charge. Although initially considered a phenomenon separate from magnetism, since the development of Maxwell's equations, both are recognized as part of a single phenomenon: electromagnetism. Various common phenomena are related to electricity, including lightning, static electricity, electric heating, electric discharges and many others.\nThe presence of an electric charge, which can be either positive or negative, produces an electric field. On the other hand, the movement of electric charges, which is known as electric current, produces a magnetic field.\nWhen a charge is placed in a location with a non-zero electric field, a force will act on it. The magnitude of this force is given by Coulomb's law. Thus, if that charge were to move, the electric field would be doing work on the electric charge. Thus we can speak of electric potential at a certain point in space, which is equal to the work done by an external agent in carrying a unit of positive charge from an arbitrarily chosen reference point to that point without any acceleration and is typically measured in volts.\nElectricity is at the heart of many modern technologies, being used for:\nelectric power where electric current is used to energise equipment\nelectronics which deals with electrical circuits that involve active electrical components such as vacuum tubes, transistors, diodes and integrated circuits, and associated passive interconnection technologies.\nElectrical phenomena have been studied since antiquity, though progress in theoretical understanding remained slow until the seventeenth and eighteenth centuries. Even then, practical applications for electricity were few, and it would not be until the late nineteenth century that electrical engineers were able to put it to industrial and residential use. The rapid expansion in electrical technology at this time transformed industry and society, becoming a driving force for the Second Industrial Revolution. Electricity's extraordinary versatility means it can be put to an almost limitless set of applications which include transport, heating, lighting, communications, and computation. Electrical power is now the backbone of modern industrial society.",
        "title": "Electricity"
    },
    "Electronics": {
        "image": "Electronics.jpg",
        "summary": "Electronics is the science of controlling electrical energy electrically, in which the electrons have a fundamental role. Electronics deals with electrical circuits that involve active electrical components (such as vacuum tubes, transistors, diodes, integrated circuits, optoelectronics, and sensors), associated passive electrical components, and interconnection technologies. Commonly, electronic devices contain circuitry consisting primarily or exclusively of active semiconductors supplemented with passive elements such a circuit is described as an electronic circuit.\nThe science of electronics is considered to be a branch of physics and electrical engineering.\nThe nonlinear behaviour of active components and their ability to control electron flows makes amplification of weak signals possible. Electronics is widely used in information processing, telecommunication, and signal processing. The ability of electronic devices to act as switches makes digital information processing possible. Interconnection technologies such as circuit boards, electronics packaging technology, and other varied forms of communication infrastructure complete circuit functionality and transform the mixed components into a regular working system.\nElectronics is distinct from electrical and electro-mechanical science and technology, which deal with the generation, distribution, switching, storage, and conversion of electrical energy to and from other energy forms using wires, motors, generators, batteries, switches, relays, transformers, resistors, and other passive components. This distinction started around 1906 with the invention by Lee De Forest of the triode, which made electrical amplification of weak radio signals and audio signals possible with a non-mechanical device. Until 1950 this field was called \"radio technology\" because its principal application was the design and theory of radio transmitters, receivers, and vacuum tubes.\nToday, most electronic devices use semiconductor components to perform electron control. The study of semiconductor devices and related technology is considered a branch of solid-state physics, whereas the design and construction of electronic circuits to solve practical problems come under electronics engineering. This article focuses on engineering aspects of electronics.",
        "title": "Electronics"
    },
    "Engineering": {
        "image": "Engineering.jpg",
        "summary": "Engineering is the application of mathematics, science, economics, and social and practical knowledge to invent, innovate, design, build, maintain, research, and improve structures, machines, tools, systems, components, materials, processes, solutions, and organizations.\nThe discipline of engineering is extremely broad and encompasses a range of more specialized fields of engineering, each with a more specific emphasis on particular areas of applied science, technology and types of application.\nThe term engineering is derived from the Latin ingenium, meaning \"cleverness\" and ingeniare, meaning \"to contrive, devise\".",
        "title": "Engineering"
    },
    "Engineers": {
        "image": "Engineer.jpg",
        "summary": "Engineers are people who invent, design, analyse, build and test machines, systems, structures and materials to fulfil objectives and requirements while considering the limitations imposed by practicality, regulation, safety, and cost. The word engineer (Latin ingeniator) is derived from the Latin words ingeniare (\"to contrive, devise\") and ingenium (\"cleverness\"). The foundation education of an engineer is typically a 4-year bachelor's degree in an engineering discipline or in some countries, a master's degree in an engineering discipline plus 4\u20136 years of peer-reviewed professional practice culminating in a project report, thesis, or engineering board's examinations.\nThe work of engineers forms the link between scientific discoveries and their subsequent applications to human and business needs and quality of life.",
        "title": "Engineer"
    },
    "Environmentalism": {
        "image": "Environmentalism.jpg",
        "summary": "Environmentalism or environmental rights is a broad philosophy, ideology, and social movement regarding concerns for environmental protection and improvement of the health of the environment, particularly as the measure for this health seeks to incorporate the impact of changes to the environment on humans, animals, plants and non-living matter. While environmentalism focuses more on the environmental and nature-related aspects of green ideology and politics, ecologism combines the ideology of social ecology and environmentalism. Ecologism is more commonly used in continental European languages while \u2018environmentalism\u2019 is more commonly used in English but the words have slightly different connotations.\nEnvironmentalism advocates the lawful preservation, restoration and/or improvement of the natural environment, and may be referred to as a movement to control pollution or protect plant and animal diversity. For this reason, concepts such as a land ethic, environmental ethics, biodiversity, ecology, and the biophilia hypothesis figure predominantly.\nAt its crux, environmentalism is an attempt to balance relations between humans and the various natural systems on which they depend in such a way that all the components are accorded a proper degree of sustainability. The exact measures and outcomes of this balance is controversial and there are many different ways for environmental concerns to be expressed in practice. Environmentalism and environmental concerns are often represented by the color green, but this association has been appropriated by the marketing industries for the tactic known as greenwashing.\nEnvironmentalism is opposed by anti-environmentalism, which says that the Earth is less fragile than some environmentalists maintain, and portrays environmentalism as overreacting to the human contribution to climate change or opposing human advancement.",
        "title": "Environmentalism"
    },
    "Espionage": {
        "image": "Espionage.jpg",
        "summary": "Espionage (colloquially, spying) is the obtaining of secret or confidential information without the permission of the holder of the information. Spies help agencies uncover secret information. Any individual or spy ring (a cooperating group of spies), in the service of a government, company or independent operation, can commit espionage. The practice is clandestine, as it is by definition unwelcome and in many cases illegal and punishable by law. Espionage is a subset of \"intelligence\" gathering, which includes espionage as well as information gathering from public sources.\nEspionage is often part of an institutional effort by a government or commercial concern. However, the term tends to associate with state spying on potential or actual enemies for military purposes. Spying involving corporations is known as industrial espionage.\nOne of the most effective ways to gather data and information about the enemy (or potential enemy) is by infiltrating the enemy's ranks. This is the job of the spy (espionage agent). Spies can return all sorts of information concerning the size and strength of enemy forces. They can also find dissidents within the enemy's forces and influence them to defect. In times of crisis, spies can also oblige to steal technology and sabotage the enemy in various ways. Counterintelligence operatives can feed false information to enemy spies, protecting important domestic secrets, and preventing attempts at subversion. Almost all nations have strict laws concerning espionage and the penalty for being caught is often severe. However, the benefits through espionage are often great enough that most governments and many large corporations make use of it to varying degrees.\nFurther information on clandestine human intelligence and human intelligence information collection techniques is available, including discussions of operational techniques, asset recruiting, and the tradecraft used to collect this information.",
        "title": "Espionage"
    },
    "Explorer": {
        "image": "Exploration.jpg",
        "summary": "Exploration is the act of searching for the purpose of discovery of information or resources. Exploration occurs in all non-sessile animal species, including humans. In human history, its most dramatic rise was during the Age of Discovery when European explorers sailed and charted much of the rest of the world for a variety of reasons. Since then, major explorations after the Age of Discovery have occurred for reasons mostly aimed at information discovery.\nIn scientific research, exploration is one of three purposes of empirical research (the other two being description and explanation). The term is commonly used metaphorically. For example, an individual may speak of exploring the Internet, sexuality, etc.",
        "title": "Exploration"
    },
    "Explosives": {
        "image": None,
        "summary": "An explosive material, also called an explosive, is a reactive substance that contains a great amount of potential energy that can produce an explosion if released suddenly, usually accompanied by the production of light, heat, sound, and pressure. An explosive charge is a measured quantity of explosive material, which may be composed of a single ingredient or a combination of two or more.\nThe potential energy stored in an explosive material may, for example, be\nchemical energy, such as nitroglycerin or grain dust\npressurized gas, such as a gas cylinder or aerosol can\nnuclear energy, such as in the fissile isotopes uranium-235 and plutonium-239\nExplosive materials may be categorized by the speed at which they expand. Materials that detonate (the front of the chemical reaction moves faster through the material than the speed of sound) are said to be \"high explosives\" and materials that deflagrate are said to be \"low explosives\". Explosives may also be categorized by their sensitivity. Sensitive materials that can be initiated by a relatively small amount of heat or pressure are primary explosives and materials that are relatively insensitive are secondary or tertiary explosives.\nA wide variety of chemicals can explode a smaller number are manufactured specifically for the purpose of being used as explosives. The remainder are too dangerous, sensitive, toxic, expensive, unstable, or prone to decomposition or degradation over short time spans.\nIn contrast, some materials are merely combustible or flammable if they burn without exploding.\nThe distinction, however, is not razor-sharp. Certain materials\u2014dusts, powders, gasses, or volatile organic liquids\u2014may be simply combustible or flammable under ordinary conditions, but become explosive in specific situations or forms, such as dispersed airborne clouds, or confinement or sudden release.",
        "title": "Explosive material"
    },
    "Factory": {
        "image": "Factory.jpg",
        "summary": "A factory (previously manufactory) or manufacturing plant is an industrial site, usually consisting of buildings and machinery, or more commonly a complex having several buildings, where workers manufacture goods or operate machines processing one product into another.\nFactories arose with the introduction of machinery during the Industrial Revolution when the capital and space requirements became too great for cottage industry or workshops. Early factories that contained small amounts of machinery, such as one or two spinning mules, and fewer than a dozen workers have been called \"glorified workshops\".\nMost modern factories have large warehouses or warehouse-like facilities that contain heavy equipment used for assembly line production. Large factories tend to be located with access to multiple modes of transportation, with some having rail, highway and water loading and unloading facilities.\nFactories may either make discrete products or some type of material continuously produced such as chemicals, pulp and paper, or refined oil products. Factories manufacturing chemicals are often called plants and may have most of their equipment \u2013 tanks, pressure vessels, chemical reactors, pumps and piping \u2013 outdoors and operated from control rooms. Oil refineries have most of their equipment outdoors.\nDiscrete products may be final consumer goods, or parts and sub-assemblies which are made into final products elsewhere. Factories may be supplied parts from elsewhere or make them from raw materials. Continuous production industries typically use heat or electricity to transform streams of raw materials into finished products.\nThe term mill originally referred to the milling of grain, which usually used natural resources such as water or wind power until those were displaced by steam power in the 19th century. Because many processes like spinning and weaving, iron rolling, and paper manufacturing were originally powered by water, the term survives as in steel mill, paper mill, etc.",
        "title": "Factory"
    },
    "Feudalism": {
        "image": "Feudalism.jpg",
        "summary": "Feudalism was a combination of legal and military customs in medieval Europe that flourished between the 9th and 15th centuries. Broadly defined, it was a way of structuring society around relationships derived from the holding of land in exchange for service or labour.\nAlthough derived from the Latin word feodum or feudum (fief), then in use, the term feudalism and the system it describes were not conceived of as a formal political system by the people living in the Middle Ages. In its classic definition, by Fran\u00e7ois-Louis Ganshof (1944), feudalism describes a set of reciprocal legal and military obligations among the warrior nobility revolving around the three key concepts of lords, vassals and fiefs.\nA broader definition of feudalism, as described by Marc Bloch (1939), includes not only the obligations of the warrior nobility but also those of all three estates of the realm: the nobility, the clergy, and the peasantry bound by manorialism this is sometimes referred to as a \"feudal society\". Since the publication of Elizabeth A. R. Brown's \"The Tyranny of a Construct\" (1974) and Susan Reynolds's Fiefs and Vassals (1994), there has been ongoing inconclusive discussion among medieval historians as to whether feudalism is a useful construct for understanding medieval society.",
        "title": "Feudalism"
    },
    "Fighter": {
        "image": "Fighter aircraft.jpg",
        "summary": "A fighter aircraft is a military aircraft designed primarily for air-to-air combat against other aircraft, as opposed to bombers and attack aircraft, whose main mission is to attack ground targets. The hallmarks of a fighter are its speed, maneuverability, and small size relative to other combat aircraft.\nMany fighters have secondary ground-attack capabilities, and some are designed as dual-purpose fighter-bombers often aircraft that do not fulfill the standard definition are called fighters. This may be for political or national security reasons, for advertising purposes, or other reasons.\nA fighter's main purpose is to establish air superiority over a battlefield. Since World War I, achieving and maintaining air superiority has been considered essential for victory in conventional warfare. The success or failure of a belligerent's efforts to gain air supremacy hinges on several factors including the skill of its pilots, the tactical soundness of its doctrine for deploying its fighters, and the numbers and performance of those fighters. Because of the importance of air superiority, since the dawn of aerial combat armed forces have constantly competed to develop technologically superior fighters and to deploy these fighters in greater numbers, and fielding a viable fighter fleet consumes a substantial proportion of the defense budgets of modern armed forces.",
        "title": "Fighter aircraft"
    },
    "Flight": {
        "image": "Flight.jpg",
        "summary": "Flight is the process by which an object moves, through an atmosphere or beyond it, as in the case of spaceflight. This can be achieved by generating aerodynamic lift, propulsive thrust, aerostatically using buoyancy, or by ballistic movement.\nMany things fly, from natural aviators such as birds, bats and insects to human inventions such as missiles, aircraft such as airplanes, helicopters and balloons, to rockets such as spacecraft.\nThe engineering aspects of flight are the purview of aerospace engineering which is subdivided into aeronautics, the study of vehicles that travel through the air, and astronautics, the study of vehicles that travel through space, and in ballistics, the study of the flight of projectiles.",
        "title": "Flight"
    },
    "Freight": {
        "image": "Cargo.jpg",
        "summary": "In economics, cargo or freight are goods or produce being conveyed \u2013 generally for commercial gain \u2013 by water, air or land. Cargo was originally a shipload. Cargo now covers all types of freight, including that carried by train, van, truck, or intermodal container. The term cargo is also used in case of goods in the cold-chain, because the perishable inventory is always in transit towards a final end-use, even when it is held in cold storage or other similar climate-controlled facility.\nMulti-modal container units, designed as reusable carriers to facilitate unit load handling of the goods contained, are also referred to as cargo, specially by shipping lines and logistics operators. Similarly, aircraft ULD boxes are also documented as cargo, with associated packing list of the items contained within. When empty containers are shipped each unit is documented as a cargo and when goods are stored within, the contents are termed as containerised cargo.",
        "title": "Cargo"
    },
    "Frigate": {
        "image": "Frigate.jpg",
        "summary": "A frigate  is any of several types of warship, the term having been used for ships of various sizes and roles over the last few centuries.\nIn the 17th century, this term was used for any warship built for speed and maneuverability, the description often used being \"frigate-built\". These could be warships carrying their principal batteries of carriage-mounted guns on a single deck or on two decks (with further smaller carriage-mounted guns usually carried on the forecastle and quarterdeck of the vessel). The term was generally used for ships too small to stand in the line of battle, although early line-of-battle ships were frequently referred to as frigates when they were built for speed.\nIn the 18th century, the term referred to ships that were usually as long as a ship of the line and were square-rigged on all three masts (full rigged), but were faster and with lighter armament, used for patrolling and escort. In the definition adopted by the British Admiralty, they were rated ships of at least 28 guns, carrying their principal armaments upon a single continuous deck \u2014 the upper deck \u2014 while ships of the line possessed two or more continuous decks bearing batteries of guns.\nIn the late 19th century (beginning about 1858 with the construction of prototypes by the British and French navies), the armoured frigate was a type of ironclad warship that for a time was the most powerful type of vessel afloat. The term \"frigate\" was used because such ships still mounted their principal armaments on a single continuous upper deck.\nIn modern navies, frigates are used to protect other warships and merchant-marine ships, especially as anti-submarine warfare (ASW) combatants for amphibious expeditionary forces, underway replenishment groups, and merchant convoys. Ship classes dubbed \"frigates\" have also more closely resembled corvettes, destroyers, cruisers, and even battleships. Some European navies such as the French, German or Spanish ones use the term \"frigate\" for both their destroyers and frigates. The rank \"frigate captain\" derives from the name of this type of ship.",
        "title": "Frigate"
    },
    "Fusion Power": {
        "image": "Fusion power.jpg",
        "summary": "Fusion power is a form of power generation in which energy is generated by using fusion reactions to produce heat for electricity generation. Fusion reactions fuse two lighter atomic nuclei to form a heavier nucleus, releasing energy. Devices designed to harness this energy are known as fusion reactors.\nThe fusion reaction normally takes place in a plasma of deuterium and tritium heated to millions of degrees. In stars, gravity contains these fuels. Outside of a star, the most researched way to confine the plasma at these temperatures is to use magnetic fields. The major challenge in realising fusion power is to engineer a system that can confine the plasma long enough at high enough temperature and density.\nAs a source of power, nuclear fusion has several theoretical advantages over fission. These advantages include reduced radioactivity in operation and as waste, ample fuel supplies, and increased safety. However, controlled fusion has proven to be extremely difficult to produce in a practical and economical manner. Research into fusion reactors began in the 1940s, but as of 2017, no design has produced more fusion energy than the energy needed to initiate the reaction, meaning all existing designs have a negative energy balance.\nOver the years, fusion researchers have investigated various confinement concepts. The early emphasis was on three main systems: z-pinch, stellarator and magnetic mirror. The current leading designs are the tokamak and inertial confinement (ICF) by laser. Both designs are being built at very large scales, most notably the ITER tokamak in France, and the National Ignition Facility laser in the USA. Researchers are also studying other designs that may offer cheaper approaches. Among these alternatives there is increasing interest in magnetized target fusion and inertial electrostatic confinement.",
        "title": "Fusion power"
    },
    "Galleon": {
        "image": "Galleon.jpg",
        "summary": "Galleons were large, multi-decked sailing ships used as armed cargo carriers primarily by European states from the 16th to 18th centuries during the age of sail and were the principal fleet units drafted for use as warships until the Anglo-Dutch Wars of the mid-1600s. Galleons generally carried three or more masts with a lateen fore-and-aft rig on the rear masts, were carvel built with a prominent squared off raised stern, and used square-rigged sail plans on their fore-mast and main-masts.\nSuch ships were the mainstay of maritime commerce into the early 19th century, and were often drafted into use as auxiliary naval war vessels\u2014indeed, were the mainstay of contending fleets through most of the 150 years of the Age of Exploration \u2014 before the Anglo-Dutch wars begat purpose-built ship-rigged warships that thereafter dominated war at sea during the remainder of the Age of Sail.",
        "title": "Galleon"
    },
    "Genetic Engineering": {
        "image": "Genetic engineering.jpg",
        "summary": "Genetic engineering, also called genetic modification, is the direct manipulation of an organism's genes using biotechnology. It is a set of technologies used to change the genetic makeup of cells, including the transfer of genes within and across species boundaries to produce improved or novel organisms. New DNA is obtained by either isolating and copying the genetic material of interest using molecular cloning methods or by artificially synthesizing the DNA. A construct is usually created and used to insert this DNA into the host organism. As well as inserting genes, the process can be used to remove, or \"knock out\", genes. The new DNA can be inserted randomly, or targeted to a specific part of the genome.\nAn organism that is generated through genetic engineering is considered to be genetically modified (GM) and the resulting entity is a genetically modified organism (GMO). The first GMOs were bacteria generated in 1973 and the first GM animals were mice in 1974. Insulin-producing bacteria were commercialized in 1982 and genetically modified food has been sold since 1994. GloFish, the first GMO designed as a pet, was sold in the United States in December 2003.\nGenetic engineering techniques have been applied in numerous fields including research, agriculture, industrial biotechnology, and medicine. Enzymes used in laundry detergent and medicines such as insulin and human growth hormone are now manufactured in GM cells, experimental GM cell lines and GM animals such as mice or zebrafish are being used for research purposes, and genetically modified crops have been commercialized.",
        "title": "Genetic engineering"
    },
    "Granary": {
        "image": "Granary.jpg",
        "summary": "A granary is a storehouse or room in a barn for threshed grain or animal feed. Ancient or primitive granaries are most often made out of pottery. Granaries are often built above the ground to keep the stored food away from mice and other animals.",
        "title": "Granary"
    },
    "Great Library": {
        "image": "Library of Alexandria.jpg",
        "summary": "The Royal Library of Alexandria or Ancient Library of Alexandria in Alexandria, Egypt, was one of the largest and most significant libraries of the ancient world. It was dedicated to the Muses, the nine goddesses of the arts. It flourished under the patronage of the Ptolemaic dynasty and functioned as a major center of scholarship from its construction in the 3rd century BC until the Roman conquest of Egypt in 30 BC, with collections of works, lecture halls, meeting rooms, and gardens. The library was part of a larger research institution called the Musaeum of Alexandria, where many of the most famous thinkers of the ancient world studied.\nThe library was created by Ptolemy I Soter, who was a Macedonian general and the successor of Alexander the Great. Most of the books were kept as papyrus scrolls. It is unknown precisely how many such scrolls were housed at any given time, but estimates range from 40,000 to 400,000 at its height.\nArguably, this library is most famous for having been burned down resulting in the loss of many scrolls and books its destruction has become a symbol for the loss of cultural knowledge. Sources differ on who was responsible for its destruction and when it occurred. The library may in truth have suffered several fires over many years. Possible occasions for the partial or complete destruction of the Library of Alexandria include a fire set by the army of Julius Caesar in 48 BC and an attack by Aurelian in the 270s AD.\nAfter the main library was destroyed, scholars used a \"daughter library\" in a temple known as the Serapeum of Alexandria, located in another part of the city. According to Socrates of Constantinople, Coptic Pope Theophilus destroyed the Serapeum in AD 391, although it is not certain what it contained or if it contained any significant fraction of the documents that were in the main library. The library may have finally been destroyed during (or after) the Muslim conquest of Egypt in AD 642.",
        "title": "Library of Alexandria"
    },
    "Great Wall": {
        "image": "Great Wall of China.jpg",
        "summary": "The Great Wall of China is a series of fortifications made of stone, brick, tamped earth, wood, and other materials, generally built along an east-to-west line across the historical northern borders of China to protect the Chinese states and empires against the raids and invasions of the various nomadic groups of the Eurasian Steppe. Several walls were being built as early as the 7th century BC these, later joined together and made bigger and stronger, are collectively referred to as the Great Wall. Especially famous is the system of fortifications built in 220\u2013206 BC by Qin Shi Huang, the first Emperor of China. Little of that wall remains. The Great Wall has been rebuilt, maintained, and enhanced over various dynasties the majority of the existing wall is from the Ming Dynasty (1368\u20131644).\nApart from defense, other purposes of the Great Wall have included border controls, allowing the imposition of duties on goods transported along the Silk Road, regulation or encouragement of trade and the control of immigration and emigration. Furthermore, the defensive characteristics of the Great Wall were enhanced by the construction of watch towers, troop barracks, garrison stations, signaling capabilities through the means of smoke or fire, and the fact that the path of the Great Wall also served as a transportation corridor.\nThe Great Wall stretches from Dandong in the east to Lop Lake in the west, along an arc that roughly delineates the southern edge of Inner Mongolia. A comprehensive archaeological survey, using advanced technologies, has concluded that the Ming walls measure 8,850 km (5,500 mi). This is made up of 6,259 km (3,889 mi) sections of actual wall, 359 km (223 mi) of trenches and 2,232 km (1,387 mi) of natural defensive barriers such as hills and rivers. Another archaeological survey found that the entire wall with all of its branches measure out to be 21,196 km (13,171 mi). Today, the Great Wall is generally recognized as one of the most impressive architectural feats in history.",
        "title": "Great Wall of China"
    },
    "Guerilla Warfare": {
        "image": "Guerrilla warfare.jpg",
        "summary": "Guerrilla warfare is a form of irregular warfare in which a small group of combatants, such as paramilitary personnel, armed civilians, or irregulars, use military tactics including ambushes, sabotage, raids, petty warfare, hit-and-run tactics, and mobility to fight a larger and less-mobile traditional military.\n\n",
        "title": "Guerrilla warfare"
    },
    "Gunpowder": {
        "image": "Gunpowder.jpg",
        "summary": "Gunpowder, also known as black powder to distinguish it from modern smokeless gunpowder, is the earliest known chemical explosive. It consists of a mixture of sulfur, charcoal, and potassium nitrate (saltpeter). The sulfur and charcoal act as fuels while the saltpeter is an oxidizer. Because of its incendiary properties and the amount of heat and gas volume that it generates, gunpowder has been widely used as a propellant in firearms, rockets, fireworks, and as a blasting powder in quarrying, mining, and road building.\nGunpowder was invented in 9th-century China and spread throughout most parts of Eurasia by the end of the 13th century. Most arguments on early gunpowder developments now revolve around how much Chinese advancements in gunpowder influenced gunpowder warfare in Europe and the Middle East, but controversy over gunpowder's precise origins continue to be debated today.\nGunpowder is classified as a low explosive because of its relatively slow decomposition rate and consequently low brisance. Low explosives deflagrate (i.e., burn) at subsonic speeds, whereas high explosives detonate, producing a supersonic wave. Ignition of powder packed behind a bullet must generate enough pressure to force it from the muzzle at high speed, but not enough to rupture the gun barrel. Gunpowder thus makes a good propellant, but is less suitable for shattering rock or fortifications. Gunpowder was widely used to fill artillery shells and in mining and civil engineering to blast rock until the second half of the 19th century, when the first high explosives were put into use. Gunpowder is no longer used in modern weapons nor is it used for industrial purposes due to its relatively inefficient cost compared to newer alternatives such as dynamite and ammonium nitrate/fuel oil. Today gunpowder firearms are limited primarily to hunting, target shooting, and bulletless historical reenactments.",
        "title": "Gunpowder"
    },
    "Hanging Gardens": {
        "image": "Hanging Gardens of Babylon.jpg",
        "summary": "The Hanging Gardens of Babylon were one of the Seven Wonders of the Ancient World, a term given to it by ancient Hellenic culture. The Hanging Gardens were described as a remarkable feat of engineering with an ascending series of tiered gardens containing a wide variety of trees, shrubs, and vines. The gardens were said to have looked like a large green mountain constructed of mud bricks.\nThe Hanging Gardens is the only one of the seven ancient wonders for which the location has not been definitively established. Traditionally they were said to have been built in the ancient city of Babylon, near present-day Hillah, Babil province, in Iraq. The Babylonian priest Berossus, writing in about 290 BC and quoted later by Josephus, attributed the gardens to Neo-Babylonian King Nebuchadnezzar II, who ruled between 605 and 562 BC. There are no extant Babylonian texts which mention the gardens, and no definitive archaeological evidence has been found in Babylon.\nBecause no physical evidence for the Hanging Gardens has been found at Babylon, two theories have been suggested. One is that they were purely mythical, and the descriptions found in ancient Greek and Roman writers including Strabo, Diodorus Siculus and Quintus Curtius Rufus represent a romantic ideal of an eastern garden. If it did indeed exist, it was destroyed sometime after the first century AD. The other theory is that they were actually in the city of Nineveh, constructed by the Assyrian king Sennacherib.\nAccording to one legend, Nebuchadnezzar II built the Hanging Gardens for his Median wife, Queen Amytis, because she missed the green hills and valleys of her homeland. He also built a grand palace that came to be known as \"The Marvel of the Mankind\". Stephanie Dalley suggests that the original garden may have been a well-documented one that Assyrian King Sennacherib (704\u2013681 BC) built in his capital city of Nineveh on the River Tigris, near the modern city of Mosul.",
        "title": "Hanging Gardens of Babylon"
    },
    "Harbor": {
        "image": "Harbor.jpg",
        "summary": "A harbor or harbour (see spelling differences), also called a haven, is a body of water where ships, boats, and barges seek shelter from stormy weather, or are stored for future use. The term harbor, referring primarily to a sheltered body of water, is often used interchangeably with port, which is a man-made facility built for loading and unloading vessels and dropping off and picking up passengers. Ports usually include one or more harbors. Alexandria Port is an example of a port with two harbors.\nHarbors may be natural or artificial. An artificial harbor can have deliberately constructed breakwaters, sea walls, or jettys, or they can be constructed by dredging, which requires maintenance by further periodic dredging. An example of an artificial harbor is Long Beach Harbor, California, United States which was an array of salt marshes and tidal flats too shallow for modern merchant ships before it was first dredged in the early 20th century. In contrast, a natural harbor is surrounded on several sides by prominences of land. Examples of natural harbors include Sydney Harbour, Australia and Trincomalee Harbour in Sri Lanka.",
        "title": "Harbor"
    },
    "Helicopter": {
        "image": "Helicopter.jpg",
        "summary": "A helicopter is a type of rotorcraft in which lift and thrust are supplied by rotors. This allows the helicopter to take off and land vertically, to hover, and to fly forward, backward, and laterally. These attributes allow helicopters to be used in congested or isolated areas where fixed-wing aircraft and many forms of VTOL (vertical takeoff and landing) aircraft cannot perform.\nThe English word helicopter is adapted from the French word h\u00e9licopt\u00e8re, coined by Gustave Ponton d'Am\u00e9court in 1861, which originates from the Greek helix (\u1f15\u03bb\u03b9\u03be) \"helix, spiral, whirl, convolution\" and pteron (\u03c0\u03c4\u03b5\u03c1\u03cc\u03bd) \"wing\". English language nicknames for helicopter include \"chopper\", \"copter\", \"helo\", \"heli\", and \"whirlybird\".\nHelicopters were developed and built during the first half-century of flight, with the Focke-Wulf Fw 61 being the first operational helicopter in 1936. Some helicopters reached limited production, but it was not until 1942 that a helicopter designed by Igor Sikorsky reached full-scale production, with 131 aircraft built. Though most earlier designs used more than one main rotor, it is the single main rotor with anti-torque tail rotor configuration that has become the most common helicopter configuration. Tandem rotor helicopters are also in widespread use due to their greater payload capacity. Coaxial helicopters, tiltrotor aircraft, and compound helicopters are all flying today. Quadcopter helicopters pioneered as early as 1907 in France, and other types of multicopter have been developed for specialized applications such as unmanned drones.\n\n",
        "title": "Helicopter"
    },
    "Hoover Dam": {
        "image": "Hoover Dam.jpg",
        "summary": "Hoover Dam is a concrete arch-gravity dam in the Black Canyon of the Colorado River, on the border between the U.S. states of Nevada and Arizona. It was constructed between 1931 and 1936 during the Great Depression and was dedicated on September 30, 1935, by President Franklin D. Roosevelt. Originally known as Boulder Dam from 1933, it was officially renamed Hoover Dam by a joint resolution of Congress in 1947. Its construction was the result of a massive effort involving thousands of workers, and cost over one hundred lives. The dam was named after President Herbert Hoover.\nSince about 1900, the Black Canyon and nearby Boulder Canyon had been investigated for their potential to support a dam that would control floods, provide irrigation water and produce hydroelectric power. In 1928, Congress authorized the project. The winning bid to build the dam was submitted by a consortium called Six Companies, Inc., which began construction on the dam in early 1931. Such a large concrete structure had never been built before, and some of the techniques were unproven. The torrid summer weather and lack of facilities near the site also presented difficulties. Nevertheless, Six Companies turned over the dam to the federal government on March 1, 1936, more than two years ahead of schedule.\nHoover Dam impounds Lake Mead, the largest reservoir in the United States by volume (when it is full). The dam is located near Boulder City, Nevada, a municipality originally constructed for workers on the construction project, about 30 mi (48 km) southeast of Las Vegas, Nevada. The dam's generators provide power for public and private utilities in Nevada, Arizona, and California. Hoover Dam is a major tourist attraction nearly a million people tour the dam each year. The heavily traveled U.S. Route 93 (US 93) ran along the dam's crest until October 2010, when the Hoover Dam Bypass opened.",
        "title": "Hoover Dam"
    },
    "Horseback Riding": {
        "image": "Equestrianism.jpg",
        "summary": "Equestrianism (from Latin equester, equestr-, equus, horseman, horse), more often known as riding, horse riding (British English) or horseback riding (American English), refers to the skill of riding, driving, steeplechasing or vaulting with horses. This broad description includes the use of horses for practical working purposes, transportation, recreational activities, artistic or cultural exercises and competitive sport.",
        "title": "Equestrianism"
    },
    "Horsemen": {
        "image": "Equestrianism.jpg",
        "summary": "Equestrianism (from Latin equester, equestr-, equus, horseman, horse), more often known as riding, horse riding (British English) or horseback riding (American English), refers to the skill of riding, driving, steeplechasing or vaulting with horses. This broad description includes the use of horses for practical working purposes, transportation, recreational activities, artistic or cultural exercises and competitive sport.",
        "title": "Equestrianism"
    },
    "Howitzer": {
        "image": "Howitzer.jpg",
        "summary": "A howitzer  is a type of artillery piece characterized by a relatively short barrel and the use of comparatively small propellant charges to propel projectiles over relatively high trajectories, with a steep angle of descent.\n\nIn the taxonomies of artillery pieces used by European (and European-style) armies in the 17th to 20th centuries, the howitzer stood between the \"gun\" (characterized by a longer barrel, larger propelling charges, smaller shells, higher velocities, and flatter trajectories) and the \"mortar\" (which was meant to fire at even higher angles of ascent and descent). Howitzers, like other artillery equipment, are usually organized in groups called batteries.",
        "title": "Howitzer"
    },
    "Hydro Plant": {
        "image": "Hydroelectricity.jpg",
        "summary": "Hydroelectricity is electricity produced from hydropower. In 2015 hydropower generated 16.6% of the world's total electricity and 70% of all renewable electricity, and was expected to increase about 3.1% each year for the next 25 years.\nHydropower is produced in 150 countries, with the Asia-Pacific region generating 33 percent of global hydropower in 2013. China is the largest hydroelectricity producer, with 920 TWh of production in 2013, representing 16.9 percent of domestic electricity use.\nThe cost of hydroelectricity is relatively low, making it a competitive source of renewable electricity. The hydro station consumes no water, unlike coal or gas plants. The average cost of electricity from a hydro station larger than 10 megawatts is 3 to 5 U.S. cents per kilowatt-hour. With a dam and reservoir it is also a flexible source of electricity since the amount produced by the station can be changed up or down very quickly to adapt to changing energy demands. Once a hydroelectric complex is constructed, the project produces no direct waste, and has a considerably lower output level of greenhouse gases than fossil fuel powered energy plants.\n\n",
        "title": "Hydroelectricity"
    },
    "Industrialization": {
        "image": "Industrialisation.jpg",
        "summary": "Industrialisation or industrialization is the period of social and economic change that transforms a human group from an agrarian society into an industrial society, involving the extensive re-organisation of an economy for the purpose of manufacturing.\nAs industrial workers' incomes rise, markets for consumer goods and services of all kinds tend to expand and provide a further stimulus to industrial investment and economic growth.",
        "title": "Industrialisation"
    },
    "Invention": {
        "image": "Invention.jpg",
        "summary": "An invention is a unique or novel device, method, composition or process. The invention process is a process within an overall engineering and product development process. It may be an improvement upon a machine or product or a new process for creating an object or a result. An invention that achieves a completely unique function or result may be a radical breakthrough. Such works are novel and not obvious to others skilled in the same field. An inventor may be taking a big step in success or failure.\nSome inventions can be patented. A patent legally protects the intellectual property rights of the inventor and legally recognizes that a claimed invention is actually an invention. The rules and requirements for patenting an invention vary from country to country and the process of obtaining a patent is often expensive.\nAnother meaning of invention is cultural invention, which is an innovative set of useful social behaviours adopted by people and passed on to others. The Institute for Social Inventions collected many such ideas in magazines and books. Invention is also an important component of artistic and design creativity. Inventions often extend the boundaries of human knowledge, experience or capability.",
        "title": "Invention"
    },
    "Iron Working": {
        "image": "Ferrous metallurgy.jpg",
        "summary": "Ferrous metallurgy is the metallurgy of iron and its alloys. It began far back in prehistory. The earliest surviving iron artifacts, from the 4th millennium BC in Egypt, were made from meteoritic iron-nickel. It is not known when or where the smelting of iron from ores began, but by the end of the 2nd millennium BC iron was being produced from iron ores from China to Sub-Saharan Africa. The use of wrought iron (worked iron) was known by the 1st millennium BC, and its spread marked the Iron Age. During the medieval period, means were found in Europe of producing wrought iron from cast iron (in this context known as pig iron) using finery forges. For all these processes, charcoal was required as fuel.\nSteel (with a carbon content between pig iron and wrought iron) was first produced in antiquity as an alloy. Its process of production, Wootz steel, was exported before the 4th century BC to ancient China, Africa, the Middle East and Europe. Archaeological evidence of cast iron appears in 5th century BC China. New methods of producing it by carburizing bars of iron in the cementation process were devised in the 17th century. During the Industrial Revolution, new methods of producing bar iron without charcoal were devised and these were later applied to produce steel, creating a new era of greatly increased use of iron and steel that some contemporaries described as a new Iron Age. In the late 1850s, Henry Bessemer invented a new steelmaking process, that involved blowing air through molten pig iron to burn off carbon, and so to produce mild steel. This and other 19th-century and later processes have displaced the use of wrought iron. Today, wrought iron is no longer produced on a commercial scale.",
        "title": "Ferrous metallurgy"
    },
    "Ironclad": {
        "image": "Ironclad warship.jpg",
        "summary": "An ironclad is a steam-propelled warship protected by iron or steel armor plates used in the early part of the second half of the 19th century. The ironclad was developed as a result of the vulnerability of wooden warships to explosive or incendiary shells. The first ironclad battleship, Gloire, was launched by the French Navy in November 1859. The British Admiralty had been considering armored warships since 1856 and prepared a draft design for an armored corvette in 1857 in early 1859 the Royal Navy started building two iron-hulled armored frigates, and by 1861 had made the decision to move to an all-armored battle fleet. After the first clashes of ironclads (both with wooden ships and with one another) took place in 1862 during the American Civil War, it became clear that the ironclad had replaced the unarmored ship of the line as the most powerful warship afloat. This type of ship would come to be very successful in the American Civil War.\nIronclads were designed for several roles, including as high seas battleships, coastal defense ships, and long-range cruisers. The rapid development of warship design in the late 19th century transformed the ironclad from a wooden-hulled vessel that carried sails to supplement its steam engines into the steel-built, turreted battleships and cruisers familiar in the 20th century. This change was pushed forward by the development of heavier naval guns (the ironclads of the 1880s carried some of the heaviest guns ever mounted at sea at the time), more sophisticated steam engines, and advances in metallurgy which made steel shipbuilding possible.\nThe quick pace of change meant that many ships were obsolete as soon as they were finished, and that naval tactics were in a state of flux. Many ironclads were built to make use of the ram or the torpedo, which a number of naval designers considered the important weapons of naval combat. There is no clear end to the ironclad period, but towards the end of the 1890s the term ironclad dropped out of use. New ships were increasingly constructed to a standard pattern and designated battleships or armored cruisers.",
        "title": "Ironclad warship"
    },
    "Isaac Newton's College": {
        "image": "Isaac Newton.jpg",
        "summary": "Sir Isaac Newton  ( 25 December 1642 \u2013 20 March 1726/27) was an English mathematician, astronomer, theologian and physicist (described in his own day as a \"natural philosopher\") who is widely recognised as one of the most influential scientists of all time and a key figure in the scientific revolution. His book Philosophi\u00e6 Naturalis Principia Mathematica (\"Mathematical Principles of Natural Philosophy\"), first published in 1687, laid the foundations of classical mechanics. Newton also made pathbreaking contributions to optics, and he shares credit with Gottfried Wilhelm Leibniz for developing the infinitesimal calculus.\nNewton's Principia formulated the laws of motion and universal gravitation that dominated scientists' view of the physical universe for the next three centuries. By deriving Kepler's laws of planetary motion from his mathematical description of gravity, and using the same principles to account for the trajectories of comets, the tides, the precession of the equinoxes, and other phenomena, Newton removed the last doubts about the validity of the heliocentric model of the Solar System and demonstrated that the motion of objects on Earth and of celestial bodies could be accounted for by the same principles. Newton's theoretical prediction that the Earth is shaped as an oblate spheroid was later vindicated by the geodetic measurements of Maupertuis, La Condamine, and others, thus convincing most Continental European scientists of the superiority of Newtonian mechanics over the earlier system of Descartes.\nNewton also built the first practical reflecting telescope and developed a sophisticated theory of colour based on the observation that a prism decomposes white light into the colours of the visible spectrum. Newton's work on light was collected in his highly influential book Opticks, first published in 1704. He also formulated an empirical law of cooling, made the first theoretical calculation of the speed of sound, and introduced the notion of a Newtonian fluid. In addition to his work on calculus, as a mathematician Newton contributed to the study of power series, generalised the binomial theorem to non-integer exponents, developed a method for approximating the roots of a function, and classified most of the cubic plane curves.\nNewton was a fellow of Trinity College and the second Lucasian Professor of Mathematics at the University of Cambridge. He was a devout but unorthodox Christian, who privately rejected the doctrine of the Trinity and who, unusually for a member of the Cambridge faculty of the day, refused to take holy orders in the Church of England. Beyond his work on the mathematical sciences, Newton dedicated much of his time to the study of alchemy and biblical chronology, but most of his work in those areas remained unpublished until long after his death. Politically and personally tied to the Whig party, Newton served two brief terms as Member of Parliament for the University of Cambridge, in 1689\u201390 and 1701\u201302. He was knighted by Queen Anne in 1705 and he spent the last three decades of his life in London, serving as Warden (1696\u20131700) and Master (1700\u20131727) of the Royal Mint, as well as president of the Royal Society (1703\u20131727).",
        "title": "Isaac Newton"
    },
    "J.S. Bach's Cathedral": {
        "image": "Johann Sebastian Bach.jpg",
        "summary": "Johann Sebastian Bach (31 March [O.S. 21 March] 1685 \u2013 28 July 1750) was a German composer and musician of the Baroque period. He is known for instrumental compositions such as the Brandenburg Concertos and the Goldberg Variations, and vocal music such as the St Matthew Passion and the Mass in B minor. Since the 19th-century Bach Revival he has been generally regarded as one of the greatest composers of all time.\nThe Bach family already counted several composers when Johann Sebastian was born as the last child of a city musician in Eisenach. Having become an orphan at age 10, he lived for five years with his eldest brother, after which he continued his musical formation in L\u00fcneburg. From 1703 he was back in Thuringia, working as a musician for Protestant churches in Arnstadt and M\u00fchlhausen and, for longer stretches of time, at courts in Weimar\u2014where he expanded his repertoire for the organ\u2014and K\u00f6then\u2014where he was mostly engaged with chamber music. From 1723 he was employed as Thomaskantor (cantor at St. Thomas) in Leipzig. He composed music for the principal Lutheran churches of the city, and for its university's student ensemble Collegium Musicum. From 1726 he published some of his keyboard and organ music. In Leipzig, as had happened in some of his earlier positions, he had a difficult relation with his employer, a situation that was little remedied when he was granted the title of court composer by the Elector of Saxony and King of Poland in 1736. In the last decades of his life he reworked and extended many of his earlier compositions. He died of complications after eye surgery in 1750.\nBach enriched established German styles through his mastery of counterpoint, harmonic and motivic organisation, and his adaptation of rhythms, forms, and textures from abroad, particularly from Italy and France. Bach's compositions include hundreds of cantatas, both sacred and secular. He composed Latin church music, Passions, oratorios and motets. He often adopted Lutheran hymns, not only in his larger vocal works, but for instance also in his four-part chorales and his sacred songs. He wrote extensively for organ and for other keyboard instruments. He composed concertos, for instance for violin and for harpsichord, and suites, as chamber music as well as for orchestra. Many of his works employ the genres of canon and fugue.\nThroughout the 18th century Bach was primarily valued as an organist, while his keyboard music, such as The Well-Tempered Clavier, was appreciated for its didactic qualities. The 19th century saw the publication of some major Bach-biographies, and by the end of that century all of his known music had been printed. Dissemination of scholarship on the composer continued through periodicals and websites exclusively devoted to him, and other publications such as the Bach-Werke-Verzeichnis (BWV, a numbered catalogue of his works) and new critical editions of his compositions. His music was further popularised through a multitude of arrangements, including for instance the Air on the G String, and of recordings, for instance three different box sets with complete performances of the composer's oeuvre marking the 250th anniversary of his death.",
        "title": "Johann Sebastian Bach"
    },
    "King Richard's Crusade": {
        "image": "Third Crusade.jpg",
        "summary": "The Third Crusade (1189\u20131192), also known as The Kings' Crusade, was an attempt by European leaders to reconquer the Holy Land from Saladin (\u1e62al\u0101\u1e25 ad-D\u012bn Y\u016bsuf ibn Ayy\u016bb). The campaign was largely successful in capturing the important cities of Acre and Jaffa, and reversing most of Saladin's conquests, but it failed to capture Jerusalem, the emotional and spiritual motivation of the Crusade.\nAfter the failure of the Second Crusade, the Zengid dynasty controlled a unified Syria and engaged in a conflict with the Fatimid rulers of Egypt. The Egyptian and Syrian forces were ultimately unified under Saladin, who employed them to reduce the Christian states and recapture Jerusalem in 1187. Spurred by religious zeal, King Henry II of England and King Philip II of France (known as Philip Augustus) ended their conflict with each other to lead a new crusade. The death of Henry in 1189, however, meant the English contingent came under the command of his successor, King Richard I of England (known as Richard the Lionheart, in French C\u0153ur de Lion). The elderly Holy Roman Emperor Frederick Barbarossa also responded to the call to arms, leading a massive army across Anatolia, but he drowned in a river in Asia Minor on 10 June 1190 before reaching the Holy Land. His death caused tremendous grief among the German Crusaders, and most of his troops returned home.\nAfter the Crusaders had driven the Muslims from Acre, Philip in company with Frederick's successor, Leopold V, Duke of Austria (known as Leopold the Virtuous), left the Holy Land in August 1191. On 2 September 1192, Richard and Saladin finalized a treaty granting Muslim control over Jerusalem but allowing unarmed Christian pilgrims and merchants to visit the city. Richard departed the Holy Land on 9 October. The successes of the Third Crusade allowed the Crusaders to maintain considerable states in Cyprus and on the Syrian coast. However, the failure to recapture Jerusalem would lead to the Fourth Crusade.",
        "title": "Third Crusade"
    },
    "Knights": {
        "image": "Knight.jpg",
        "summary": "A knight is a person granted an honorary title of knighthood by a monarch or other political leader for service to the monarch or country, especially in a military capacity. Historically, in Europe, knighthood was conferred upon mounted warriors. During the High Middle Ages, knighthood was considered a class of lower nobility. By the Late Middle Ages, the rank had become associated with the ideals of chivalry, a code of conduct for the perfect courtly Christian warrior. Often, a knight was a vassal who served as a fighter for a lord, with payment in the form of land holdings. The lords trusted the knights, who were skilled in battle on horseback.\nKnighthood in the Middle Ages was closely linked with horsemanship (and especially the joust) from its origins in the 12th century until its final flowering as a fashion among the high nobility in the Duchy of Burgundy in the 15th century. This linkage is reflected in the etymology of chivalry, cavalier and related terms (see Etymology section below). The special prestige accorded to mounted warriors finds a parallel in the furusiyya in the Muslim world, and the Greek hippeus (\u1f31\u03c0\u03c0\u03b5\u03cd\u03c2) and Roman eques of classical antiquity.\nIn the late medieval period, new methods of warfare began to render classical knights in armour obsolete, but the titles remained in many nations. Today, a number of orders of knighthood continue to exist in several countries, such as the English Order of the Garter, the Swedish Royal Order of the Seraphim, and the Royal Norwegian Order of St. Olav. Each of these orders has its own criteria for eligibility, but knighthood is generally granted by a head of state or monarch to selected persons to recognise some meritorious achievement, as in the British honours system, often for non-military service to the country. The modern female equivalent in the United Kingdom is Dame.\nHistorically, the ideals of chivalry were popularized in medieval literature, particularly the literary cycles known as the Matter of France, relating to the legendary companions of Charlemagne, and the Matter of Britain, relating to the legend of King Arthur.",
        "title": "Knight"
    },
    "Labor Union": {
        "image": "Trade union.jpg",
        "summary": "A trade union or trades union, also called a labour union (Canada) or labor union (US), is an organization of workers who have come together to achieve common goals such as protecting the integrity of its trade, improving safety standards, achieving higher pay and benefits such as health care and retirement, increasing the number of employees an employer assigns to complete the work, and better working conditions. The trade union, through its leadership, bargains with the employer on behalf of union members (rank and file members) and negotiates labour contracts (collective bargaining) with employers. The most common purpose of these associations or unions is \"maintaining or improving the conditions of their employment\". This may include the negotiation of wages, work rules, complaint procedures, rules governing hiring, firing and promotion of workers, benefits, workplace safety and policies.\nUnions may organize a particular section of skilled workers (craft unionism), a cross-section of workers from various trades (general unionism), or attempt to organize all workers within a particular industry (industrial unionism). The agreements negotiated by a union are binding on the rank and file members and the employer and in some cases on other non-member workers. Trade unions traditionally have a constitution which details the governance of their bargaining unit and also have governance at various levels of government depending on the industry that binds them legally to their negotiations and functioning.\nOriginating in Great Britain, trade unions became popular in many countries during the Industrial Revolution. Trade unions may be composed of individual workers, professionals, past workers, students, apprentices or the unemployed. Trade union density, or the percentage of workers belonging to a trade union, is highest in the Nordic countries.",
        "title": "Trade union"
    },
    "Laser": {
        "image": "Laser.jpg",
        "summary": "A laser is a device that emits light through a process of optical amplification based on the stimulated emission of electromagnetic radiation. The term \"laser\" originated as an acronym for \"light amplification by stimulated emission of radiation\". The first laser was built in 1960 by Theodore H. Maiman at Hughes Research Laboratories, based on theoretical work by Charles Hard Townes and Arthur Leonard Schawlow.\nA laser differs from other sources of light in that it emits light coherently, spatially and temporally. Spatial coherence allows a laser to be focused to a tight spot, enabling applications such as laser cutting and lithography. Spatial coherence also allows a laser beam to stay narrow over great distances (collimation), enabling applications such as laser pointers. Lasers can also have high temporal coherence, which allows them to emit light with a very narrow spectrum, i.e., they can emit a single color of light. Temporal coherence can be used to produce pulses of light as short as a femtosecond.\nAmong their many applications, lasers are used in optical disk drives, laser printers, and barcode scanners DNA sequencing instruments, fiber-optic and free-space optical communication laser surgery and skin treatments cutting and welding materials military and law enforcement devices for marking targets and measuring range and speed and laser lighting displays in entertainment.",
        "title": "Laser"
    },
    "Leader": {
        "image": "Leadership.jpg",
        "summary": "Leadership is both a research area and a practical skill encompassing the ability of an individual or organization to \"lead\" or guide other individuals, teams, or entire organizations. The literature debates various viewpoints: contrasting Eastern and Western approaches to leadership, and also (within the West) US vs. European approaches. US academic environments define leadership as \"a process of social influence in which a person can enlist the aid and support of others in the accomplishment of a common task\". Leadership seen from a European and non-academic perspective encompasses a view of a leader who can be moved not only by communitarian goals but also by the search for personal power. Leadership can derive from a combination of several factors, as the European researcher Daniele Trevisani highlights:\n\n\"Leadership is a holistic spectrum that can arise from: (1) higher levels of physical power, need to display power and control others, force superiority, ability to generate fear, or group-member's need for a powerful group protector (Primal Leadership), (2) superior mental energies, superior motivational forces, perceivable in communication and behaviors, lack of fear, courage, determination (Psychoenergetic Leadership), (3) higher abilities in managing the overall picture (Macro-Leadership), (4) higher abilities in specialized tasks (Micro-Leadership), (5) higher ability in managing the execution of a task (Project Leadership), and (6) higher level of values, wisdom, and spirituality (Spiritual Leadership), where any Leader derives its Leadership Style from a unique mix of one or more of the former factors\".\n\nStudies of leadership have produced theories involving traits, situational interaction, function, behavior, power, vision and values, charisma, and intelligence, among others.",
        "title": "Leadership"
    },
    "Leadership": {
        "image": "Leadership.jpg",
        "summary": "Leadership is both a research area and a practical skill encompassing the ability of an individual or organization to \"lead\" or guide other individuals, teams, or entire organizations. The literature debates various viewpoints: contrasting Eastern and Western approaches to leadership, and also (within the West) US vs. European approaches. US academic environments define leadership as \"a process of social influence in which a person can enlist the aid and support of others in the accomplishment of a common task\". Leadership seen from a European and non-academic perspective encompasses a view of a leader who can be moved not only by communitarian goals but also by the search for personal power. Leadership can derive from a combination of several factors, as the European researcher Daniele Trevisani highlights:\n\n\"Leadership is a holistic spectrum that can arise from: (1) higher levels of physical power, need to display power and control others, force superiority, ability to generate fear, or group-member's need for a powerful group protector (Primal Leadership), (2) superior mental energies, superior motivational forces, perceivable in communication and behaviors, lack of fear, courage, determination (Psychoenergetic Leadership), (3) higher abilities in managing the overall picture (Macro-Leadership), (4) higher abilities in specialized tasks (Micro-Leadership), (5) higher ability in managing the execution of a task (Project Leadership), and (6) higher level of values, wisdom, and spirituality (Spiritual Leadership), where any Leader derives its Leadership Style from a unique mix of one or more of the former factors\".\n\nStudies of leadership have produced theories involving traits, situational interaction, function, behavior, power, vision and values, charisma, and intelligence, among others.",
        "title": "Leadership"
    },
    "Legion": {
        "image": "Roman legion.jpg",
        "summary": "A Roman legion (from Latin legio \"military levy, conscription\", from legere \"to choose\") was the largest unit of the Roman army, evolving from 3000 men in early times to over 5200 men in imperial times, consisting of centuries as the basic units. Until the middle of the first century, 10 cohorts (about 5,000 men) made up a Roman Legion. This was later changed to nine cohorts of standard size (with 6 centuries at 80 men each) and one cohort, the first cohort, of double strength (5 double-strength centuries with 160 men each).\nIn the early Roman Kingdom the \"legion\" may have meant the entire Roman army but sources on this period are few and unreliable. The subsequent organization of legions varied greatly over time but legions were typically composed of around five thousand soldiers, divided during the republican era into three lines of ten maniples, and from about 100 BC into ten cohorts. Legions also included a small ala or cavalry unit. By the third century AD, the legion was a much smaller unit of about 1,000 to 1,500 men, and there were more of them. In the fourth century AD, East Roman border guard legions (limitanei) may have become even smaller.\nFor most of the Roman Imperial period, the legions formed the Roman army's elite heavy infantry, recruited exclusively from Roman citizens, while the remainder of the army consisted of auxiliaries, who provided additional infantry and the vast majority of the Roman army's cavalry. (Provincials who aspired to citizenship gained it when honourably discharged from the auxiliaries). The Roman army, for most of the Imperial period, consisted mostly of auxiliaries rather than legions.\nMany of the legions founded before 40 BC were still active until at least the fifth century, notably Legio V Macedonica, which was founded by Augustus in 43 BC and was in Egypt in the seventh century during the Islamic conquest of Egypt.",
        "title": "Roman legion"
    },
    "Leonardo's Workshop": {
        "image": "Leonardo da Vinci.jpg",
        "summary": "Leonardo di ser Piero da Vinci (Italian: [leo\u02c8nardo di \u02ccs\u025br \u02c8pj\u025b\u02d0ro da (v)\u02c8vint\u0283i] ( listen) 15 April 1452 \u2013 2 May 1519), more commonly Leonardo da Vinci or simply Leonardo, was an Italian Renaissance polymath whose areas of interest included invention, painting, sculpting, architecture, science, music, mathematics, engineering, literature, anatomy, geology, astronomy, botany, writing, history, and cartography. He has been variously called the father of palaeontology, ichnology, and architecture, and is widely considered one of the greatest painters of all time. Sometimes credited with the inventions of the parachute, helicopter and tank, he epitomised the Renaissance humanist ideal.\nMany historians and scholars regard Leonardo as the prime exemplar of the \"Universal Genius\" or \"Renaissance Man\", an individual of \"unquenchable curiosity\" and \"feverishly inventive imagination\". According to art historian Helen Gardner, the scope and depth of his interests were without precedent in recorded history, and \"his mind and personality seem to us superhuman, while the man himself mysterious and remote\". Marco Rosci notes that while there is much speculation regarding his life and personality, his view of the world was logical rather than mysterious, and that the empirical methods he employed were unorthodox for his time.\nBorn out of wedlock to a notary, Piero da Vinci, and a peasant woman, Caterina, in Vinci in the region of Florence, Leonardo was educated in the studio of the renowned Florentine painter Andrea del Verrocchio. Much of his earlier working life was spent in the service of Ludovico il Moro in Milan. He later worked in Rome, Bologna and Venice, and he spent his last years in France at the home awarded to him by Francis I of France.\nLeonardo was, and is, renowned primarily as a painter. Among his works, the Mona Lisa is the most famous and most parodied portrait and The Last Supper the most reproduced religious painting of all time. Leonardo's drawing of the Vitruvian Man is also regarded as a cultural icon, being reproduced on items as varied as the euro coin, textbooks, and T-shirts. Perhaps fifteen of his paintings have survived. Nevertheless, these few works, together with his notebooks, which contain drawings, scientific diagrams, and his thoughts on the nature of painting, compose a contribution to later generations of artists rivalled only by that of his contemporary, Michelangelo.\nLeonardo is revered for his technological ingenuity. He conceptualised flying machines, a type of armoured fighting vehicle, concentrated solar power, an adding machine, and the double hull. Relatively few of his designs were constructed or even feasible during his lifetime, as the modern scientific approaches to metallurgy and engineering were only in their infancy during the Renaissance. Some of his smaller inventions, however, such as an automated bobbin winder and a machine for testing the tensile strength of wire, entered the world of manufacturing unheralded. A number of Leonardo's most practical inventions are nowadays displayed as working models at the Museum of Vinci. He made substantial discoveries in anatomy, civil engineering, geology, optics, and hydrodynamics, but he did not publish his findings and they had no direct influence on later science.\nToday, Leonardo is widely considered one of the most diversely talented individuals ever to have lived.",
        "title": "Leonardo da Vinci"
    },
    "Library": {
        "image": "Library.jpg",
        "summary": "A library is a collection of sources of information and similar resources, made accessible to a defined community for reference or borrowing. It provides physical or digital access to material, and may be a physical building or room, or a virtual space, or both. A library's collection can include books, periodicals, newspapers, manuscripts, films, maps, prints, documents, microform, CDs, cassettes, videotapes, DVDs, Blu-ray Discs, e-books, audiobooks, databases, and other formats. Libraries range in size from a few shelves of books to several million items. In Latin and Greek, the idea of a bookcase is represented by Bibliotheca and Biblioth\u0113k\u0113 (Greek: \u03b2\u03b9\u03b2\u03bb\u03b9\u03bf\u03b8\u03ae\u03ba\u03b7): derivatives of these mean library in many modern languages, e.g. French biblioth\u00e8que.\nThe first libraries consisted of archives of the earliest form of writing\u2014the clay tablets in cuneiform script discovered in Sumer, some dating back to 2600 BC. Private or personal libraries made up of written books appeared in classical Greece in the 5th century BC. In the 6th century, at the very close of the Classical period, the great libraries of the Mediterranean world remained those of Constantinople and Alexandria.\nA library is organized for use and maintained by a public body, an institution, a corporation, or a private individual. Public and institutional collections and services may be intended for use by people who choose not to\u2014or cannot afford to\u2014purchase an extensive collection themselves, who need material no individual can reasonably be expected to have, or who require professional assistance with their research. In addition to providing materials, libraries also provide the services of librarians who are experts at finding and organizing information and at interpreting information needs. Libraries often provide quiet areas for studying, and they also often offer common areas to facilitate group study and collaboration. Libraries often provide public facilities for access to their electronic resources and the Internet. Modern libraries are increasingly being redefined as places to get unrestricted access to information in many formats and from many sources. They are extending services beyond the physical walls of a building, by providing material accessible by electronic means, and by providing the assistance of librarians in navigating and analyzing very large amounts of information with a variety of digital tools.",
        "title": "Library"
    },
    "Lighthouse": {
        "image": "Lighthouse.jpg",
        "summary": "A lighthouse is a tower, building, or other type of structure designed to emit light from a system of lamps and lenses, and to serve as a navigational aid for maritime pilots at sea or on inland waterways.\nLighthouses mark dangerous coastlines, hazardous shoals, reefs, and safe entries to harbors, and can assist in aerial navigation. Once widely used, the number of operational lighthouses has declined due to the expense of maintenance and use of electronic navigational systems.",
        "title": "Lighthouse"
    },
    "Literacy": {
        "image": "Literacy.jpg",
        "summary": "Literacy is traditionally meant as the ability to read, write, and use arithmetic. The modern term's meaning has been expanded to include the ability to use language, numbers, images, computers, and other basic means to understand, communicate, gain useful knowledge and use the dominant symbol systems of a culture. The concept of literacy is expanding in OECD countries to include skills to access knowledge through technology and ability to assess complex contexts. A person who travels and resides in a foreign country but is unable to read or write in the language of the host country would also be regarded by the locals as being illiterate.\nThe key to literacy is reading development, a progression of skills that begins with the ability to understand spoken words and decode written words, and culminates in the deep understanding of text. Reading development involves a range of complex language underpinnings including awareness of speech sounds (phonology), spelling patterns (orthography), word meaning (semantics), grammar (syntax) and patterns of word formation (morphology), all of which provide a necessary platform for reading fluency and comprehension. Literacy takes place from birth to age three. If the time frame from birth to age three is missed it will be harder for literacy to take place\nOnce these skills are acquired, the reader can attain full language literacy, which includes the abilities to apply to printed material critical analysis, inference and synthesis to write with accuracy and coherence and to use information and insights from text as the basis for informed decisions and creative thought. The inability to do so is called illiteracy or analphabetism.\nThe United Nations Educational, Scientific and Cultural Organization (UNESCO) defines literacy as the \"ability to identify, understand, interpret, create, communicate and compute, using printed and written materials associated with varying contexts. Literacy involves a continuum of learning in enabling individuals to achieve their goals, to develop their knowledge and potential, and to participate fully in their community and wider society\".",
        "title": "Literacy"
    },
    "Machine Tools": {
        "image": "Machine tool.jpg",
        "summary": "A machine tool is a machine for shaping or machining metal or other rigid materials, usually by cutting, boring, grinding, shearing, or other forms of deformation. Machine tools employ some sort of tool that does the cutting or shaping. All machine tools have some means of constraining the workpiece and provide a guided movement of the parts of the machine. Thus the relative movement between the workpiece and the cutting tool (which is called the toolpath) is controlled or constrained by the machine to at least some extent, rather than being entirely \"offhand\" or \"freehand\".\nThe precise definition of the term machine tool varies among users, as discussed below. While all machine tools are \"machines that help people to make things\", not all factory machines are machine tools.\nToday machine tools are typically powered other than by human muscle (e.g., electrically, hydraulically, or via line shaft), used to make manufactured parts (components) in various ways that include cutting or certain other kinds of deformation.\nWith their inherent precision, machine tools enabled the economical production of interchangeable parts.",
        "title": "Machine tool"
    },
    "Magellan's Expedition": {
        "image": "Ferdinand Magellan.jpg",
        "summary": "Ferdinand Magellan ( or  Portuguese: Fern\u00e3o de Magalh\u00e3es, IPA: [f\u0268\u027e\u02c8n\u0250\u0303w d\u0268 m\u0250\u0263\u0250\u02c8\u028e\u0250\u0303j\u0283] Spanish: Fernando de Magallanes, IPA: [fer\u02c8nando \u00f0e ma\u0263a\u02c8\u028eanes] c. 1480 \u2013 27 April 1521) was a Portuguese explorer who organised the Spanish expedition to the East Indies from 1519 to 1522, resulting in the first circumnavigation of the Earth, completed by Juan Sebasti\u00e1n Elcano.\nBorn into a Portuguese noble family in around 1480, Magellan became a skilled sailor and naval officer and was eventually selected by King Charles I of Spain to search for a westward route to the Maluku Islands (the \"Spice Islands\"). Commanding a fleet of five vessels, he headed south through the Atlantic Ocean to Patagonia, passing through the Strait of Magellan into a body of water he named the \"peaceful sea\" (the modern Pacific Ocean). Despite a series of storms and mutinies, the expedition reached the Spice Islands in 1521 and returned home via the Indian Ocean to complete the first circuit of the globe. Magellan did not complete the entire voyage, as he was killed during the Battle of Mactan in the Philippines in 1521.\nMagellan had already reached the Malay Archipelago in Southeast Asia on previous voyages traveling east (from 1505 to 1511-1512). By visiting this area again but now travelling west, Magellan achieved a nearly complete personal circumnavigation of the globe for the first time in history.\nThe Magellanic penguin is named after him, as he was the first European to note it. Magellan's navigational skills have also been acknowledged in the naming of objects associated with the stars, including the Magellanic Clouds, now known to be two nearby dwarf galaxies the twin lunar craters of Magelhaens and Magelhaens A and the Martian crater of Magelhaens.",
        "title": "Ferdinand Magellan"
    },
    "Magnetism": {
        "image": "Magnetism.jpg",
        "summary": "Magnetism is a class of physical phenomena that are mediated by magnetic fields. Electric currents and the magnetic moments of elementary particles give rise to a magnetic field, which acts on other currents and magnetic moments. The most familiar effects occur in ferromagnetic materials, which are strongly attracted by magnetic fields and can be magnetized to become permanent magnets, producing magnetic fields themselves. Only a few substances are ferromagnetic the most common ones are iron, nickel and cobalt and their alloys. The prefix ferro- refers to iron, because permanent magnetism was first observed in lodestone, a form of natural iron ore called magnetite, Fe3O4.\nAlthough ferromagnetism is responsible for most of the effects of magnetism encountered in everyday life, all other materials are influenced to some extent by a magnetic field, by several other types of magnetism. Paramagnetic substances such as aluminum and oxygen are weakly attracted to an applied magnetic field diamagnetic substances such as copper and carbon are weakly repelled while antiferromagnetic materials such as chromium and spin glasses have a more complex relationship with a magnetic field. The force of a magnet on paramagnetic, diamagnetic, antiferromagnetic materials is usually too weak to be felt, and can be detected only by laboratory instruments, so in everyday life these substances are often described as non-magnetic.\nThe magnetic state (or magnetic phase) of a material depends on temperature and other variables such as pressure and the applied magnetic field. A material may exhibit more than one form of magnetism as these variables change.",
        "title": "Magnetism"
    },
    "Manhattan Project": {
        "image": "Manhattan Project.jpg",
        "summary": "The Manhattan Project was a research and development undertaking during World War II that produced the first nuclear weapons. It was led by the United States with the support of the United Kingdom and Canada. From 1942 to 1946, the project was under the direction of Major General Leslie Groves of the U.S. Army Corps of Engineers. Nuclear physicist Robert Oppenheimer was the director of the Los Alamos Laboratory that designed the actual bombs. The Army component of the project was designated the Manhattan District \"Manhattan\" gradually superseded the official codename, Development of Substitute Materials, for the entire project. Along the way, the project absorbed its earlier British counterpart, Tube Alloys. The Manhattan Project began modestly in 1939, but grew to employ more than 130,000 people and cost nearly US $2 billion (about $27 billion in 2016 dollars). Over 90% of the cost was for building factories and to produce fissile material, with less than 10% for development and production of the weapons. Research and production took place at more than 30 sites across the United States, the United Kingdom, and Canada.\nTwo types of atomic bombs were developed concurrently during the war: a relatively simple gun-type fission weapon and a more complex implosion-type nuclear weapon. The Thin Man gun-type design proved impractical to use with plutonium so a simpler gun-type called Little Boy was developed that used uranium-235, an isotope that makes up only 0.7 percent of natural uranium. Chemically identical to the most common isotope, uranium-238, and with almost the same mass, it proved difficult to separate the two. Three methods were employed for uranium enrichment: electromagnetic, gaseous and thermal. Most of this work was performed at the Clinton Engineer Works at Oak Ridge, Tennessee.\nIn parallel with the work on uranium was an effort to produce plutonium. After the feasibility of the world's first artificial nuclear reactor was demonstrated in Chicago at the Metallurgical Laboratory, it designed the X-10 Graphite Reactor at Oak Ridge and the production reactors in Hanford, Washington, in which uranium was irradiated and transmuted into plutonium. The plutonium was then chemically separated from the uranium. The Fat Man implosion-type weapon was developed in a concerted design and development effort by the Los Alamos Laboratory.\nThe project was also charged with gathering intelligence on the German nuclear weapon project. Through Operation Alsos, Manhattan Project personnel served in Europe, sometimes behind enemy lines, where they gathered nuclear materials and documents, and rounded up German scientists. Despite the Manhattan Project's tight security, Soviet atomic spies successfully penetrated the program.\nThe first nuclear device ever detonated was an implosion-type bomb at the Trinity test, conducted at New Mexico's Alamogordo Bombing and Gunnery Range on 16 July 1945. Little Boy and Fat Man bombs were used a month later in the atomic bombings of Hiroshima and Nagasaki, respectively. In the immediate postwar years, the Manhattan Project conducted weapons testing at Bikini Atoll as part of Operation Crossroads, developed new weapons, promoted the development of the network of national laboratories, supported medical research into radiology and laid the foundations for the nuclear navy. It maintained control over American atomic weapons research and production until the formation of the United States Atomic Energy Commission in January 1947.",
        "title": "Manhattan Project"
    },
    "Map Making": {
        "image": "Cartography.jpg",
        "summary": "Cartography (from Greek \u03c7\u03ac\u03c1\u03c4\u03b7\u03c2 khart\u0113s, \"papyrus, sheet of paper, map\" and \u03b3\u03c1\u03ac\u03c6\u03b5\u03b9\u03bd graphein, \"write\") is the study and practice of making maps. Combining science, aesthetics, and technique, cartography builds on the premise that reality can be modeled in ways that communicate spatial information effectively.\nThe fundamental problems of traditional cartography are to:\nSet the map's agenda and select traits of the object to be mapped. This is the concern of map editing. Traits may be physical, such as roads or land masses, or may be abstract, such as toponyms or political boundaries.\nRepresent the terrain of the mapped object on flat media. This is the concern of map projections.\nEliminate characteristics of the mapped object that are not relevant to the map's purpose. This is the concern of generalization.\nReduce the complexity of the characteristics that will be mapped. This is also the concern of generalization.\nOrchestrate the elements of the map to best convey its message to its audience. This is the concern of map design.\nModern cartography constitutes many theoretical and practical foundations of geographic information systems.",
        "title": "Cartography"
    },
    "Marco Polo's Embassy": {
        "image": "Marco Polo.jpg",
        "summary": "Marco Polo ( ( listen) Italian: [\u02c8marko \u02c8p\u0254\u02d0lo] Venetian: [\u02c8ma\u027eko \u02c8po.lo] 1254 \u2013 January 8\u20139, 1324) was a Venetian merchant, explorer, and writer. His travels are recorded in Livres des merveilles du monde (Book of the Marvels of the World, also known as The Travels of Marco Polo, c. 1300), a book that described to Europeans the wealth and great size of China, its capital Peking, and other Asian cities and countries.\nHe learned the mercantile trade from his father and his uncle, Niccol\u00f2 and Maffeo, who travelled through Asia and met Kublai Khan. In 1269, they returned to Venice to meet Marco for the first time. The three of them embarked on an epic journey to Asia, returning after 24 years to find Venice at war with Genoa Marco was imprisoned and dictated his stories to a cellmate. He was released in 1299, became a wealthy merchant, married, and had three children. He died in 1324 and was buried in the church of San Lorenzo in Venice.\nMarco Polo was not the first European to reach China (see Europeans in Medieval China), but he was the first to leave a detailed chronicle of his experience. This book inspired Christopher Columbus and many other travellers. There is a substantial literature based on Polo's writings he also influenced European cartography, leading to the introduction of the Fra Mauro map.",
        "title": "Marco Polo"
    },
    "Marines": {
        "image": "Marines.jpg",
        "summary": "Marines, also known as a marine corps or naval infantry, are typically an infantry force that specializes in the support of naval and army operations at sea and on land, as well as the execution of their own operations. In the majority of countries, the marine force is part of the navy, but it can also be under the army like the Troupes de marine (French Marines) and Givati Brigade (Israeli Marines), or form an independent service branch like the United States Marine Corps and the Royal Marines (although the United States Marine Corps is under the United States Department of the Navy and the Royal Marines come under Her Majesty's Naval Service respectively).\nHistorically, tasks undertaken by marines have included: helping maintain discipline and order aboard the ship (reflecting the pressed nature of the ships' company and the risk of mutiny), the boarding of vessels during combat or capture of prize ships, and providing manpower for raiding ashore in support of the naval objectives.\nWith the industrialization of warfare in the 20th century the scale of landing operations increased this brought with it an increased likelihood of opposition and a need for co-ordination of various military elements. Marine forces evolved to specialize in the skills and capabilities required for amphibious warfare.",
        "title": "Marines"
    },
    "Marketplace": {
        "image": "Marketplace.jpg",
        "summary": "A market, or marketplace, is a location where people regularly gather for the purchase and sale of provisions, livestock, and other goods. In different parts of the world, a market place may be described as a souk (from the Arabic), bazaar (from the Persian), a fixed mercado (Spanish), or itinerant tianguis (Mexico), or palengke (Philippines). Some markets operate daily and are said to be permanent markets while others are held once a week or on less frequent specified days such as festival days and are said to be periodic markets. The form that a market adopts is depends on its locality's population, culture, ambient and geographic conditions.\nMarkets have existed for as long as humans have engaged in trade. The earliest bazaars are believed to have originated in Persia, from where they spread to the rest of the Middle East and Europe. Documentary sources suggest that zoning policies confined trading to particular parts of cities from around 3,000 BCE, creating the conditions necessary for the emergence of a bazaar. Middle Eastern bazaars were typically long strips with stalls on either side and a covered roof designed to protect traders and purchasers from the fierce sun. In Europe, informal, unregulated markets gradually made way for a system of formal, chartered markets from the 12th century. Throughout the Medieval period, increased regulation of marketplace practices, especially weights and measures, gave consumers confidence in the quality of market goods and the fairness of prices. Around the globe, markets have evolved in different ways depending on local ambient conditions, especially weather, tradition and culture. In the Middle East, markets tend to be covered, to protect traders and shoppers from the sun. In milder climates, markets are often open air. In Asia, a system of morning markets trading in fresh produce and night markets trading in non-perishables is common.\nIn many countries, shopping at a local market is a standard feature of daily life. Given the market's role in ensuring food supply for a population, markets are often highly regulated by a central authority. In many places, designated market places have become listed sites of historic and architectural significance and represent part of a town or nation's cultural assets. For these reasons, they are often popular tourist destinations.",
        "title": "Marketplace"
    },
    "Masonry": {
        "image": "Masonry.jpg",
        "summary": "Masonry is the building of structures from individual units, which are often laid in and bound together by mortar the term masonry can also refer to the units themselves. The common materials of masonry construction are brick, building stone such as marble, granite, travertine, and limestone, cast stone, concrete block, glass block, and adobe. Masonry is generally a highly durable form of construction. However, the materials used, the quality of the mortar and workmanship, and the pattern in which the units are assembled can substantially affect the durability of the overall masonry construction. A person who constructs masonry is called a mason or bricklayer.",
        "title": "Masonry"
    },
    "Mass Production": {
        "image": "Mass production.jpg",
        "summary": "Mass production, also known as flow production or continuous production, is the production of large amounts of standardized products, including and especially on assembly lines. Together with job production and batch production, it is one of the three main production methods.\nThe term mass production was popularized by a 1926 article in the Encyclop\u00e6dia Britannica supplement that was written based on correspondence with Ford Motor Company. The New York Times used the term in the title of an article that appeared before publication of the Britannica article.\nThe concepts of mass production are applied to various kinds of products, from fluids and particulates handled in bulk (such as food, fuel, chemicals, and mined minerals) to discrete solid parts (such as fasteners) to assemblies of such parts (such as household appliances and automobiles).\nMass production is a diverse field, but it can generally be contrasted with craft production or distributed manufacturing. Some mass production techniques, such as standardized sizes and production lines, predate the Industrial Revolution by many centuries however, it was not until the introduction of machine tools and techniques to produce interchangeable parts were developed in the mid 19th century that modern mass production was possible.\n\n",
        "title": "Mass production"
    },
    "Mass Transit": {
        "image": "Public transport.jpg",
        "summary": "Public transport (also known as public transportation, public transit, or mass transit) is a shared passenger-transport service which is available for use by the general public, as distinct from modes such as taxicab, carpooling, hired buses, and transportation network companies, which are not shared by the general public without private arrangement.\nPublic transport modes include city buses, trolleybuses, trams (or light rail) and passenger trains, rapid transit (metro/subway/underground, etc.) and ferries. Public transport between cities is dominated by airlines, coaches, and intercity rail. High-speed rail networks are being developed in many parts of the world. Most public transport systems run along fixed routes with set embarkation/disembarkation points to a prearranged timetable, with the most frequent services running to a headway (e.g.: \"every 5 minutes\" as opposed to being scheduled for any specific time of the day). Share taxis offer on-demand services in many parts of the world, and some services will wait until the vehicle is full before it departs. Paratransit is sometimes used in areas of low demand and for people who need a door-to-door service.\nUrban public transit differs distinctly among Asia, North America, and Europe. In Asia, profit-driven, privately-owned and publicly traded mass transit and real estate conglomerates predominantly operate public transit systems  In North America, municipal transit authorities most commonly run mass transit operations. In Europe, both state-owned and private companies predominantly operate mass transit systems, Public transport services can be profit-driven by use of pay-by-the-distance fares or funded by government subsidies in which flat rate fares are charged to each passenger. Services can be fully profitable through high usership numbers and high farebox recovery ratios, or can be regulated and possibly subsidised from local or national tax revenue. Fully subsidised, free of charge services operate in some towns and cities.\nFor geographical, historical and economic reasons, differences exist internationally regarding use and extent of public transport. While countries in the Old World tend to have extensive and frequent systems serving their old and dense cities, many cities of the New World have more sprawl and much less comprehensive public transport. The International Association of Public Transport (UITP) is the international network for public transport authorities and operators, policy decision-makers, scientific institutes and the public transport supply and service industry. It has 3,400 members from 92 countries.",
        "title": "Public transport"
    },
    "Mathematics": {
        "image": "Mathematics.jpg",
        "summary": "Mathematics (from Greek \u03bc\u03ac\u03b8\u03b7\u03bc\u03b1 m\u00e1th\u0113ma, \"knowledge, study, learning\") is the study of objects and their relations. Examples of objects are quantity (numbers), structure, space, and change. There is a range of views among mathematicians and philosophers as to the exact scope and definition of mathematics.\nMathematicians seek out patterns and use them to formulate new conjectures. Mathematicians resolve the truth or falsity of conjectures by mathematical proof. When mathematical structures are good models of real phenomena, then mathematical reasoning can provide insight or predictions about nature. Through the use of abstraction and logic, mathematics developed from counting, calculation, measurement, and the systematic study of the shapes and motions of physical objects. Practical mathematics has been a human activity from as far back as written records exist. The research required to solve mathematical problems can take years or even centuries of sustained inquiry.\nRigorous arguments first appeared in Greek mathematics, most notably in Euclid's Elements. Since the pioneering work of Giuseppe Peano (1858\u20131932), David Hilbert (1862\u20131943), and others on axiomatic systems in the late 19th century, it has become customary to view mathematical research as establishing truth by rigorous deduction from appropriately chosen axioms and definitions. Mathematics developed at a relatively slow pace until the Renaissance, when mathematical innovations interacting with new scientific discoveries led to a rapid increase in the rate of mathematical discovery that has continued to the present day.\nGalileo Galilei (1564\u20131642) said, \"The universe cannot be read until we have learned the language and become familiar with the characters in which it is written. It is written in mathematical language, and the letters are triangles, circles and other geometrical figures, without which means it is humanly impossible to comprehend a single word. Without these, one is wandering about in a dark labyrinth.\" Carl Friedrich Gauss (1777\u20131855) referred to mathematics as \"the Queen of the Sciences\". Benjamin Peirce (1809\u20131880) called mathematics \"the science that draws necessary conclusions\". David Hilbert said of mathematics: \"We are not speaking here of arbitrariness in any sense. Mathematics is not like a game whose tasks are determined by arbitrarily stipulated rules. Rather, it is a conceptual system possessing internal necessity that can only be so and by no means otherwise.\" Albert Einstein (1879\u20131955) stated that \"as far as the laws of mathematics refer to reality, they are not certain and as far as they are certain, they do not refer to reality.\"\nMathematics is essential in many fields, including natural science, engineering, medicine, finance and the social sciences. Applied mathematics has led to entirely new mathematical disciplines, such as statistics and game theory. Mathematicians also engage in pure mathematics, or mathematics for its own sake, without having any application in mind. There is no clear line separating pure and applied mathematics, and practical applications for what began as pure mathematics are often discovered.",
        "title": "Mathematics"
    },
    "Mech. Inf.": {
        "image": "Mechanized infantry.jpg",
        "summary": "Mechanized infantry are infantry equipped with armored personnel carriers (APCs) or infantry fighting vehicles (IFVs) for transport and combat (see also mechanized force).\nMechanized infantry is distinguished from motorized infantry in that its vehicles provide a degree of protection from hostile fire, as opposed to \"soft-skinned\" wheeled vehicles (trucks or jeeps) for motorized infantry. Most APCs and IFVs are fully tracked or are all-wheel drive vehicles (6\u00d76 or 8\u00d78), for mobility across rough ground. Some nations distinguish between mechanized and armored infantry, designating troops carried by APCs as mechanized and those in IFVs as armored.\nThe support weapons for mechanized infantry are also provided with motorized transport, or they are built directly into combat vehicles to keep pace with the mechanized infantry in combat. For units equipped with most types of APC or any type of IFV, fire support weapons, such as machine guns, autocannons, small-bore direct-fire howitzers, and anti-tank guided missiles are often mounted directly on the infantry's own transport vehicles.\nCompared with \"light\" truck-mobile infantry, mechanized infantry can maintain rapid tactical movement and, if mounted in IFVs, have more integral firepower. It requires more combat supplies (ammunition and especially fuel) and ordnance supplies (spare vehicle components), and a comparatively larger proportion of manpower is required to crew and maintain the vehicles. For example, most APCs mount a section of seven or eight infantrymen but have a crew of two. Most IFVs carry only six or seven infantry but require a crew of three. To be effective in the field, mechanized units also require many mechanics, with specialized maintenance and recovery vehicles and equipment.",
        "title": "Mechanized infantry"
    },
    "Medicine": {
        "image": "Medicine.jpg",
        "summary": "Medicine is the science and practice of the diagnosis, treatment, and prevention of disease. Medicine encompasses a variety of health care practices evolved to maintain and restore health by the prevention and treatment of illness. Contemporary medicine applies biomedical sciences, biomedical research, genetics, and medical technology to diagnose, treat, and prevent injury and disease, typically through pharmaceuticals or surgery, but also through therapies as diverse as psychotherapy, external splints and traction, medical devices, biologics, and ionizing radiation, amongst others.\nMedicine has existed for thousands of years, during most of which it was an art (an area of skill and knowledge) frequently having connections to the religious and philosophical beliefs of local culture. For example, a medicine man would apply herbs and say prayers for healing, or an ancient philosopher and physician would apply bloodletting according to the theories of humorism. In recent centuries, since the advent of modern science, most medicine has become a combination of art and science (both basic and applied, under the umbrella of medical science). While stitching technique for sutures is an art learned through practice, the knowledge of what happens at the cellular and molecular level in the tissues being stitched arises through science.\nPrescientific forms of medicine are now known as traditional medicine and folk medicine. They remain commonly used with or instead of scientific medicine and are thus called alternative medicine. For example, evidence on the effectiveness of acupuncture is \"variable and inconsistent\" for any condition, but is generally safe when done by an appropriately trained practitioner. In contrast, treatments outside the bounds of safety and efficacy are termed quackery.",
        "title": "Medicine"
    },
    "Metallurgy": {
        "image": "Metallurgy.jpg",
        "summary": "Metallurgy is a domain of materials science and engineering that studies the physical and chemical behavior of metallic elements, their inter-metallic compounds, and their mixtures, which are called alloys. Metallurgy is also the technology of metals: the way in which science is applied to the production of metals, and the engineering of metal components for usage in products for consumers and manufacturers. The production of metals involves the processing of ores to extract the metal they contain, and the mixture of metals, sometimes with other elements, to produce alloys. Metallurgy is distinguished from the craft of metalworking, although metalworking relies on metallurgy, as medicine relies on medical science, for technical advancement.\nMetallurgy is subdivided into ferrous metallurgy (also known as black metallurgy) and non-ferrous metallurgy (also known as colored metallurgy).\nFerrous metallurgy involves processes and alloys based on iron while non-ferrous metallurgy involves processes and alloys based on other metals. The production of ferrous metals accounts for 95 percent of world metal production.",
        "title": "Metallurgy"
    },
    "Mfg. Plant": {
        "image": "Factory.jpg",
        "summary": "A factory (previously manufactory) or manufacturing plant is an industrial site, usually consisting of buildings and machinery, or more commonly a complex having several buildings, where workers manufacture goods or operate machines processing one product into another.\nFactories arose with the introduction of machinery during the Industrial Revolution when the capital and space requirements became too great for cottage industry or workshops. Early factories that contained small amounts of machinery, such as one or two spinning mules, and fewer than a dozen workers have been called \"glorified workshops\".\nMost modern factories have large warehouses or warehouse-like facilities that contain heavy equipment used for assembly line production. Large factories tend to be located with access to multiple modes of transportation, with some having rail, highway and water loading and unloading facilities.\nFactories may either make discrete products or some type of material continuously produced such as chemicals, pulp and paper, or refined oil products. Factories manufacturing chemicals are often called plants and may have most of their equipment \u2013 tanks, pressure vessels, chemical reactors, pumps and piping \u2013 outdoors and operated from control rooms. Oil refineries have most of their equipment outdoors.\nDiscrete products may be final consumer goods, or parts and sub-assemblies which are made into final products elsewhere. Factories may be supplied parts from elsewhere or make them from raw materials. Continuous production industries typically use heat or electricity to transform streams of raw materials into finished products.\nThe term mill originally referred to the milling of grain, which usually used natural resources such as water or wind power until those were displaced by steam power in the 19th century. Because many processes like spinning and weaving, iron rolling, and paper manufacturing were originally powered by water, the term survives as in steel mill, paper mill, etc.",
        "title": "Factory"
    },
    "Michelangelo's Chapel": {
        "image": "Sistine Chapel.jpg",
        "summary": "The Sistine Chapel ( Latin: Sacellum Sixtinum Italian: Cappella Sistina [kap\u02c8p\u025blla si\u02c8sti\u02d0na]) is a chapel in the Apostolic Palace, the official residence of the Pope, in Vatican City. Originally known as the Cappella Magna, the chapel takes its name from Pope Sixtus IV, who restored it between 1477 and 1480. Since that time, the chapel has served as a place of both religious and functionary papal activity. Today it is the site of the Papal conclave, the process by which a new pope is selected. The fame of the Sistine Chapel lies mainly in the frescos that decorate the interior, and most particularly the Sistine Chapel ceiling and The Last Judgment by Michelangelo.\nDuring the reign of Sixtus IV, a team of Renaissance painters that included Sandro Botticelli, Pietro Perugino, Pinturicchio, Domenico Ghirlandaio and Cosimo Roselli, created a series of frescos depicting the Life of Moses and the Life of Christ, offset by papal portraits above and trompe l\u2019oeil drapery below. These paintings were completed in 1482, and on 15 August 1483 Sixtus IV celebrated the first mass in the Sistine Chapel for the Feast of the Assumption, at which ceremony the chapel was consecrated and dedicated to the Virgin Mary.\nBetween 1508 and 1512, under the patronage of Pope Julius II, Michelangelo painted the chapel's ceiling, a project which changed the course of Western art and is regarded as one of the major artistic accomplishments of human civilization. In a different climate after the Sack of Rome, he returned and between 1535 and 1541, painted The Last Judgment for Popes Clement VII and Paul III. The fame of Michelangelo's paintings has drawn multitudes of visitors to the chapel ever since they were revealed five hundred years ago.",
        "title": "Sistine Chapel"
    },
    "Miniaturization": {
        "image": "Miniaturization.jpg",
        "summary": "Miniaturization (Br.Eng.: Miniaturisation) is the trend to manufacture ever smaller mechanical, optical and electronic products and devices. Examples include miniaturization of mobile phones, computers and vehicle engine downsizing. In electronics, Moore's Law predicted that the number of transistors on an integrated circuit for minimum component cost doubles every 18 months. This enables processors to be built in smaller sizes.\n\n",
        "title": "Miniaturization"
    },
    "Mobile Warfare": {
        "image": "Maneuver warfare.jpg",
        "summary": "Maneuver warfare, or manoeuvre warfare, is a military strategy that advocates attempting to defeat the enemy by incapacitating their decision-making through shock and disruption.",
        "title": "Maneuver warfare"
    },
    "Monarchy": {
        "image": "Monarchy.jpg",
        "summary": "A monarchy is a form of government in which a group, generally a family representing a dynasty, embodies the country's national identity and its head, the monarch, exercises the role of sovereignty. The actual power of the monarch may vary from purely symbolic (crowned republic), to partial and restricted (constitutional monarchy), to completely autocratic (absolute monarchy). Traditionally the monarch's post is inherited and lasts until death or abdication. In contrast, elective monarchies require the monarch to be elected. Both types have further variations as there are widely divergent structures and traditions defining monarchy. For example, in some elected monarchies only pedigrees are taken into account for eligibility of the next ruler, whereas many hereditary monarchies impose requirements regarding the religion, age, gender, mental capacity, etc. Occasionally this might create a situation of rival claimants whose legitimacy is subject to effective election. There have been cases where the term of a monarch's reign is either fixed in years or continues until certain goals are achieved: an invasion being repulsed, for instance.\n\nMonarchic rule was the most common form of government until the 19th century. It is now usually a constitutional monarchy, in which the monarch retains a unique legal and ceremonial role, but exercises limited or no official political power: under the written or unwritten constitution, others have governing authority. Currently, 45 sovereign nations in the world have monarchs acting as heads of state, 16 of which are Commonwealth realms that recognise Queen Elizabeth II as their head of state. Most modern European monarchies are constitutional and hereditary with a largely ceremonial role, with the exception of the Vatican which is an elective theocracy and the Principalities of Liechtenstein and Monaco where the monarchs exercise unrestricted authority. The monarchies of Cambodia and Malaysia are constitutional with a largely ceremonial role, despite possessing significantly more social and legal clout than their European counterparts. The monarchs of Brunei, Morocco, Oman, Qatar, Saudi Arabia and Swaziland have more political influence than any other single source of authority in their nations, either by tradition or a constitutional mandate.",
        "title": "Monarchy"
    },
    "Monotheism": {
        "image": "Monotheism.jpg",
        "summary": "Monotheism has been defined as the belief in the existence of only one god that created the world, is all-powerful and intervenes in the world. A broader definition of monotheism is the belief in one god. A distinction may be made between exclusive monotheism, and both inclusive monotheism and pluriform (panentheistic) monotheism which, while recognising various distinct gods, postulate some underlying unity.\nMonotheism is distinguished from henotheism, a religious system in which the believer worships one god without denying that others may worship different gods with equal validity, and monolatrism, the recognition of the existence of many gods but with the consistent worship of only one deity.\nThe broader definition of monotheism characterizes the traditions of B\u00e1bism, the Bah\u00e1'\u00ed Faith, Cao Dai (Caodaiism), Cheondoism (Cheondogyo), Christianity, Deism, Eckankar, Hindu sects such as Shaivism and Vaishnavism, Islam, Judaism, Mandaeism, Rastafari, Seicho no Ie, Sikhism, Tengrism (Tangrism), Tenrikyo (Tenriism), Yazidism, and Zoroastrianism, and elements of pre-monotheistic thought are found in early religions such as Atenism, Ancient Chinese religion, and Yahwism.",
        "title": "Monotheism"
    },
    "Musketeers": {
        "image": "Musketeer.jpg",
        "summary": "A musketeer (French: mousquetaire) was a type of soldier equipped with a musket. Musketeers were an important part of early modern armies, particularly in Europe and the west, as they normally comprised the majority of their infantry. The musketeer was a precursor to the rifleman. Muskets were replaced by rifles in most western armies during the mid-1850s. The traditional designation of \"musketeer\" for an infantry private survived in the Imperial German Army until World War I.",
        "title": "Musketeer"
    },
    "Mysticism": {
        "image": "Mysticism.jpg",
        "summary": "Mysticism is popularly known as becoming one with God or the Absolute, but may refer to any kind of ecstasy or altered state of consciousness which is given a religious or spiritual meaning. It may also refer to the attainment of insight in ultimate or hidden truths, and to human transformation supported by various practices and experiences.\nThe term \"mysticism\" has Ancient Greek origins with various historically determined meanings. Derived from the Greek word \u03bc\u03c5\u03c9, meaning \"to conceal\", mysticism referred to the biblical liturgical, spiritual, and contemplative dimensions of early and medieval Christianity. During the early modern period, the definition of mysticism grew to include a broad range of beliefs and ideologies related to \"extraordinary experiences and states of mind\".\nIn modern times, \"mysticism\" has acquired a limited definition, with broad applications, as meaning the aim at the \"union with the Absolute, the Infinite, or God\". This limited definition has been applied to a wide range of religious traditions and practices, valuing \"mystical experience\" as a key element of mysticism.\nBroadly defined, mysticism can be found in all religious traditions, from indigenous religions and folk religions like shamanism, to organised religions like the Abrahamic faiths and Indian religions, and modern spirituality, New Age and New Religious Movements.\nSince the 1960s scholars have debated the merits of perennial and constructionist approaches in the scientific research of \"mystical experiences\". The perennial position is now \"largely dismissed by scholars\", most scholars using a contextual approach, which takes the cultural and historical context into consideration.",
        "title": "Mysticism"
    },
    "Navigation": {
        "image": "Navigation.jpg",
        "summary": "Navigation is a field of study that focuses on the process of monitoring and controlling the movement of a craft or vehicle from one place to another. The field of navigation includes four general categories: land navigation, marine navigation, aeronautic navigation, and space navigation.\nIt is also the term of art used for the specialized knowledge used by navigators to perform navigation tasks. All navigational techniques involve locating the navigator's position compared to known locations or patterns.\nNavigation, in a broader sense, can refer to any skill or study that involves the determination of position and direction. In this sense, navigation includes orienteering and pedestrian navigation.",
        "title": "Navigation"
    },
    "Nuclear": {
        "image": "Nuclear weapon.jpg",
        "summary": "A nuclear weapon is an explosive device that derives its destructive force from nuclear reactions, either fission (fission bomb) or from a combination of fission and fusion reactions (thermonuclear bomb). Both bomb types release large quantities of energy from relatively small amounts of matter. The first test of a fission (\"atomic\") bomb released an amount of energy approximately equal to 20,000 tons of TNT (84 TJ). The first thermonuclear (\"hydrogen\") bomb test released energy approximately equal to 10 million tons of TNT (42 PJ). A thermonuclear weapon weighing little more than 2,400 pounds (1,100 kg) can release energy equal to more than 1.2 million tons of TNT (5.0 PJ). A nuclear device no larger than traditional bombs can devastate an entire city by blast, fire, and radiation. Since they are weapons of mass destruction, the proliferation of nuclear weapons is a focus of international relations policy.\nNuclear weapons have been used twice in war, both times by the United States against Japan near the end of World War II. On August 6, 1945, the U.S. Army Air Forces detonated a uranium gun-type fission bomb nicknamed \"Little Boy\" over the Japanese city of Hiroshima three days later, on August 9, the U.S. Army Air Forces detonated a plutonium implosion-type fission bomb nicknamed \"Fat Man\" over the Japanese city of Nagasaki. These bombings resulted in the deaths of approximately 200,000 civilians and military personnel from injuries sustained from the explosions. The ethics of these bombings and their role in Japan's surrender are subjects of debate.\nSince the atomic bombings of Hiroshima and Nagasaki, nuclear weapons have been detonated over two thousand times for testing and demonstration. Only a few nations possess such weapons or are suspected of seeking them. The only countries known to have detonated nuclear weapons\u2014and acknowledge possessing them\u2014are (chronologically by date of first test) the United States, the Soviet Union (succeeded as a nuclear power by Russia), the United Kingdom, France, China, India, Pakistan, and North Korea. Israel is believed to possess nuclear weapons, though, in a policy of deliberate ambiguity, it does not acknowledge having them. Germany, Italy, Turkey, Belgium and the Netherlands are nuclear weapons sharing states. South Africa is the only country to have independently developed and then renounced and dismantled its nuclear weapons.\nThe Treaty on the Non-Proliferation of Nuclear Weapons aims to reduce the spread of nuclear weapons, but its effectiveness has been questioned, and political tensions remained high in the 1970s and 1980s. Modernisation of weapons continues to this day.",
        "title": "Nuclear weapon"
    },
    "Nuclear Fission": {
        "image": "Nuclear fission.jpg",
        "summary": "In nuclear physics and nuclear chemistry, nuclear fission is either a nuclear reaction or a radioactive decay process in which the nucleus of an atom splits into smaller parts (lighter nuclei). The fission process often produces free neutrons and gamma photons, and releases a very large amount of energy even by the energetic standards of radioactive decay.\nNuclear fission of heavy elements was discovered on December 17, 1938 by German Otto Hahn and his assistant Fritz Strassmann, and explained theoretically in January 1939 by Lise Meitner and her nephew Otto Robert Frisch. Frisch named the process by analogy with biological fission of living cells. It is an exothermic reaction which can release large amounts of energy both as electromagnetic radiation and as kinetic energy of the fragments (heating the bulk material where fission takes place). In order for fission to produce energy, the total binding energy of the resulting elements must be less negative (higher energy) than that of the starting element.\nFission is a form of nuclear transmutation because the resulting fragments are not the same element as the original atom. The two nuclei produced are most often of comparable but slightly different sizes, typically with a mass ratio of products of about 3 to 2, for common fissile isotopes. Most fissions are binary fissions (producing two charged fragments), but occasionally (2 to 4 times per 1000 events), three positively charged fragments are produced, in a ternary fission. The smallest of these fragments in ternary processes ranges in size from a proton to an argon nucleus.\nApart from fission induced by a neutron, harnessed and exploited by humans, a natural form of spontaneous radioactive decay (not requiring a neutron) is also referred to as fission, and occurs especially in very high-mass-number isotopes. Spontaneous fission was discovered in 1940 by Flyorov, Petrzhak and Kurchatov in Moscow, when they decided to confirm that, without bombardment by neutrons, the fission rate of uranium was indeed negligible, as predicted by Niels Bohr it was not.\nThe unpredictable composition of the products (which vary in a broad probabilistic and somewhat chaotic manner) distinguishes fission from purely quantum-tunneling processes such as proton emission, alpha decay, and cluster decay, which give the same products each time. Nuclear fission produces energy for nuclear power and drives the explosion of nuclear weapons. Both uses are possible because certain substances called nuclear fuels undergo fission when struck by fission neutrons, and in turn emit neutrons when they break apart. This makes possible a self-sustaining nuclear chain reaction that releases energy at a controlled rate in a nuclear reactor or at a very rapid uncontrolled rate in a nuclear weapon.\nThe amount of free energy contained in nuclear fuel is millions of times the amount of free energy contained in a similar mass of chemical fuel such as gasoline, making nuclear fission a very dense source of energy. The products of nuclear fission, however, are on average far more radioactive than the heavy elements which are normally fissioned as fuel, and remain so for significant amounts of time, giving rise to a nuclear waste problem. Concerns over nuclear waste accumulation and over the destructive potential of nuclear weapons are a counterbalance to the peaceful desire to use fission as an energy source, and give rise to ongoing political debate over nuclear power.",
        "title": "Nuclear fission"
    },
    "Nuclear Plant": {
        "image": "Nuclear power plant.jpg",
        "summary": "A nuclear power plant or nuclear power station is a thermal power station in which the heat source is a nuclear reactor. As is typical in all conventional thermal power stations the heat is used to generate steam which drives a steam turbine connected to an electric generator which produces electricity. As of 23 April 2014, the IAEA report there are 449 nuclear power reactors in operation operating in 31 countries.\nNuclear power stations are usually considered to be base load stations since fuel is a small part of the cost of production. Their operations and maintenance (O&M) and fuel costs are, along with hydropower stations, at the low end of the spectrum and make them suitable as base-load power suppliers. The cost of spent fuel management, however, is somewhat uncertain.",
        "title": "Nuclear power plant"
    },
    "Nuclear Power": {
        "image": "Nuclear power.jpg",
        "summary": "Nuclear power is the use of nuclear reactions that release nuclear energy to generate heat, which most frequently is then used in steam turbines to produce electricity in a nuclear power plant. The term includes nuclear fission, nuclear decay and nuclear fusion. Presently, the nuclear fission of elements in the actinide series of the periodic table produce the vast majority of nuclear energy in the direct service of humankind, with nuclear decay processes, primarily in the form of geothermal energy, and radioisotope thermoelectric generators, in niche uses making up the rest.\nOwing, fundamentally, to the control on the power or heat increase, that is inherent to the slow delayed critical fission process, Fission-electric power stations and engines have and continue to be built, as an alternative to the dominant fossil-fuel power systems of the world. Fission-electricity is one of the leading low carbon power generation methods of producing electricity, and in terms of total life-cycle greenhouse gas emissions per unit of energy generated, has emission values lower than renewable energy when the latter is taken as a single energy source. A 2014 analysis of the carbon footprint literature by the Intergovernmental Panel on Climate Change (IPCC) reported that the embodied total life-cycle emission intensity of fission electricity has a median value of 12 g CO2eq/kWh which is the lowest out of all commercial baseload energy sources. This is contrasted with coal and fossil gas at 820 and 490 g CO2 eq/kWh. From the beginning of fission-electric power station commercialization in the 1970s, nuclear power prevented the emission of about 64 billion tonnes of carbon dioxide equivalent that would have otherwise resulted from the burning of fossil fuels in thermal power stations.\nThere is a social debate about nuclear power. Proponents, such as the World Nuclear Association and Environmentalists for Nuclear Energy, contend that nuclear power is a safe, sustainable energy source that reduces carbon emissions. Opponents, such as Greenpeace International and NIRS, contend that nuclear power poses many threats to people and the environment. Far-reaching fission power reactor accidents, or accidents that resulted in medium to long-lived fission product contamination of inhabited areas, have occurred in Generation I and II reactor designs. These include the Chernobyl disaster in 1986, the Fukushima Daiichi nuclear disaster in 2011, and the more contained Three Mile Island accident in 1979. There have also been some nuclear submarine accidents. In terms of lives lost per unit of energy generated, analysis has determined that fission-electric reactors have caused fewer fatalities per unit of energy generated than the other major sources of energy generation. Energy production from coal, petroleum, natural gas and hydroelectricity has caused a greater number of fatalities per unit of energy generated due to air pollution and energy accident effects.\nAs of 2017, the International Atomic Energy Agency states that 60 reactors, mostly of Generation III reactor design, are under construction around the world, with the majority in Asia. Collaboration on research & developments towards greater passive nuclear safety, efficiency and recycling of spent fuel in future Generation IV reactors presently includes Euratom and the co-operation of more than 10 permanent countries globally.",
        "title": "Nuclear power"
    },
    "Offshore Platform": {
        "image": "Oil platform.jpg",
        "summary": "An oil platform, offshore platform, or (colloquially) oil rig is a large structure with facilities for well drilling (optionally), to extract and process oil and natural gas, or to temporarily store product until it can be brought to shore for refining and marketing. In many cases, the platform contains facilities to house the workforce as well.\nDepending on the circumstances, the platform may be fixed to the ocean floor, may consist of an artificial island, or may float. Remote subsea wells may also be connected to a platform by flow lines and by umbilical connections. These sub-sea solutions may consist of one or more subsea wells, or of one or more manifold centres for multiple wells.",
        "title": "Oil platform"
    },
    "Oracle": {
        "image": "Oracle.jpg",
        "summary": "In classical antiquity, an oracle was a person or agency considered to provide wise and insightful counsel or prophetic predictions or precognition of the future, inspired by the gods. As such it is a form of divination.",
        "title": "Oracle"
    },
    "Palace": {
        "image": "Palace.jpg",
        "summary": "A palace is a grand residence, especially a royal residence, or the home of a head of state or some other high-ranking dignitary, such as a bishop or archbishop.\nThe word is derived from the Latin name Pal\u0101tium, for Palatine Hill in Rome which housed the Imperial residences. In many parts of Europe, the term is also applied to ambitious private mansions of the aristocracy. Many historic palaces are now put to other uses such as parliaments, museums, hotels, or office buildings. The word is also sometimes used to describe a lavishly ornate building used for public entertainment or exhibitions.",
        "title": "Palace"
    },
    "Paratroopers": {
        "image": "Paratrooper.jpg",
        "summary": "Paratroopers are military parachutists \u2014 military personnel trained in parachuting into an operation and usually functioning as part of an airborne force. Military parachutists (troops) and parachutes were first used on a large scale during World War II for troop distribution and transportation. Paratroopers are often used to seize strategic objectives such as airfields or bridges.\n\n",
        "title": "Paratrooper"
    },
    "Partisan": {
        "image": "Partisan (military).jpg",
        "summary": "A partisan is a member of an irregular military force formed to oppose control of an area by a foreign power or by an army of occupation by some kind of insurgent activity. The term can apply to the field element of resistance movements, examples of which are the civilians who opposed Nazi German, Usta\u0161e and Fascist Italian rule in several countries during World War II.",
        "title": "Partisan (military)"
    },
    "Phalanx": {
        "image": "Phalanx.jpg",
        "summary": "The phalanx (Ancient Greek: \u03c6\u03ac\u03bb\u03b1\u03b3\u03be plural phalanxes or phalanges, \u03c6\u03ac\u03bb\u03b1\u03b3\u03b3\u03b5\u03c2, phalanges) was a rectangular mass military formation, usually composed entirely of heavy infantry armed with spears, pikes, sarissas, or similar weapons. The term is particularly (and originally) used to describe the use of this formation in Ancient Greek warfare, although the ancient Greek writers used it to also describe any massed infantry formation, regardless of its equipment, as does Arrian in his Array against the Alans when he refers to his legions. In Greek texts, the phalanx may be deployed for battle, on the march, even camped, thus describing the mass of infantry or cavalry that would deploy in line during battle. They marched forward as one entity.\nThe term itself, as used today, does not refer to a distinctive military unit or division (e.g., the Roman legion or the contemporary Western-type battalion), but to the general formation of an army's troops. Thus a phalanx does not have a standard combat strength or composition but includes the total number of infantry, which is or will be deployed in action in a single phalanx formation.\n\nMany spear-armed troops historically fought in what might be termed phalanx-like formations. The word has come into use in common English to describe \"a group of people standing, or moving forward closely together\" c.f. \"a phalanx of police\".\nThis article focuses on the use of the military phalanx formation in Ancient Greece, the Hellenistic world, and other ancient states heavily influenced by Greek civilization.",
        "title": "Phalanx"
    },
    "Philosophy": {
        "image": "Philosophy.jpg",
        "summary": "Philosophy (from Greek \u03c6\u03b9\u03bb\u03bf\u03c3\u03bf\u03c6\u03af\u03b1, philosophia, literally \"love of wisdom\") is the study of general and fundamental problems concerning matters such as existence, knowledge, values, reason, mind, and language. The term was probably coined by Pythagoras (c. 570\u2013495 BCE). Philosophical methods include questioning, critical discussion, rational argument, and systematic presentation. Classic philosophical questions include: Is it possible to know anything and to prove it? What is most real? Philosophers also pose more practical and concrete questions such as: Is there a best way to live? Is it better to be just or unjust (if one can get away with it)? Do humans have free will?\nHistorically, \"philosophy\" encompassed any body of knowledge. From the time of Ancient Greek philosopher Aristotle to the 19th century, \"natural philosophy\" encompassed astronomy, medicine, and physics. For example, Newton's 1687 Mathematical Principles of Natural Philosophy later became classified as a book of physics. In the 19th century, the growth of modern research universities led academic philosophy and other disciplines to professionalize and specialize. In the modern era, some investigations that were traditionally part of philosophy became separate academic disciplines, including psychology, sociology, linguistics, and economics.\nOther investigations closely related to art, science, politics, or other pursuits remained part of philosophy. For example, is beauty objective or subjective? Are there many scientific methods or just one? Is political utopia a hopeful dream or hopeless fantasy? Major sub-fields of academic philosophy include metaphysics (\"concerned with the fundamental nature of reality and being\"), epistemology (about the \"nature and grounds of knowledge [and]...its limits and validity\" ), ethics, aesthetics, political philosophy, logic, philosophy of science, and the history of Western philosophy.\nSince the 20th century, professional philosophers contribute to society primarily as professors, researchers, and writers. However, many of those who study philosophy in undergraduate or graduate programs contribute in the fields of law, journalism, politics, religion, science, business and various art and entertainment activities.",
        "title": "Philosophy"
    },
    "Physics": {
        "image": "Physics.jpg",
        "summary": "Physics (from Ancient Greek: \u03c6\u03c5\u03c3\u03b9\u03ba\u03ae (\u1f10\u03c0\u03b9\u03c3\u03c4\u03ae\u03bc\u03b7), translit. phusik\u1e17 (epist\u1e17m\u0113), lit. 'knowledge of nature', from \u03c6\u03cd\u03c3\u03b9\u03c2 ph\u00fasis \"nature\") is the natural science that involves the study of matter and its motion and behavior through space and time, along with related concepts such as energy and force. One of the most fundamental scientific disciplines, the main goal of physics is to understand how the universe behaves.\nPhysics is one of the oldest academic disciplines, perhaps the oldest through its inclusion of astronomy. Over the last two millennia, physics was a part of natural philosophy along with chemistry, biology, and certain branches of mathematics, but during the scientific revolution in the 17th century, the natural sciences emerged as unique research programs in their own right. Physics intersects with many interdisciplinary areas of research, such as biophysics and quantum chemistry, and the boundaries of physics are not rigidly defined. New ideas in physics often explain the fundamental mechanisms of other sciences while opening new avenues of research in areas such as mathematics and philosophy.\nPhysics also makes significant contributions through advances in new technologies that arise from theoretical breakthroughs. For example, advances in the understanding of electromagnetism or nuclear physics led directly to the development of new products that have dramatically transformed modern-day society, such as television, computers, domestic appliances, and nuclear weapons advances in thermodynamics led to the development of industrialization, and advances in mechanics inspired the development of calculus.",
        "title": "Physics"
    },
    "Pikemen": {
        "image": "Pike square.jpg",
        "summary": "The pike square (German: Gevierthaufen or Gewalthaufen, meaning crowd of force) was a military tactic developed by the Swiss Confederacy during the 15th century for use by its infantry.",
        "title": "Pike square"
    },
    "Plastics": {
        "image": "Plastic.jpg",
        "summary": "Plastic is material consisting of any of a wide range of synthetic or semi-synthetic organic compounds that are malleable and so can be molded into solid objects.\nPlasticity is the general property of all materials which can deform irreversibly without breaking but, in the class of moldable polymers, this occurs to such a degree that their actual name derives from this ability.\nPlastics are typically organic polymers of high molecular mass, but they often contain other substances. They are usually synthetic, most commonly derived from petrochemicals, but many are made from renewable materials such as polylactic acid from corn or cellulosics from cotton linters.\nDue to their relatively low cost, ease of manufacture, versatility, and imperviousness to water, plastics are used in an enormous and expanding range of products, from paper clips to spaceships. They have already displaced many traditional materials, such as wood, stone, horn and bone, leather, paper, metal, glass, and ceramic, in most of their former uses.\nIn developed countries, about a third of plastic is used in packaging and another third in buildings such as piping used in plumbing or vinyl siding. Other uses include automobiles (up to 20% plastic), furniture, and toys. In the developing world, the ratios may be different - for example, reportedly 42% of India's consumption is used in packaging.\nPlastics have many uses in the medical field as well, to include polymer implants, however the field of plastic surgery is not named for use of plastic materials, but rather the more generic meaning of the word plasticity, with regard to the reshaping of flesh.\nThe world's first fully synthetic plastic was bakelite, invented in New York in 1907 by Leo Baekeland who coined the term 'plastics'. Many chemists have contributed to the materials science of plastics, including Nobel laureate Hermann Staudinger who has been called \"the father of polymer chemistry\" and Herman Mark, known as \"the father of polymer physics\".\nThe success and dominance of plastics starting in the early 20th century led to environmental concerns regarding its slow decomposition rate after being discarded as trash due to its composition of very large molecules. Toward the end of the century, one approach to this problem was met with wide efforts toward recycling.",
        "title": "Plastic"
    },
    "Police Station": {
        "image": "Police station.jpg",
        "summary": "A police station (sometimes called a \"station house\" in the US) is a building which serves to accommodate police officers and other members of staff. These buildings often contain offices and accommodation for personnel and vehicles, along with locker rooms, temporary holding cells and interview/interrogation rooms. In many countries, the commander of a police station is called a commissary.",
        "title": "Police station"
    },
    "Polytheism": {
        "image": "Polytheism.jpg",
        "summary": "Polytheism (from Greek \u03c0\u03bf\u03bb\u03c5\u03b8\u03b5\u03ca\u03c3\u03bc\u03cc\u03c2, polytheismos) is the worship of or belief in multiple deities, which are usually assembled into a pantheon of gods and goddesses, along with their own religions and rituals. In most religions which accept polytheism, the different gods and goddesses are representations of forces of nature or ancestral principles, and can be viewed either as autonomous or as aspects or emanations of a creator God or transcendental absolute principle (monistic theologies), which manifests immanently in nature (panentheistic and pantheistic theologies). Most of the polytheistic deities of ancient religions, with the notable exceptions of the Ancient Egyptian and Hindu deities, were conceived as having physical bodies.\nPolytheism is a type of theism. Within theism, it contrasts with monotheism, the belief in a singular God, in most cases transcendent. Polytheists do not always worship all the gods equally, but they can be henotheists, specializing in the worship of one particular deity. Other polytheists can be kathenotheists, worshiping different deities at different times.\nPolytheism was the typical form of religion during the Bronze Age and Iron Age up to the Axial Age and the development of Abrahamic religions, the latter of which enforced strict monotheism. It is well documented in historical religions of Classical antiquity, especially ancient Greek religion and ancient Roman religion, and after the decline of Greco-Roman polytheism in tribal religions such as Germanic paganism or Slavic paganism.\nImportant polytheistic religions practiced today include Chinese traditional religion, Hinduism, Japanese Shinto, and various neopagan faiths.",
        "title": "Polytheism"
    },
    "Port Facility": {
        "image": "Port.jpg",
        "summary": "A port is a location on a coast or shore containing one or more harbors where ships can dock and transfer people or cargo to or from land. Port locations are selected to optimize access to land and navigable water, for commercial demand, and for shelter from wind and waves. Ports with deeper water are rarer, but can handle larger ships. Since ports throughout history handled every kind of traffic, support and storage facilities vary widely, may extend for miles, and dominate the local economy. Some ports have an important military role.",
        "title": "Port"
    },
    "Pottery": {
        "image": "Pottery.jpg",
        "summary": "Pottery is the ceramic material which makes up potterywares, of which major types include earthenware, stoneware and porcelain. The place where such wares are made by a potter is also called a pottery (plural \"potteries\"). The definition of pottery used by the American Society for Testing and Materials (ASTM) is \"all fired ceramic wares that contain clay when formed, except technical, structural, and refractory products.\"\nPottery is one of the oldest human inventions, originating before the Neolithic period, with ceramic objects like the Gravettian culture Venus of Doln\u00ed V\u011bstonice figurine discovered in the Czech Republic date back to 29,000\u201325,000 BC, and pottery vessels that were discovered in Jiangxi, China, which date back to 18,000 BC. Early Neolithic pottery have been found in places such as Jomon Japan (10,500 BC), the Russian Far East (14,000 BC), Sub-Saharan Africa and South America.\nPottery is made by forming a ceramic (often clay) body into objects of a required shape and heating them to high temperatures in a kiln which removes all the water from the clay, which induces reactions that lead to permanent changes including increasing their strength and hardening and setting their shape. A clay body can be decorated before or after firing however, prior to some shaping processes, clay must be prepared. Kneading helps to ensure an even moisture content throughout the body. Air trapped within the clay body needs to be removed. This is called de-airing and can be accomplished either by a machine called a vacuum pug or manually by wedging. Wedging can also help produce an even moisture content. Once a clay body has been kneaded and de-aired or wedged, it is shaped by a variety of techniques. After shaping, it is dried and then fired.",
        "title": "Pottery"
    },
    "Power Plant": {
        "image": "Power station.jpg",
        "summary": "A power station, also referred to as a power plant or powerhouse and sometimes generating station or generating plant, is an industrial facility for the generation of electric power. Most power stations contain one or more generators, a rotating machine that converts mechanical power into electrical power. The relative motion between a magnetic field and a conductor creates an electrical current. The energy source harnessed to turn the generator varies widely. Most power stations in the world burn fossil fuels such as coal, oil, and natural gas to generate electricity. Others use nuclear power, but there is an increasing use of cleaner renewable sources such as solar, wind, wave and hydroelectric.",
        "title": "Power station"
    },
    "Pyramids": {
        "image": "Giza pyramid complex.jpg",
        "summary": "The Giza pyramid complex (Arabic: \u0623\u0647\u0631\u0627\u0645\u0627\u062a \u0627\u0644\u062c\u064a\u0632\u0629\u200e\u200e, IPA: [\u0294\u0251h\u027e\u0251\u02c8m\u0251\u02d0t el\u02c8\u0261i\u02d0z\u00e6], \"pyramids of Giza\") is an archaeological site on the Giza Plateau, on the outskirts of Cairo, Egypt.\nThis complex of ancient monuments includes the three pyramid complexes known as the Great Pyramids, the massive sculpture known as the Great Sphinx, several cemeteries, a workers' village and an industrial complex. It is located in the Libyan Desert, approximately 9 km (5 mi) west of the Nile river at the old town of Giza, and about 13 km (8 mi) southwest of Cairo city centre.\nThe pyramids, which have historically loomed large as emblems of ancient Egypt in the Western imagination, were popularised in Hellenistic times, when the Great Pyramid was listed by Antipater of Sidon as one of the Seven Wonders of the World. It is by far the oldest of the ancient Wonders and the only one still in existence.",
        "title": "Giza pyramid complex"
    },
    "Radio": {
        "image": "Radio.jpg",
        "summary": "Radio is the technology of using radio waves to carry information, such as sound, by systematically modulating properties of electromagnetic energy waves transmitted through space, such as their amplitude, frequency, phase, or pulse width. When radio waves strike an electrical conductor, the oscillating fields induce an alternating current in the conductor. The information in the waves can be extracted and transformed back into its original form.\nRadio systems need a transmitter to modulate (change) some property of the energy produced to impress a signal on it, for example using amplitude modulation or angle modulation (which can be frequency modulation or phase modulation). Radio systems also need an antenna to convert electric currents into radio waves, and radio waves into an electric current. An antenna can be used for both transmitting and receiving. The electrical resonance of tuned circuits in radios allow individual stations to be selected. The electromagnetic wave is intercepted by a tuned receiving antenna. A radio receiver receives its input from an antenna and converts it into a form that is usable for the consumer, such as sound, pictures, digital data, measurement values, navigational positions, etc. Radio frequencies occupy the range from a 3 kHz to 300 GHz, although commercially important uses of radio use only a small part of this spectrum.\nA radio communication system sends signals by radio. The radio equipment involved in communication systems includes a transmitter and a receiver, each having an antenna and appropriate terminal equipment such as a microphone at the transmitter and a loudspeaker at the receiver in the case of a voice-communication system.",
        "title": "Radio"
    },
    "Railroad": {
        "image": "Rail transport.jpg",
        "summary": "Rail transport is a means of transferring of passengers and goods on wheeled vehicles running on rails, also known as tracks. It is also commonly referred to as train transport. In contrast to road transport, where vehicles run on a prepared flat surface, rail vehicles (rolling stock) are directionally guided by the tracks on which they run. Tracks usually consist of steel rails, installed on ties (sleepers) and ballast, on which the rolling stock, usually fitted with metal wheels, moves. Other variations are also possible, such as slab track, where the rails are fastened to a concrete foundation resting on a prepared subsurface.\nRolling stock in a rail transport system generally encounters lower frictional resistance than road vehicles, so passenger and freight cars (carriages and wagons) can be coupled into longer trains. The operation is carried out by a railway company, providing transport between train stations or freight customer facilities. Power is provided by locomotives which either draw electric power from a railway electrification system or produce their own power, usually by diesel engines. Most tracks are accompanied by a signalling system. Railways are a safe land transport system when compared to other forms of transport. Railway transport is capable of high levels of passenger and cargo utilization and energy efficiency, but is often less flexible and more capital-intensive than road transport, when lower traffic levels are considered.\nThe oldest known, man/animal-hauled railways date back to the 6th century BC in Corinth, Greece. Rail transport then commenced in mid 16th century in Germany in form of horse-powered funiculars and wagonways. Modern rail transport commenced with the British development of the steam locomotives in the early 19th century. Thus the railway system in Great Britain is the oldest in the world. Built by George Stephenson and his son Robert's company Robert Stephenson and Company, the Locomotion No. 1 is the first steam locomotive to carry passengers on a public rail line, the Stockton and Darlington Railway in 1825. George also built the first public inter-city railway line in the world to use only the steam locomotives all the time, the Liverpool and Manchester Railway which opened in 1830. With steam engines, one could construct mainline railways, which were a key component of the Industrial Revolution. Also, railways reduced the costs of shipping, and allowed for fewer lost goods, compared with water transport, which faced occasional sinking of ships. The change from canals to railways allowed for \"national markets\" in which prices varied very little from city to city. The invention and development of the railway in the United Kingdom was one of the most important technological inventions of the 19th century. The world's first underground railway, the Metropolitan Railway (part of the London Underground), opened in 1863.\nIn the 1880s, electrified trains were introduced, leading to electrification of tramways and rapid transit systems. Starting during the 1940s, the non-electrified railways in most countries had their steam locomotives replaced by diesel-electric locomotives, with the process being almost complete by 2000s. During the 1960s, electrified high-speed railway systems were introduced in Japan and later in some other countries. Many countries are in process of replacing diesel locomotives with electric locomotives, mainly due to environmental concerns, a notable example being Switzerland, which has completely electrified its network. Other forms of guided ground transport outside the traditional railway definitions, such as monorail or maglev, have been tried but have seen limited use.\nFollowing decline after World War II due to competition from cars, rail transport has had a revival in recent decades due to road congestion and rising fuel prices, as well as governments investing in rail as a means of reducing CO2 emissions in the context of concerns about global warming.",
        "title": "Rail transport"
    },
    "Recycling": {
        "image": "Recycling.jpg",
        "summary": "Recycling is the process of converting waste materials into new materials and objects. It is an alternative to \"conventional\" waste disposal that can save material and help lower greenhouse gas emissions (compared to plastic production, for example). Recycling can prevent the waste of potentially useful materials and reduce the consumption of fresh raw materials, thereby reducing: energy usage, air pollution (from incineration), and water pollution (from landfilling).\nRecycling is a key component of modern waste reduction and is the third component of the \"Reduce, Reuse, and Recycle\" waste hierarchy.\nThere are some ISO standards related to recycling such as ISO 15270:2008 for plastics waste and ISO 14001:2004 for environmental management control of recycling practice.\nRecyclable materials include many kinds of glass, paper, and cardboard, metal, plastic, tires, textiles, and electronics. The composting or other reuse of biodegradable waste\u2014such as food or garden waste\u2014is also considered recycling. Materials to be recycled are either brought to a collection center or picked up from the curbside, then sorted, cleaned, and reprocessed into new materials destined for manufacturing.\nIn the strictest sense, recycling of a material would produce a fresh supply of the same material\u2014for example, used office paper would be converted into new office paper or used polystyrene foam into new polystyrene. However, this is often difficult or too expensive (compared with producing the same product from raw materials or other sources), so \"recycling\" of many products or materials involves their reuse in producing different materials (for example, paperboard) instead. Another form of recycling is the salvage of certain materials from complex products, either due to their intrinsic value (such as lead from car batteries, or gold from circuit boards), or due to their hazardous nature (e.g., removal and reuse of mercury from thermometers and thermostats).",
        "title": "Recycling"
    },
    "Recycling Center": {
        "image": "Recycling.jpg",
        "summary": "Recycling is the process of converting waste materials into new materials and objects. It is an alternative to \"conventional\" waste disposal that can save material and help lower greenhouse gas emissions (compared to plastic production, for example). Recycling can prevent the waste of potentially useful materials and reduce the consumption of fresh raw materials, thereby reducing: energy usage, air pollution (from incineration), and water pollution (from landfilling).\nRecycling is a key component of modern waste reduction and is the third component of the \"Reduce, Reuse, and Recycle\" waste hierarchy.\nThere are some ISO standards related to recycling such as ISO 15270:2008 for plastics waste and ISO 14001:2004 for environmental management control of recycling practice.\nRecyclable materials include many kinds of glass, paper, and cardboard, metal, plastic, tires, textiles, and electronics. The composting or other reuse of biodegradable waste\u2014such as food or garden waste\u2014is also considered recycling. Materials to be recycled are either brought to a collection center or picked up from the curbside, then sorted, cleaned, and reprocessed into new materials destined for manufacturing.\nIn the strictest sense, recycling of a material would produce a fresh supply of the same material\u2014for example, used office paper would be converted into new office paper or used polystyrene foam into new polystyrene. However, this is often difficult or too expensive (compared with producing the same product from raw materials or other sources), so \"recycling\" of many products or materials involves their reuse in producing different materials (for example, paperboard) instead. Another form of recycling is the salvage of certain materials from complex products, either due to their intrinsic value (such as lead from car batteries, or gold from circuit boards), or due to their hazardous nature (e.g., removal and reuse of mercury from thermometers and thermostats).",
        "title": "Recycling"
    },
    "Refining": {
        "image": None,
        "summary": "Refining (also perhaps called by the mathematical term affining) is the process of purification of a (1) substance or a (2) form. The term is usually used of a natural resource that is almost in a usable form, but which is more useful in its pure form. For instance, most types of natural petroleum will burn straight from the ground, but it will burn poorly and quickly clog an engine with residues and by-products. The term is broad, and may include more drastic transformations, such as the reduction of ore to metal (for which see Refining (metallurgy)).\nThe refining of liquids is often accomplished by distillation or fractionation this process is useful, for example, for isolating different fractions of petroleum. Gases can be refined in this way as well, by being cooled and/or compressed until they liquefy. Gases and liquids can also be refined by extraction with a selective solvent that dissolves away either the substance of interest, or the unwanted impurities.\nMany solids can be refined by growing crystals in a solution of the impure material the regular structure of the crystal tends to favor the desired material and exclude other kinds of particles.\nChemical reactions are often used to remove impurities of particular types.\nThe use of silicon and other semiconductors in electronics depends on precise control of impurities. The zone melting process developed by William Gardner Pfann was used to produce pure germanium, and subsequently float-zone silicon became available when Henry Theuerer of Bell Labs adapted Pfann's method to silicon.\nTypes of materials that are usually refined:\nmetals - see Refining (metallurgy)\npetroleum\nsilicon\nsugar\ntable salt\nvegetable oil\nair",
        "title": "Refining"
    },
    "Refrigeration": {
        "image": "Refrigeration.jpg",
        "summary": "Refrigeration is a process of removing heat from a low-temperature reservoir and transferring it to a high-temperature reservoir. The work of heat transfer is traditionally driven by mechanical means, but can also be driven by heat, magnetism, electricity, laser, or other means. Refrigeration has many applications, including, but not limited to: household refrigerators, industrial freezers, cryogenics, and air conditioning. Heat pumps may use the heat output of the refrigeration process, and also may be designed to be reversible, but are otherwise similar to air conditioning units.\nRefrigeration has had a large impact on industry, lifestyle, agriculture, and settlement patterns. The idea of preserving food dates back to at least the ancient Roman and Chinese empires. However, mechanical refrigeration technology has rapidly evolved in the last century, from ice harvesting to temperature-controlled rail cars. The introduction of refrigerated rail cars contributed to the westward expansion of the United States, allowing settlement in areas that were not on main transport channels such as rivers, harbors, or valley trails. Settlements were also developing in infertile parts of the country, filled with newly discovered natural resources. These new settlement patterns sparked the building of large cities which are able to thrive in areas that were otherwise thought to be inhospitable, such as Houston, Texas, and Las Vegas, Nevada. In most developed countries, cities are heavily dependent upon refrigeration in supermarkets, in order to obtain their food for daily consumption. The increase in food sources has led to a larger concentration of agricultural sales coming from a smaller percentage of existing farms. Farms today have a much larger output per person in comparison to the late 1800s. This has resulted in new food sources available to entire populations, which has had a large impact on the nutrition of society.\nAmmonia was one of the first refrigerants.",
        "title": "Refrigeration"
    },
    "Republic": {
        "image": "Republic.jpg",
        "summary": "A republic (Latin: res publica) is a form of government in which the country is considered a \"public matter\", not the private concern or property of the rulers. The primary positions of power within a republic are not inherited, but are attained through elections expressing the consent of the governed. Such leadership positions are therefore expected to fairly represent the citizen body. It is a form of government under which the head of state is not a monarch. In American English, the definition of a republic can also refer specifically to a government in which elected individuals represent the citizen body, known elsewhere as a representative democracy (a democratic republic) and exercise power according to the rule of law (a constitutional republic).\nAs of 2017, 159 of the world's 206 sovereign states use the word \"republic\" as part of their official names \u2013 not all of these are republics in the sense of having elected governments, nor is the word \"republic\" used in the names of all nations with elected governments. While heads-of-state often tend to claim that they rule only by the \"consent of the governed\", elections in some countries have been found to be held more for the purpose of \u201cshow\u201d than for the actual purpose of in reality providing citizens with any genuine ability to choose their own leaders.\nThe term \u201crepublic\u201d was first coined ca. 500 BC in Rome, but over time the term has undergone several changes in meaning. Initially the Latin term \u201cres publica\u201d signified the earlier \u201cpartial form of democracy\u201d as found in Rome from c. 500 BC until c. 27 BC. In this early Roman partial-democracy, the power of the aristocratic or patrician class who held all of the seats in the Roman Senate, was checked by the institution of the consulship, whose two consul/vice-rulers were elected annually by the free citizens or plebes of Rome. The ancient Roman definition of the word differs from the modern use of the term, where no leadership positions are held to be restricted to only the \"ruling class\".\nMost often a republic is a single sovereign state, but there are also sub-sovereign state entities that are referred to as republics, or that have governments that are described as \"republican\" in nature. For instance, Article IV of the United States Constitution \"guarantee[s] to every State in this Union a Republican form of Government\". In contrast, the former Soviet Union, which described itself as being a group of \"Republics\" and also as a \"federal multinational state composed of 15 republics\", was widely viewed as being an authoritarian form of government and not as a republican form of government. It was seen as authoritarian, as its electoral system was structured so as to automatically guarantee the election of government sponsored candidates.",
        "title": "Republic"
    },
    "Research Lab": {
        "image": "Laboratory.jpg",
        "summary": "A laboratory (CommE  or , AmE  informally, lab) is a facility that provides controlled conditions in which scientific or technological research, experiments, and measurement may be performed.",
        "title": "Laboratory"
    },
    "Riflemen": {
        "image": "Rifleman.jpg",
        "summary": "A rifleman is an infantry soldier armed with a rifled long gun. Although the rifleman role had its origin with 16th century hand cannoneers and 17th century musketeers, the term originated in the 18th century with the introduction of the rifled musket. By the mid-19th century, entire regiments of riflemen were formed and became the mainstay of all standard infantry. Rifleman became a term for any common infantryman.",
        "title": "Rifleman"
    },
    "Robotics": {
        "image": "Robotics.jpg",
        "summary": "Robotics is an interdisciplinary branch of engineering and science that includes mechanical engineering, electrical engineering, computer science, and others. Robotics deals with the design, construction, operation, and use of robots, as well as computer systems for their control, sensory feedback, and information processing.\nThese technologies are used to develop machines that can substitute for humans. Robots can be used in any situation and for any purpose, but today many are used in dangerous environments (including bomb detection and de-activation), manufacturing processes, or where humans cannot survive. Robots can take on any form but some are made to resemble humans in appearance. This is said to help in the acceptance of a robot in certain replicative behaviors usually performed by people. Such robots attempt to replicate walking, lifting, speech, cognition, and basically anything a human can do. Many of today's robots are inspired by nature, contributing to the field of bio-inspired robotics.\nThe concept of creating machines that can operate autonomously dates back to classical times, but research into the functionality and potential uses of robots did not grow substantially until the 20th century. Throughout history, it has been frequently assumed that robots will one day be able to mimic human behavior and manage tasks in a human-like fashion. Today, robotics is a rapidly growing field, as technological advances continue researching, designing, and building new robots serve various practical purposes, whether domestically, commercially, or militarily. Many robots are built to do jobs that are hazardous to people such as defusing bombs, finding survivors in unstable ruins, and exploring mines and shipwrecks. Robotics is also used in STEM (Science, Technology, Engineering, and Mathematics) as a teaching aid.",
        "title": "Robotics"
    },
    "Rocketry": {
        "image": "Rocket.jpg",
        "summary": "A rocket (from Italian rocchetto \"bobbin\") is a missile, spacecraft, aircraft or other vehicle that obtains thrust from a rocket engine. Rocket engine exhaust is formed entirely from propellant carried within the rocket before use. Rocket engines work by action and reaction and push rockets forward simply by expelling their exhaust in the opposite direction at high speed, and can therefore work in the vacuum of space.\nIn fact, rockets work more efficiently in space than in an atmosphere. Multistage rockets are capable of attaining escape velocity from Earth and therefore can achieve unlimited maximum altitude. Compared with airbreathing engines, rockets are lightweight and powerful and capable of generating large accelerations. To control their flight, rockets rely on momentum, airfoils, auxiliary reaction engines, gimballed thrust, momentum wheels, deflection of the exhaust stream, propellant flow, spin, and/or gravity.\nRockets for military and recreational uses date back to at least 13th century China. Significant scientific, interplanetary and industrial use did not occur until the 20th century, when rocketry was the enabling technology for the Space Age, including setting foot on the Earth's moon. Rockets are now used for fireworks, weaponry, ejection seats, launch vehicles for artificial satellites, human spaceflight, and space exploration.\nChemical rockets are the most common type of high power rocket, typically creating a high speed exhaust by the combustion of fuel with an oxidizer. The stored propellant can be a simple pressurized gas or a single liquid fuel that disassociates in the presence of a catalyst (monopropellants), two liquids that spontaneously react on contact (hypergolic propellants), two liquids that must be ignited to react, a solid combination of fuel with oxidizer (solid fuel), or solid fuel with liquid oxidizer (hybrid propellant system). Chemical rockets store a large amount of energy in an easily released form, and can be very dangerous. However, careful design, testing, construction and use minimizes risks.",
        "title": "Rocket"
    },
    "SAM Battery": {
        "image": "Surface-to-air missile.jpg",
        "summary": "A surface-to-air missile (SAM), or ground-to-air missile (GTAM), is a missile designed to be launched from the ground to destroy aircraft or other missiles. It is one type of antiaircraft system in modern armed forces, missiles have replaced most other forms of dedicated antiaircraft weapons, with anti-aircraft guns pushed into specialized roles.\nThe first serious attempts at SAM development took place during World War II, although no operational systems were introduced. Further development in the 1940s and 1950s led to the first operational systems being introduced by most major forces during the second half of the 1950s. Smaller systems, suitable for close-range work, evolved through the 1960s and 1970s, to modern systems that are man-portable. Shipborne systems followed the evolution of land-based models, starting with long-range weapons and steadily evolving toward smaller designs to provide a layered defence that have pushed gun-based systems into the shortest-range roles.\nThe American Nike Ajax was the first operational guided missile SAM system, and the Soviet Union's S-75 Dvina was the most-produced SAM. Widely used modern examples include the Patriot and S-300 wide-area systems, SM-6 naval missiles, and short-range man-portable systems like the Stinger and Strela-3.",
        "title": "Surface-to-air missile"
    },
    "SDI Defense": {
        "image": "Strategic Defense Initiative.jpg",
        "summary": "The Strategic Defense Initiative (SDI) was a proposed missile defense system intended to protect the United States from attack by ballistic strategic nuclear weapons (intercontinental ballistic missiles and submarine-launched ballistic missiles). The system, which was to combine ground-based units and orbital deployment platforms, was first publicly announced by President Ronald Reagan on 23 March 1983. The Strategic Defense Initiative Organization (SDIO) was set up in 1984 within the United States Department of Defense to oversee the Strategic Defense Initiative.\nReagan was a vocal critic of the doctrine of mutual assured destruction (MAD), which he described a \"suicide pact\". In his 1983 speech, he called upon the scientists and engineers of the United States to develop a system that would render nuclear weapons obsolete. SDI was an important part of his defense policy, intended to end MAD as a nuclear deterrence strategy. A wide array of advanced weapon concepts, including lasers, particle beam weapons and ground- and space-based missile systems were studied, along with various sensor, command and control, and high-performance computer systems that would be needed to control a system consisting of hundreds of combat centers and satellites spanning the entire globe. A number of these concepts were tested through the late 1980s, and follow-on efforts and spin-offs continue to this day.\nThe ambitious initiative was criticized for allegedly threatening to destabilize the MAD-approach and to possibly re-ignite \"an offensive arms race\". SDI was nicknamed largely in the mainstream media as \"Star Wars\", after the popular 1977 film by George Lucas. In 1987, the American Physical Society concluded that a global shield such as \"Star Wars\" was not directly feasible for operational status using existing technology, and that about ten more years of research was needed to know whether such a system was possible.\nAfter the publication of the APS report, SDIs budget was repeatedly cut. By the late 1980s, the effort had been re-focused on the \"Brilliant Pebbles\" concept, which was expected to be much less expensive to develop and deploy. By the early 1990s, with the Cold War ending and nuclear arsenals being rapidly reduced, political support for SDI collapsed. SDI officially ended in 1993, when the administration of President Bill Clinton redirected the efforts towards theatre ballistic missiles and renamed the agency as the Ballistic Missile Defense Organization (BMDO). BMDO was renamed to the Missile Defense Agency in 2002. This article covers defense efforts under the SDIO.",
        "title": "Strategic Defense Initiative"
    },
    "SETI Program": {
        "image": "Search for extraterrestrial intelligence.jpg",
        "summary": "The search for extraterrestrial intelligence (SETI) is a collective term for scientific searches for intelligent extraterrestrial life, for example, monitoring electromagnetic radiation for signs of transmissions from civilizations on other planets.\nScientific investigation began shortly after the advent of radio in the early 1900s, and focused international efforts have been going on since the 1980s. In 2015 Stephen Hawking and Russian billionaire Yuri Milner announced a well-funded effort called the Breakthrough Initiatives.\n\n",
        "title": "Search for extraterrestrial intelligence"
    },
    "Sanitation": {
        "image": "Sanitation.jpg",
        "summary": "Sanitation is the prevention of human contact with feces and the proper treatment and disposal of wastewater. Sanitation also includes promoting hygiene on a personal level through washing hands with soap. Proper sanitation protects people from hazards that may be microbiological, biological or chemical agents of disease. The main objective of a sanitation system is to protect and promote human health by providing a clean environment that will break the cycle of disease. For example, improving access to safe sanitation and changing hygiene behaviours can reduce the incidents of diarrhea.\nSanitation technologies may involve centralized civil engineering structures like sewer systems, sewage treatment, surface runoff treatment and solid waste landfills. These structures are designed to treat wastewater and municipal solid waste. Sanitation technologies may also take the form of relatively simple onsite sanitation systems. This can in some cases consist of a simple pit latrine or other type of non-flush toilet for the excreta management part.\nProviding sanitation to people requires attention to the entire system, not just focusing on technical aspects such as the toilet, fecal sludge management or the wastewater treatment plant. The \"sanitation chain\" involves the experience of the user, excreta and wastewater collection methods, transporting and treatment of waste, and reuse or disposal. All need to be thoroughly considered.\nOne of the main challenges of is the provide sustainable sanitation, especially in developing countries. Maintaining and sustaining sanitation has aspects that are technological, institutional and social in nature. Sanitation infrastructure has to be adapted to several specific contexts including consumers' expectations and local resources available.",
        "title": "Sanitation"
    },
    "Seafaring": {
        "image": "Seamanship.jpg",
        "summary": "Seamanship is the art of operating a ship or boat.\nIt involves topics and development of specialised skills including: navigation and international maritime law weather, meteorology and forecasting watchstanding ship-handling and small boat handling operation of deck equipment, anchors and cables ropework and line handling communications sailing engines execution of evolutions such as towing cargo handling equipment, dangerous cargoes and cargo storage dealing with emergencies survival at sea and search and rescue and fire fighting.\nThe degree of knowledge needed within these areas is dependent upon the nature of the work and the type of vessel employed by a mariner.",
        "title": "Seamanship"
    },
    "Settlers": {
        "image": "Settler.jpg",
        "summary": "A settler is a person who has migrated to an area and established a permanent residence there, often to colonize the area. Settlers are generally from a sedentary culture, as opposed to nomads who share and rotate their settlements with little or no concept of individual land ownership. Settlements are often built on land already claimed or owned by another group. Many times settlers are backed by governments or large countries. They also leave in search of religious freedom.",
        "title": "Settler"
    },
    "Sewer System": {
        "image": "Sanitary sewer.jpg",
        "summary": "A sanitary sewer or \"foul sewer\" is an underground carriage system specifically for transporting sewage from houses and commercial buildings through pipes to treatment facilities or disposal. Sanitary sewers are part of an overall system called a sewage system or sewerage.\nSewage may be treated to control water pollution before discharge to surface waters. Sanitary sewers serving industrial areas also carry industrial wastewater.\nSeparate sanitary sewer systems are designed to transport sewage alone. In municipalities served by sanitary sewers, separate storm drains may convey surface runoff directly to surface waters. Sanitary sewers are distinguished from combined sewers, which combine sewage with stormwater runoff in one pipe. Sanitary sewer systems are beneficial because they avoid combined sewer overflows.\n\n",
        "title": "Sanitary sewer"
    },
    "Shakespeare's Theater": {
        "image": "William Shakespeare.jpg",
        "summary": "William Shakespeare ( 26 April 1564 (baptised) \u2013 23 April 1616) was an English poet, playwright and actor, widely regarded as the greatest writer in the English language and the world's pre-eminent dramatist. He is often called England's national poet and the \"Bard of Avon\". His extant works, including collaborations, consist of approximately 38 plays, 154 sonnets, two long narrative poems and a few other verses, some of uncertain authorship. His plays have been translated into every major living language and are performed more often than those of any other playwright.\nShakespeare was born and brought up in Stratford-upon-Avon, Warwickshire. At the age of 18, he married Anne Hathaway, with whom he had three children: Susanna and twins Hamnet and Judith. Sometime between 1585 and 1592, he began a successful career in London as an actor, writer, and part-owner of a playing company called the Lord Chamberlain's Men, later known as the King's Men. At age 49 around 1613, he appears to have retired to Stratford, where he died three years later. Few records of Shakespeare's private life survive, which has stimulated considerable speculation about such matters as his physical appearance, sexuality, religious beliefs and whether the works attributed to him were written by others.\nShakespeare produced most of his known work between 1589 and 1613. His early plays were primarily comedies and histories, which are regarded as some of the best work ever produced in these genres. He then wrote mainly tragedies until about 1608, including Hamlet, Othello, King Lear and Macbeth, considered some of the finest works in the English language. In his last phase, he wrote tragicomedies, also known as romances and collaborated with other playwrights.\nMany of his plays were published in editions of varying quality and accuracy during his lifetime. However, in 1623 John Heminges and Henry Condell, two friends and fellow actors of Shakespeare, published a more definitive text known as the First Folio, a posthumous collected edition of his dramatic works that included all but two of the plays now recognised as Shakespeare's. It was prefaced with a poem by Ben Jonson, in which Shakespeare is hailed, presciently, as \"not of an age, but for all time\".\nIn the 20th and 21st centuries, his works have been repeatedly adapted and rediscovered by new movements in scholarship and performance. His plays remain highly popular and are constantly studied, performed and reinterpreted in diverse cultural and political contexts throughout the world.",
        "title": "William Shakespeare"
    },
    "Solar Plant": {
        "image": "Solar energy.jpg",
        "summary": "Solar energy is radiant light and heat from the Sun that is harnessed using a range of ever-evolving technologies such as solar heating, photovoltaics, solar thermal energy, solar architecture, molten salt power plants and artificial photosynthesis.\nIt is an important source of renewable energy and its technologies are broadly characterized as either passive solar or active solar depending on how they capture and distribute solar energy or convert it into solar power. Active solar techniques include the use of photovoltaic systems, concentrated solar power and solar water heating to harness the energy. Passive solar techniques include orienting a building to the Sun, selecting materials with favorable thermal mass or light-dispersing properties, and designing spaces that naturally circulate air.\nThe large magnitude of solar energy available makes it a highly appealing source of electricity. The United Nations Development Programme in its 2000 World Energy Assessment found that the annual potential of solar energy was 1,575\u201349,837 exajoules (EJ). This is several times larger than the total world energy consumption, which was 559.8 EJ in 2012.\nIn 2011, the International Energy Agency said that \"the development of affordable, inexhaustible and clean solar energy technologies will have huge longer-term benefits. It will increase countries\u2019 energy security through reliance on an indigenous, inexhaustible and mostly import-independent resource, enhance sustainability, reduce pollution, lower the costs of mitigating global warming, and keep fossil fuel prices lower than otherwise. These advantages are global. Hence the additional costs of the incentives for early deployment should be considered learning investments they must be wisely spent and need to be widely shared\".",
        "title": "Solar energy"
    },
    "Space Component": {
        "image": "Spacecraft propulsion.jpg",
        "summary": "Spacecraft propulsion is any method used to accelerate spacecraft and artificial satellites. There are many different methods. Each method has drawbacks and advantages, and spacecraft propulsion is an active area of research. However, most spacecraft today are propelled by forcing a gas from the back/rear of the vehicle at very high speed through a supersonic de Laval nozzle. This sort of engine is called a rocket engine.\nAll current spacecraft use chemical rockets (bipropellant or solid-fuel) for launch, though some (such as the Pegasus rocket and SpaceShipOne) have used air-breathing engines on their first stage. Most satellites have simple reliable chemical thrusters (often monopropellant rockets) or resistojet rockets for orbital station-keeping and some use momentum wheels for attitude control. Soviet bloc satellites have used electric propulsion for decades, and newer Western geo-orbiting spacecraft are starting to use them for north-south stationkeeping and orbit raising. Interplanetary vehicles mostly use chemical rockets as well, although a few have used ion thrusters and Hall effect thrusters (two different types of electric propulsion) to great success.",
        "title": "Spacecraft propulsion"
    },
    "Space Flight": {
        "image": "Spaceflight.jpg",
        "summary": "Spaceflight (also written space flight) is ballistic flight into or through outer space. Spaceflight can occur with spacecraft with or without humans on board. Examples of human spaceflight include the U.S. Apollo Moon landing and Space Shuttle programs and the Russian Soyuz program, as well as the ongoing International Space Station. Examples of unmanned spaceflight include space probes that leave Earth orbit, as well as satellites in orbit around Earth, such as communications satellites. These operate either by telerobotic control or are fully autonomous.\nSpaceflight is used in space exploration, and also in commercial activities like space tourism and satellite telecommunications. Additional non-commercial uses of spaceflight include space observatories, reconnaissance satellites and other Earth observation satellites.\nA spaceflight typically begins with a rocket launch, which provides the initial thrust to overcome the force of gravity and propels the spacecraft from the surface of the Earth. Once in space, the motion of a spacecraft\u2014both when unpropelled and when under propulsion\u2014is covered by the area of study called astrodynamics. Some spacecraft remain in space indefinitely, some disintegrate during atmospheric reentry, and others reach a planetary or lunar surface for landing or impact.\n\n",
        "title": "Spaceflight"
    },
    "Space Module": {
        "image": "Life support system.jpg",
        "summary": "In human spaceflight, a life support system is a group of devices that allow a human being to survive in space. US government space agency NASA, and private spaceflight companies use the term environmental control and life support system or the acronym ECLSS when describing these systems for their human spaceflight missions. The life support system may supply air, water and food. It must also maintain the correct body temperature, an acceptable pressure on the body and deal with the body's waste products. Shielding against harmful external influences such as radiation and micro-meteorites may also be necessary. Components of the life support system are life-critical, and are designed and constructed using safety engineering techniques.",
        "title": "Life support system"
    },
    "Space Structural": {
        "image": "Spacecraft.jpg",
        "summary": "A spacecraft (S/C)is a vehicle or machine designed to fly in outer space. Spacecraft are used for a variety of purposes, including communications, earth observation, meteorology, navigation, space colonization, planetary exploration, and transportation of humans and cargo.\nOn a sub-orbital spaceflight, a spacecraft enters space and then returns to the surface, without having gone into an orbit. For orbital spaceflights, spacecraft enter closed orbits around the Earth or around other celestial bodies. Spacecraft used for human spaceflight carry people on board as crew or passengers from start or on orbit (space stations) only, whereas those used for robotic space missions operate either autonomously or telerobotically. Robotic spacecraft used to support scientific research are space probes. Robotic spacecraft that remain in orbit around a planetary body are artificial satellites. Only a handful of interstellar probes, such as Pioneer 10 and 11, Voyager 1 and 2, and New Horizons, are on trajectories that leave the Solar System.\nOrbital spacecraft may be recoverable or not. By method of reentry to Earth they may be divided in non-winged space capsules and winged spaceplanes.\nHumanity has achieved space flight but only a few nations have the technology for orbital launches, including: Russia (RSA or \"Roscosmos\"), the United States (NASA), the member states of the European Space Agency (ESA), Japan (JAXA), Iran (ISA), India (ISRO), and China (CNSA).",
        "title": "Spacecraft"
    },
    "Spy": {
        "image": "Espionage.jpg",
        "summary": "Espionage (colloquially, spying) is the obtaining of secret or confidential information without the permission of the holder of the information. Spies help agencies uncover secret information. Any individual or spy ring (a cooperating group of spies), in the service of a government, company or independent operation, can commit espionage. The practice is clandestine, as it is by definition unwelcome and in many cases illegal and punishable by law. Espionage is a subset of \"intelligence\" gathering, which includes espionage as well as information gathering from public sources.\nEspionage is often part of an institutional effort by a government or commercial concern. However, the term tends to associate with state spying on potential or actual enemies for military purposes. Spying involving corporations is known as industrial espionage.\nOne of the most effective ways to gather data and information about the enemy (or potential enemy) is by infiltrating the enemy's ranks. This is the job of the spy (espionage agent). Spies can return all sorts of information concerning the size and strength of enemy forces. They can also find dissidents within the enemy's forces and influence them to defect. In times of crisis, spies can also oblige to steal technology and sabotage the enemy in various ways. Counterintelligence operatives can feed false information to enemy spies, protecting important domestic secrets, and preventing attempts at subversion. Almost all nations have strict laws concerning espionage and the penalty for being caught is often severe. However, the benefits through espionage are often great enough that most governments and many large corporations make use of it to varying degrees.\nFurther information on clandestine human intelligence and human intelligence information collection techniques is available, including discussions of operational techniques, asset recruiting, and the tradecraft used to collect this information.",
        "title": "Espionage"
    },
    "Statue of Liberty": {
        "image": "Statue of Liberty.jpg",
        "summary": "The Statue of Liberty (Liberty Enlightening the World French: La Libert\u00e9 \u00e9clairant le monde) is a colossal neoclassical sculpture on Liberty Island in New York Harbor in New York City, in the United States. The copper statue, a gift from the people of France to the people of the United States, was designed by French sculptor Fr\u00e9d\u00e9ric Auguste Bartholdi and built by Gustave Eiffel. The statue was dedicated on October 28, 1886.\nThe Statue of Liberty is a figure of a robed woman representing Libertas, a Roman goddess. She holds a torch above her head with her right hand, and in her left hand carries a tabula ansata inscribed in Roman numerals with \"JULY IV MDCCLXXVI\" (July 4, 1776), the date of the U.S. Declaration of Independence. A broken chain lies at her feet. The statue became an icon of freedom and of the United States, and was a welcoming sight to immigrants arriving from abroad.\nBartholdi was inspired by a French law professor and politician, \u00c9douard Ren\u00e9 de Laboulaye, who is said to have commented in 1865 that any monument raised to U.S. independence would properly be a joint project of the French and American peoples. Because of the post-war instability in France, work on the statue did not commence until the early 1870s. In 1875, Laboulaye proposed that the French finance the statue and the U.S. provide the site and build the pedestal. Bartholdi completed the head and the torch-bearing arm before the statue was fully designed, and these pieces were exhibited for publicity at international expositions.\nThe torch-bearing arm was displayed at the Centennial Exposition in Philadelphia in 1876, and in Madison Square Park in Manhattan from 1876 to 1882. Fundraising proved difficult, especially for the Americans, and by 1885 work on the pedestal was threatened by lack of funds. Publisher Joseph Pulitzer, of the New York World, started a drive for donations to finish the project and attracted more than 120,000 contributors, most of whom gave less than a dollar. The statue was built in France, shipped overseas in crates, and assembled on the completed pedestal on what was then called Bedloe's Island. The statue's completion was marked by New York's first ticker-tape parade and a dedication ceremony presided over by President Grover Cleveland.\nThe statue was administered by the United States Lighthouse Board until 1901 and then by the Department of War since 1933 it has been maintained by the National Park Service. Public access to the balcony around the torch has been barred for safety since 1916.",
        "title": "Statue of Liberty"
    },
    "Stealth": {
        "image": "Stealth technology.jpg",
        "summary": "Stealth technology also termed LO technology (low observable technology) is a sub-discipline of military tactics and passive electronic countermeasures, which cover a range of techniques used with personnel, aircraft, ships, submarines, missiles and satellites to make them less visible (ideally invisible) to radar, infrared, sonar and other detection methods. It corresponds to military camouflage for these parts of the electromagnetic spectrum (Multi-spectral camouflage).\nDevelopment of modern stealth technologies in the United States began in 1958, where earlier attempts in preventing radar tracking of its U-2 spy planes during the Cold War by the Soviet Union had been unsuccessful. Designers turned to develop a particular shape for planes that tended to reduce detection, by redirecting electromagnetic waves from radars. Radar-absorbent material was also tested and made to reduce or block radar signals that reflect off from the surface of planes. Such changes to shape and surface composition form stealth technology as currently used on the Northrop Grumman B-2 Spirit \"Stealth Bomber\".\nThe concept of stealth is to operate or hide without giving enemy forces any indications as to the presence of friendly forces. This concept was first explored through camouflage by blending into the background visual clutter. As the potency of detection and interception technologies (radar, Infra-red search and track, surface-to-air missiles, etc.) have increased over time, so too has the extent to which the design and operation of military personnel and vehicles have been affected in response. Some military uniforms are treated with chemicals to reduce their infrared signature. A modern \"stealth\" vehicle is designed from the outset to have a chosen spectral signature. The degree of stealth embodied in a particular design is chosen according to the predicted capabilities of projected threats.",
        "title": "Stealth technology"
    },
    "Stealth Bomber": {
        "image": "Stealth aircraft.jpg",
        "summary": "Stealth aircraft are designed to avoid detection using a variety of technologies that reduce reflection/emission of radar, infrared, visible light, radio-frequency (RF) spectrum, and audio, collectively known as stealth technology. Development of stealth technology likely began in Germany during World War II, the prototyped Horten Ho 229 was designed for twin BMW 003 jet engines but finally powered by twin Junkers Jumo 004 jet engines being described as the first stealth aircraft. Well-known modern examples of stealth of U.S. aircraft include the United States' F-117 Nighthawk (1981\u20132008), the B-2 Spirit, the F-22 Raptor, and the F-35 Lightning II.\nWhile no aircraft is totally invisible to radar, stealth aircraft make it more difficult for conventional radar to detect or track the aircraft effectively, increasing the odds of an aircraft successfully avoiding detection by enemy radar and/or avoiding being successfully targeted by radar guided weapons. Stealth is the combination of passive low observable (LO) features and active emitters such as low-probability-of-intercept radars, radios and laser designators. These are usually combined with active measures such as carefully planning all mission maneuvers in order to minimize the aircraft's radar cross section, since common actions such as hard turns or opening bomb bay doors can more than double an otherwise stealthy aircraft's radar return. It is accomplished by using a complex design philosophy to reduce the ability of an opponent's sensors to detect, track, or attack the stealth aircraft. This philosophy also takes into account the heat, sound, and other emissions of the aircraft as these can also be used to locate it.\nFull-size stealth combat aircraft demonstrators have been flown by the United States (in 1977), Russia (in 2010) and China (in 2011). As of March 2017, the United States Armed Forces utilize three models of dedicated, manned stealth aircraft and the Chinese Air Force operates one, with a number of other countries developing their own designs. There are also various aircraft with reduced detectability, either unintentionally or as a secondary feature.",
        "title": "Stealth aircraft"
    },
    "Stealth Fighter": {
        "image": "Stealth aircraft.jpg",
        "summary": "Stealth aircraft are designed to avoid detection using a variety of technologies that reduce reflection/emission of radar, infrared, visible light, radio-frequency (RF) spectrum, and audio, collectively known as stealth technology. Development of stealth technology likely began in Germany during World War II, the prototyped Horten Ho 229 was designed for twin BMW 003 jet engines but finally powered by twin Junkers Jumo 004 jet engines being described as the first stealth aircraft. Well-known modern examples of stealth of U.S. aircraft include the United States' F-117 Nighthawk (1981\u20132008), the B-2 Spirit, the F-22 Raptor, and the F-35 Lightning II.\nWhile no aircraft is totally invisible to radar, stealth aircraft make it more difficult for conventional radar to detect or track the aircraft effectively, increasing the odds of an aircraft successfully avoiding detection by enemy radar and/or avoiding being successfully targeted by radar guided weapons. Stealth is the combination of passive low observable (LO) features and active emitters such as low-probability-of-intercept radars, radios and laser designators. These are usually combined with active measures such as carefully planning all mission maneuvers in order to minimize the aircraft's radar cross section, since common actions such as hard turns or opening bomb bay doors can more than double an otherwise stealthy aircraft's radar return. It is accomplished by using a complex design philosophy to reduce the ability of an opponent's sensors to detect, track, or attack the stealth aircraft. This philosophy also takes into account the heat, sound, and other emissions of the aircraft as these can also be used to locate it.\nFull-size stealth combat aircraft demonstrators have been flown by the United States (in 1977), Russia (in 2010) and China (in 2011). As of March 2017, the United States Armed Forces utilize three models of dedicated, manned stealth aircraft and the Chinese Air Force operates one, with a number of other countries developing their own designs. There are also various aircraft with reduced detectability, either unintentionally or as a secondary feature.",
        "title": "Stealth aircraft"
    },
    "Steam Engine": {
        "image": "Steam engine.jpg",
        "summary": "A steam engine is a heat engine that performs mechanical work using steam as its working fluid.\nSteam engines are external combustion engines, where the working fluid is separated from the combustion products. Non-combustion heat sources such as solar power, nuclear power or geothermal energy may be used. The ideal thermodynamic cycle used to analyze this process is called the Rankine cycle. In the cycle, water is heated and transforms into steam within a boiler operating at a high pressure. When expanded through pistons or turbines, mechanical work is done. The reduced pressure steam is then exhausted to the atmosphere, or condensed and pumped back into the boiler.\nIn general usage, the term steam engine can refer to either the integrated steam plants (including boilers etc.) such as railway steam locomotives and portable engines, or may refer to the piston or turbine machinery alone, as in the beam engine and stationary steam engine. Specialized devices such as steam hammers and steam pile drivers are dependent on the steam pressure supplied from a separate boiler.\nThe use of boiling water to produce mechanical motion goes back over 2000 years, but early devices were not highly practical. The Spanish inventor Jer\u00f3nimo de Ayanz y Beaumont obtained a patent for a rudimentary steam-powered water pump in 1606. In 1698 Thomas Savery patented a steam pump that used steam in direct contact with the water being pumped. Savery's steam pump used condensing steam to create a vacuum and draw water into a chamber, and then applied pressurized steam to further pump the water.\nThomas Newcomen's atmospheric engine was the first commercial true steam engine using a piston, and was used in 1712 for pumping in a mine. They became popular for mining and 104 were in use by 1733. Eventually over two thousand of them were installed.\nIn 1781 Scottish engineer James Watt patented a steam engine that produced continuous rotary motion. Watt's ten-horsepower engines enabled a wide range of manufacturing machinery to be powered. The engines could be sited anywhere that water and coal or wood fuel could be obtained. By 1883, engines that could provide 10,000 hp had become feasible. The stationary steam engine was a key component of the Industrial Revolution, allowing factories to locate where water power was unavailable. The atmospheric engines of Newcomen and Watt were large compared to the amount of power they produced, but high-pressure steam engines were light enough to be applied to vehicles such as traction engines and the railway locomotives.\nReciprocating piston type steam engines remained the dominant source of power until the early 20th century, when advances in the design of electric motors and internal combustion engines gradually resulted in the replacement of reciprocating (piston) steam engines in commercial usage, and the ascendancy of steam turbines in power generation. Considering that the great majority of worldwide electric generation is produced by turbine type steam engines, the \"steam age\" is continuing with energy levels far beyond those of the turn of the 19th and 20th century.",
        "title": "Steam engine"
    },
    "Steel": {
        "image": "Steel.jpg",
        "summary": "Steel is an alloy of iron and carbon with trace amounts of other elements. Because of its high tensile strength and low cost, it is a major component used in buildings, infrastructure, tools, ships, automobiles, machines, appliances, and weapons.\nSteel base metal is iron, which is able to take on two crystalline forms (allotropic forms), body centered cubic (BCC) and face centered cubic (FCC), depending on its temperature. It is the interaction of those allotropes with the alloying elements, primarily carbon, that gives steel and cast iron their range of unique properties. In the body-centred cubic arrangement, there is an iron atom in the centre of each cube, and in the face-centred cubic, there is one at the center of each of the six faces of the cube.\nIn pure iron, the crystal structure has relatively little resistance to the iron atoms slipping past one another, and so pure iron is quite ductile, or soft and easily formed. In steel, small amounts of carbon, other elements, and inclusions within the iron act as hardening agents that prevent the movement of dislocations that otherwise occur in the crystal lattices of iron atoms.\nThe carbon in typical steel alloys may contribute up to 2.14% of its weight. Varying the amount of carbon and many other alloying elements, as well as controlling their chemical and physical makeup in the final steel (either as solute elements, or as precipitated phases), slows the movement of those dislocations that make pure iron ductile, and thus controls and enhances its qualities. These qualities include such things as the hardness, quenching behavior, need for annealing, tempering behavior, yield strength, and tensile strength of the resulting steel. The increase in steel's strength compared to pure iron is only possible by reducing iron's ductility.\nSteel was produced in bloomery furnaces for thousands of years, but its large-scale, industrial use only began after more efficient production methods were devised in the 17th century, with the production of blister steel and then crucible steel. With the invention of the Bessemer process in the mid-19th century, a new era of mass-produced steel began. This was followed by the Siemens-Martin process and then the Gilchrist-Thomas process that refined the quality of steel. With their introductions, mild steel replaced wrought iron.\nFurther refinements in the process, such as basic oxygen steelmaking (BOS), largely replaced earlier methods by further lowering the cost of production and increasing the quality of the final product. Today, steel is one of the most common man-made materials in the world, with more than 1.6 billion tons produced annually. Modern steel is generally identified by various grades defined by assorted standards organizations.",
        "title": "Steel"
    },
    "Stock Exchange": {
        "image": "Stock exchange.jpg",
        "summary": "A stock exchange is an exchange (or bourse) where stock brokers and traders can buy and sell shares of stock, bonds, and other securities. Stock exchanges may also provide facilities for issue and redemption of securities and other financial instruments and capital events including the payment of income and dividends. Securities traded on a stock exchange include stock issued by listed companies, unit trusts, derivatives, pooled investment products and bonds. Stock exchanges often function as \"continuous auction\" markets with buyers and sellers consummating transactions at a central location such as the floor of the exchange.\nTo be able to trade a security on a certain stock exchange, it must be listed there. Usually, there is a central location at least for record keeping, but trade is increasingly less linked to such a physical place, as modern markets use electronic networks, which gives them advantages of increased speed and reduced cost of transactions. Trade on an exchange is restricted to brokers who are members of the exchange. In recent years, various other trading venues, such as electronic communication networks, alternative trading systems and \"dark pools\" have taken much of the trading activity away from traditional stock exchanges.\nThe initial public offering of stocks and bonds to investors is by definition done in the primary market and subsequent trading is done in the secondary market. A stock exchange is often the most important component of a stock market. Supply and demand in stock markets are driven by various factors that, as in all free markets, affect the price of stocks (see stock valuation).\nThere is usually no obligation for stock to be issued via the stock exchange itself, nor must stock be subsequently traded on the exchange. Such trading may be off exchange or over-the-counter. This is the usual way that derivatives and bonds are traded. Increasingly, stock exchanges are part of a global securities market.",
        "title": "Stock exchange"
    },
    "Submarine": {
        "image": "Submarine.jpg",
        "summary": "A submarine (or simply sub) is a watercraft capable of independent operation underwater. It differs from a submersible, which has more limited underwater capability. The term most commonly refers to a large, crewed vessel. It is also sometimes used historically or colloquially to refer to remotely operated vehicles and robots, as well as medium-sized or smaller vessels, such as the midget submarine and the wet sub. The noun submarine evolved as a shortened form of submarine boat by naval tradition, submarines are usually referred to as \"boats\" rather than as \"ships\", regardless of their size (boat is usually reserved for seagoing vessels of relatively small size).\nAlthough experimental submarines had been built before, submarine design took off during the 19th century, and they were adopted by several navies. Submarines were first widely used during World War I (1914\u20131918), and now figure in many navies large and small. Military uses include attacking enemy surface ships (merchant and military), attacking other submarines, aircraft carrier protection, blockade running, ballistic missile submarines as part of a nuclear strike force, reconnaissance, conventional land attack (for example using a cruise missile), and covert insertion of special forces. Civilian uses for submarines include marine science, salvage, exploration and facility inspection and maintenance. Submarines can also be modified to perform more specialized functions such as search-and-rescue missions or undersea cable repair. Submarines are also used in tourism, and for undersea archaeology.\nMost large submarines consist of a cylindrical body with hemispherical (or conical) ends and a vertical structure, usually located amidships, which houses communications and sensing devices as well as periscopes. In modern submarines, this structure is the \"sail\" in American usage, and \"fin\" in European usage. A \"conning tower\" was a feature of earlier designs: a separate pressure hull above the main body of the boat that allowed the use of shorter periscopes. There is a propeller (or pump jet) at the rear, and various hydrodynamic control fins. Smaller, deep-diving and specialty submarines may deviate significantly from this traditional layout. Submarines use diving planes and also change the amount of water and air in ballast tanks to change buoyancy for submerging and surfacing.\nSubmarines have one of the widest ranges of types and capabilities of any vessel. They range from small autonomous examples and one- or two-person vessels that operate for a few hours, to vessels that can remain submerged for six months\u2014such as the Russian Typhoon class, the biggest submarines ever built. Submarines can work at greater depths than are survivable or practical for human divers. Modern deep-diving submarines derive from the bathyscaphe, which in turn evolved from the diving bell.",
        "title": "Submarine"
    },
    "Sun Tzu's War Academy": {
        "image": "Sun Tzu.jpg",
        "summary": "Sun Tzu ( also rendered as Sun Zi \u5b6b\u5b50) was a Chinese general, military strategist, and philosopher who lived in the Spring and Autumn period of ancient China. Sun Tzu is traditionally credited as the author of The Art of War, a widely influential work of military strategy that has affected both Western and Eastern philosophy. Aside from his legacy as the author of The Art of War, Sun Tzu is revered in Chinese and the Culture of Asia as a legendary historical figure. His birth name was Sun Wu, and he was known outside of his family by his courtesy name Changqing. The name Sun Tzu by which he is best known in the West is an honorific which means \"Master Sun\".\nSun Tzu's historicity is uncertain. Sima Qian and other traditional historians placed him as a minister to King Hel\u00fc of Wu and dated his lifetime to 544\u2013496 BC. Modern scholars accepting his historicity nonetheless place the existing text of The Art of War in the later Warring States period based upon its style of composition and its descriptions of warfare. Traditional accounts state that the general's descendant Sun Bin also wrote a treatise on military tactics, also titled The Art of War. Since both Sun Wu and Sun Bin were referred to as Sun Tzu in classical Chinese texts, some historians believed them identical prior to the rediscovery of Sun Bin's treatise in 1972.\nSun Tzu's work has been praised and employed throughout East Asia since its composition. During the twentieth century, The Art of War grew in popularity and saw practical use in Western society as well. It continues to influence many competitive endeavors in Asia, Europe, and Americas including culture, politics, business, and sports, as well as modern warfare.",
        "title": "Sun Tzu"
    },
    "Super Highways": {
        "image": "Controlled-access highway.jpg",
        "summary": "A controlled-access highway is a type of highway which has been designed for high-speed vehicular traffic, with all traffic flow and ingress/egress regulated. Common English terms are freeway (in Australia, South Africa and parts of the United States and Canada), motorway (in the United Kingdom, Ireland and New Zealand) and expressway (some parts of Canada, parts of the United States, and many Asian countries). Other similar terms include Interstate and parkway. Some of these may be limited-access highways, although this term can also refer to a class of highway with somewhat less isolation from other traffic.\nIn countries following the Vienna convention, the motorway qualification implies they are forbidden for walking or parking, and reserved for the use of motorised vehicles only.\nA controlled-access highway provides an unhindered flow of traffic, with no traffic signals, intersections or property access. They are free of any at-grade crossings with other roads, railways, or pedestrian paths, which are instead carried by overpasses and underpasses. Entrances and exits to the highway are provided at interchanges by slip roads (ramps), which allow for speed changes between the highway and arterials and collector roads. On the controlled-access highway, opposing directions of travel are generally separated by a median strip or central reservation containing a traffic barrier or grass. Elimination of conflicts with other directions of traffic dramatically improves safety and capacity.\nControlled-access highways evolved during the first half of the 20th century. Italy opened its first autostrada in 1924, A8, connecting Milan to Varese. Germany began to build its first controlled-access autobahn without speed limits (30-kilometre (19 mi) on what is now A555, then referred to as a dual highway) in 1932 between Cologne and Bonn. It then rapidly constructed a nationwide system of such roads. The first North American freeways (known as parkways) opened in the New York City area in the 1920s. Britain, heavily influenced by the railways, did not build its first motorway, the Preston By-pass (M6), until 1958.\nMost technologically advanced nations feature an extensive network of freeways or motorways to provide high-capacity urban travel, or high-speed rural travel, or both. Many have a national-level or even international-level (e.g. European E route) system of route numbering.",
        "title": "Controlled-access highway"
    },
    "Superconductors": {
        "image": "Superconductivity.jpg",
        "summary": "Superconductivity is a phenomenon of exactly zero electrical resistance and expulsion of magnetic flux fields occurring in certain materials, called superconductors, when cooled below a characteristic critical temperature. It was discovered by Dutch physicist Heike Kamerlingh Onnes on April 8, 1911, in Leiden. Like ferromagnetism and atomic spectral lines, superconductivity is a quantum mechanical phenomenon. It is characterized by the Meissner effect, the complete ejection of magnetic field lines from the interior of the superconductor as it transitions into the superconducting state. The occurrence of the Meissner effect indicates that superconductivity cannot be understood simply as the idealization of perfect conductivity in classical physics.\nThe electrical resistance of a metallic conductor decreases gradually as temperature is lowered. In ordinary conductors, such as copper or silver, this decrease is limited by impurities and other defects. Even near absolute zero, a real sample of a normal conductor shows some resistance. In a superconductor the resistance drops abruptly to zero when the material is cooled below its critical temperature. An electric current through a loop of superconducting wire can persist indefinitely with no power source.\nIn 1986, it was discovered that some cuprate-perovskite ceramic materials have a critical temperature above 90 K (\u2212183 \u00b0C). Such a high transition temperature is theoretically impossible for a conventional superconductor, leading the materials to be termed high-temperature superconductors. The cheaply-available coolant liquid nitrogen boils at 77 K, and thus superconduction at higher temperatures than this facilitates many experiments and applications that are less practical at lower temperatures.",
        "title": "Superconductivity"
    },
    "Supermarket": {
        "image": "Supermarket.jpg",
        "summary": "A supermarket is a self-service shop offering a wide variety of food and household products, organized into aisles. It is larger and has a wider selection than a traditional grocery store, but is smaller and more limited in the range of merchandise than a hypermarket or big-box market.\nThe supermarket typically comprises meat, fresh produce, dairy, and baked goods aisles, along with shelf space reserved for canned and packaged goods as well as for various non-food items such as kitchenware, household cleaners, pharmacy products and pet supplies. Some supermarkets also sell a variety of other household products that are consumed regularly, such as alcohol (where permitted), medicine, and clothes, and some stores sell a much wider range of non-food products: DVDs, sporting equipment, board games, and seasonal items (e.g., Christmas wrapping paper in December).\nThe traditional supermarket occupies a large amount of floor space, usually on a single level. It is usually situated near a residential area in order to be convenient to consumers. The basic appeal is the availability of a broad selection of goods under a single roof, at relatively low prices. Other advantages include ease of parking and frequently the convenience of shopping hours that extend into the evening or even 24 hours of the day. Supermarkets usually allocate large budgets to advertising, typically through newspapers. They also present elaborate in-shop displays of products.\nSupermarkets typically are chain stores, supplied by the distribution centres of their parent companies thus increasing opportunities for economies of scale. Supermarkets usually offer products at relatively low prices by using their buying power to buy goods from manufacturers at lower prices than smaller stores can. They also minimise financing costs by paying for goods at least 30 days after receipt and some extract credit terms of 90 days or more from vendors. Certain products (typically staple foods such as bread, milk and sugar) are very occasionally sold as loss leaders so as to attract shoppers to their store. Supermarkets make up for their low margins by a higher overall volume of sales, and with the sale of higher-margin items bought by the intended higher volume of shoppers. Customers usually shop by placing their selected merchandise into shopping carts (trolleys) or baskets (self-service) and pay for the merchandise at the check-out. Many supermarket chains are attempting to further reduce labor costs by shifting to self-service check-out machines, where a single employee can oversee and assist multiple customers at a time.\nA larger full-service supermarket combined with a department store is sometimes known as a hypermarket. Other services offered at some supermarkets may include those of banks, caf\u00e9s, childcare centres/creches, insurance (and other financial services), Mobile Phone services, photo processing, video rentals, pharmacies and/or petrol stations. If the eatery in a supermarket is substantial enough, the facility may be called a \"grocerant\", a portmanteau of \"grocery\" and \"restaurant\".",
        "title": "Supermarket"
    },
    "Tactics": {
        "image": "Military tactics.jpg",
        "summary": "Military tactics are the science and art of organizing a military force, and the techniques for combining and using weapons and military units to engage and defeat an enemy in battle. Changes in philosophy and technology have been reflected in changes to military tactics. In contemporary military science, tactics are the lowest of three planning levels: (i) strategic, (ii) operational, and (iii) tactical. The highest level of planning is strategy: how force is translated into political objectives by bridging the means and ends of war. The intermediate level, operational, the conversion of strategy into tactics, deals with formations of units. In the vernacular, tactical decisions are those made to achieve the greatest immediate value strategic decisions are those made to achieve the greatest overall value, irrespective of the immediate results of a tactical decision.",
        "title": "Military tactics"
    },
    "Temple": {
        "image": "Temple.jpg",
        "summary": "A temple (from the Latin word templum) is a structure reserved for religious or spiritual rituals and activities such as prayer and sacrifice. It is typically used for such buildings belonging to all faiths where a more specific term such as church, mosque or synagogue is not generally used in English. These include Hinduism, Buddhism, and Jainism among religions with many modern followers, as well as other ancient religions such as Ancient Egyptian religion.\nThe form and function of temples is thus very variable, though they are often considered by believers to be in some sense the \"house\" of one or more deities. Typically offerings of some sort are made to the deity, and other rituals enacted, and a special group of clergy maintain, and operate the temple. The degree to which the whole population of believers can access the building varies significantly often parts or even the whole main building can only be accessed by the clergy. Temples typically have a main building and a larger precinct, which may contain many other buildings.\nThe word comes from Ancient Rome, where a templum constituted a sacred precinct as defined by a priest, or augur. It has the same root as the word \"template\", a plan in preparation of the building that was marked out on the ground by the augur. Templa also became associated with the dwelling places of a god or gods. Despite the specific set of meanings associated with the word, it has now become widely used to describe a house of worship for any number of religions and is even used for time periods prior to the Romans.",
        "title": "Temple"
    },
    "The Corporation": {
        "image": "Corporation.jpg",
        "summary": "A corporation is a company or group of people authorized to act as a single entity (legally a person) and recognized as such in law. Early incorporated entities were established by charter (i.e. by an ad hoc act granted by a monarch or passed by a parliament or legislature). Most jurisdictions now allow the creation of new corporations through registration.\nCorporations come in many different types but are usually divided by the law of the jurisdiction where they are chartered into two kinds: by whether they can issue stock or not, or by whether they are formed to make a profit or not.\nWhere local law distinguishes corporations by ability to issue stock, corporations allowed to do so are referred to as \"stock corporations\", ownership of the corporation is through stock, and owners of stock are referred to as \"stockholders\" or \"shareholders\". Corporations not allowed to issue stock are referred to as \"non-stock\" corporations those who are considered the owners of a non-stock corporation are persons (or other entities) who have obtained membership in the corporation, and are referred to as a \"member\" of the corporation.\nCorporations chartered in regions where they are distinguished by whether they are allowed to be for profit or not are referred to as \"for profit\" and \"not-for-profit\" corporations, respectively.\nThere is some overlap between stock/non-stock and for profit/not-for-profit in that not-for-profit corporations are always non-stock as well. A for profit corporation is almost always a stock corporation, but some for profit corporations may choose to be non-stock. To simplify the explanation, whenever \"Stockholder\" or \"Shareholder\" is used in the rest of this article to refer to a stock corporation, it is presumed to mean the same as \"member\" for a non-profit corporation or for a profit, non-stock corporation.\nRegistered corporations have legal personality and are owned by shareholders whose liability is generally limited to their investment. Shareholders do not typically actively manage a corporation shareholders instead elect or appoint a board of directors to control the corporation in a fiduciary capacity. In most circumstances, a shareholder may also serve as a director or officer of a corporation.\nIn American English, the word corporation is most often used to describe large business corporations. In British English and in the Commonwealth countries, the term company is more widely used to describe the same sort of entity while the word corporation encompasses all incorporated entities. In American English, the word company can include entities such as partnerships that would not be referred to as companies in British English as they are not a separate legal entity.\nDespite not being individual human beings, corporations, as far as the law is concerned, are legal persons, and have many of the same rights and responsibilities as natural persons do. For example, a corporation can own property, and can sue or be sued.\n\nCorporations can exercise human rights against real individuals and the state, and they can themselves be responsible for human rights violations. Corporations can be \"dissolved\" either by statutory operation, order of court, or voluntary action on the part of shareholders. Insolvency may result in a form of corporate failure, when creditors force the liquidation and dissolution of the corporation under court order, but it most often results in a restructuring of corporate holdings. Corporations can even be convicted of criminal offenses, such as fraud and manslaughter. However, corporations are not considered living entities in the way that humans are.\nLate in the 19th century, a new form of company having the limited liability protections of a corporation, and the more favorable tax treatment of either a sole proprietorship or partnership was developed. While not a corporation, this new type of entity became very attractive as an alternative for corporations not needing to issue stock. In Germany, the organization was referred to as Gesellschaft mit beschr\u00e4nkter Haftung or GmbH. In the last quarter of the 20th Century this new form of non-corporate organization became available in the United States and other countries, and was known as the limited liability company or LLC. Since the GmbH and LLC forms of organization are technically not corporations (even though they have many of the same features), they will not be discussed in this article.",
        "title": "Corporation"
    },
    "The Republic": {
        "image": "Republic.jpg",
        "summary": "A republic (Latin: res publica) is a form of government in which the country is considered a \"public matter\", not the private concern or property of the rulers. The primary positions of power within a republic are not inherited, but are attained through elections expressing the consent of the governed. Such leadership positions are therefore expected to fairly represent the citizen body. It is a form of government under which the head of state is not a monarch. In American English, the definition of a republic can also refer specifically to a government in which elected individuals represent the citizen body, known elsewhere as a representative democracy (a democratic republic) and exercise power according to the rule of law (a constitutional republic).\nAs of 2017, 159 of the world's 206 sovereign states use the word \"republic\" as part of their official names \u2013 not all of these are republics in the sense of having elected governments, nor is the word \"republic\" used in the names of all nations with elected governments. While heads-of-state often tend to claim that they rule only by the \"consent of the governed\", elections in some countries have been found to be held more for the purpose of \u201cshow\u201d than for the actual purpose of in reality providing citizens with any genuine ability to choose their own leaders.\nThe term \u201crepublic\u201d was first coined ca. 500 BC in Rome, but over time the term has undergone several changes in meaning. Initially the Latin term \u201cres publica\u201d signified the earlier \u201cpartial form of democracy\u201d as found in Rome from c. 500 BC until c. 27 BC. In this early Roman partial-democracy, the power of the aristocratic or patrician class who held all of the seats in the Roman Senate, was checked by the institution of the consulship, whose two consul/vice-rulers were elected annually by the free citizens or plebes of Rome. The ancient Roman definition of the word differs from the modern use of the term, where no leadership positions are held to be restricted to only the \"ruling class\".\nMost often a republic is a single sovereign state, but there are also sub-sovereign state entities that are referred to as republics, or that have governments that are described as \"republican\" in nature. For instance, Article IV of the United States Constitution \"guarantee[s] to every State in this Union a Republican form of Government\". In contrast, the former Soviet Union, which described itself as being a group of \"Republics\" and also as a \"federal multinational state composed of 15 republics\", was widely viewed as being an authoritarian form of government and not as a republican form of government. It was seen as authoritarian, as its electoral system was structured so as to automatically guarantee the election of government sponsored candidates.",
        "title": "Republic"
    },
    "The Wheel": {
        "image": "Wheel.jpg",
        "summary": "A wheel is a circular component that is intended to rotate on an axle bearing. The wheel is one of the key components of the wheel and axle which is one of the six simple machines. Wheels, in conjunction with axles, allow heavy objects to be moved easily facilitating movement or transportation while supporting a load, or performing labor in machines. Wheels are also used for other purposes, such as a ship's wheel, steering wheel, potter's wheel and flywheel.\nCommon examples are found in transport applications. A wheel greatly reduces friction by facilitating motion by rolling together with the use of axles. In order for wheels to rotate, a moment needs to be applied to the wheel about its axis, either by way of gravity or by the application of another external force or torque.",
        "title": "Wheel"
    },
    "Theology": {
        "image": "Theology.jpg",
        "summary": "Theology is the critical study of the nature of the divine. It is taught as an academic discipline, typically in universities, seminaries, and schools of divinity.",
        "title": "Theology"
    },
    "Theory of Gravity": {
        "image": "Gravity.jpg",
        "summary": "Gravity, or gravitation, is a natural phenomenon by which all things with mass are brought toward (or gravitate toward) one another, including objects ranging from atoms and photons, to planets and stars. Since energy and mass are equivalent, all forms of energy (including light) cause gravitation and are under the influence of it. On Earth, gravity gives weight to physical objects, and the Moon's gravity causes the ocean tides. The gravitational attraction of the original gaseous matter present in the Universe caused it to begin coalescing, forming stars \u2013 and for the stars to group together into galaxies \u2013 so gravity is responsible for many of the large scale structures in the Universe. Gravity has an infinite range, although its effects become increasingly weaker on farther objects.\nGravity is most accurately described by the general theory of relativity (proposed by Albert Einstein in 1915) which describes gravity not as a force, but as a consequence of the curvature of spacetime caused by the uneven distribution of mass. The most extreme example of this curvature of spacetime is a black hole, from which nothing -- not even light -- can escape once past the black hole's event horizon. However, for most applications, gravity is well approximated by Newton's law of universal gravitation, which describes gravity as a force which causes any two bodies to be attracted to each other, with the force proportional to the product of their masses and inversely proportional to the square of the distance between them.\nGravity is the weakest of the four fundamental forces of physics, approximately 1038 times weaker than the strong force, 1036 times weaker than the electromagnetic force and 1029 times weaker than the weak force. As a consequence, it has no significant influence at the level of subatomic particles. In contrast, it is the dominant force at the macroscopic scale, and is the cause of the formation, shape and trajectory (orbit) of astronomical bodies. For example, gravity causes the Earth and the other planets to orbit the Sun, it also causes the Moon to orbit the Earth, and causes the formation of tides, the formation and evolution of the Solar System, stars and galaxies.\nThe earliest instance of gravity in the Universe, possibly in the form of quantum gravity, supergravity or a gravitational singularity, along with ordinary space and time, developed during the Planck epoch (up to 10\u221243 seconds after the birth of the Universe), possibly from a primeval state, such as a false vacuum, quantum vacuum or virtual particle, in a currently unknown manner. Attempts to develop a theory of gravity consistent with quantum mechanics, a quantum gravity theory, which would allow gravity to be united in a common mathematical framework (a theory of everything) with the other three forces of physics, are a current area of research.",
        "title": "Gravity"
    },
    "Trade": {
        "image": "Trade.jpg",
        "summary": "Trade involves the transfer of goods or services from one person or entity to another, often in exchange for money. A network that allows trade is called a market.\nThe original form of trade, barter, saw the direct exchange of goods and services for other goods and services. Barter is trading things without the use of money. Later one side of the barter started to involve precious metals, which gained symbolic as well as practical importance. Modern traders generally negotiate through a medium of exchange, such as money. As a result, buying can be separated from selling, or earning. The invention of money (and later credit, paper money and non-physical money) greatly simplified and promoted trade. Trade between two traders is called bilateral trade, while trade between more than two traders is called multilateral trade.\nTrade exists due to the specialization and division of labor, in which most people concentrate on a small aspect of production, but use that output in trades for other products and needs. Trade exists between regions because different regions may have a comparative advantage (perceived or real) in the production of some trade-able commodity\u2014including production of natural resources scarce or limited elsewhere, or because different regions' size may encourage mass production. As such, trade at market prices between locations can benefit both locations.\nRetail trade consists of the sale of goods or merchandise from a very fixed location, such as a department store, boutique or kiosk, online or by mail, in small or individual lots for direct consumption or use by the purchaser. Wholesale trade is defined as the sale of goods that are sold as merchandise to retailers, or industrial, commercial, institutional, or other professional business users, or to other wholesalers and related subordinated services.",
        "title": "Trade"
    },
    "Transport": {
        "image": "Troopship.jpg",
        "summary": "A troopship (also troop ship or troop transport or trooper) is a ship used to carry soldiers, either in peacetime or wartime. Operationally, standard troopships \u2013 often drafted from commercial shipping fleets \u2013 cannot land troops directly on shore, typically loading and unloading at a seaport or onto smaller vessels, either tenders or barges.\nAttack transports, a variant of ocean-going troopship adapted to transporting invasion forces ashore, carry their own fleet of landing craft. Landing ships beach themselves and bring their troops directly ashore.\n\n",
        "title": "Troopship"
    },
    "Trireme": {
        "image": "Trireme.jpg",
        "summary": "A trireme ( derived from Latin: trir\u0113mis \"with three banks of oars\" Ancient Greek: \u03c4\u03c1\u03b9\u03ae\u03c1\u03b7\u03c2 tri\u0113r\u0113s, literally \"three-rower\") was an ancient vessel and a type of galley that was used by the ancient maritime civilizations of the Mediterranean, especially the Phoenicians, ancient Greeks and Romans.\nThe trireme derives its name from its three rows of oars, manned with one man per oar. The early trireme was a development of the penteconter, an ancient warship with a single row of 25 oars on each side (i.e., a single-banked boat), and of the bireme (Ancient Greek: \u03b4\u03b9\u03ae\u03c1\u03b7\u03c2, di\u0113r\u0113s), a warship with two banks of oars, of Phoenician origin. The word dieres does not appear until the Roman period. \"It must be assumed the term pentekontor covered the two-level type\". As a ship it was fast and agile, and it was the dominant warship in the Mediterranean during the 7th to 4th centuries BC, after which it was largely superseded by the larger quadriremes and quinqueremes. Triremes played a vital role in the Persian Wars, the creation of the Athenian maritime empire, and its downfall in the Peloponnesian War.\nThe term is sometimes also used to refer to medieval and early modern galleys with three files of oarsmen per side as triremes.",
        "title": "Trireme"
    },
    "United Nations": {
        "image": "United Nations.jpg",
        "summary": "The United Nations (UN) is an intergovernmental organization tasked to promote international co-operation and to create and maintain international order. A replacement for the ineffective League of Nations, the organization was established on 24 October 1945 after World War II in order to prevent another such conflict. At its founding, the UN had 51 member states there are now 193. The headquarters of the UN is in Manhattan, New York City, and is subject to extraterritoriality. Further main offices are situated in Geneva, Nairobi, and Vienna. The organization is financed by assessed and voluntary contributions from its member states. Its objectives include maintaining international peace and security, promoting human rights, fostering social and economic development, protecting the environment, and providing humanitarian aid in cases of famine, natural disaster, and armed conflict. The UN is the largest, most familiar, most internationally represented and most powerful intergovernmental organization in the world.\nThe UN Charter was drafted at a conference between April\u2013June 1945 in San Francisco, and was signed on 26 June 1945 at the conclusion of the conference this charter took effect 24 October 1945, and the UN began operation. The UN's mission to preserve world peace was complicated in its early decades by the Cold War between the US and Soviet Union and their respective allies. The organization participated in major actions in Korea and the Congo, as well as approving the creation of the state of Israel in 1947. The organization's membership grew significantly following widespread decolonization in the 1960s, and by the 1970s its budget for economic and social development programmes far outstripped its spending on peacekeeping. After the end of the Cold War, the UN took on major military and peacekeeping missions across the world with varying degrees of success.\nThe UN has six principal organs: the General Assembly (the main deliberative assembly) the Security Council (for deciding certain resolutions for peace and security) the Economic and Social Council (ECOSOC for promoting international economic and social co-operation and development) the Secretariat (for providing studies, information, and facilities needed by the UN) the International Court of Justice (the primary judicial organ) and the UN Trusteeship Council (inactive since 1994). UN System agencies include the World Bank Group, the World Health Organization, the World Food Programme, UNESCO, and UNICEF. The UN's most prominent officer is the Secretary-General, an office held by Portuguese Ant\u00f3nio Guterres since 2017. Non-governmental organizations may be granted consultative status with ECOSOC and other agencies to participate in the UN's work.\nThe organization won the Nobel Peace Prize in 2001, and a number of its officers and agencies have also been awarded the prize. Other evaluations of the UN's effectiveness have been mixed. Some commentators believe the organization to be an important force for peace and human development, while others have called the organization ineffective, corrupt, or biased.",
        "title": "United Nations"
    },
    "University": {
        "image": "University.jpg",
        "summary": "A university (Latin: universitas, \"a whole\") is an institution of higher (or tertiary) education and research which awards academic degrees in various academic disciplines. Universities typically provide undergraduate education and postgraduate education.\nThe word \"university\" is derived from the Latin universitas magistrorum et scholarium, which roughly means \"community of teachers and scholars.\" While antecedents had existed in Asia and Africa, the modern university system has roots in the European medieval university, which was created in Italy and evolved from Christian Cathedral schools for the clergy during the High Middle Ages.",
        "title": "University"
    },
    "Warrior Code": {
        "image": "Warrior.jpg",
        "summary": "A warrior is a person specializing in combat or warfare, especially within the context of a tribal or clan-based warrior culture society that recognizes a separate warrior class or caste.",
        "title": "Warrior"
    },
    "Warriors": {
        "image": "Warrior.jpg",
        "summary": "A warrior is a person specializing in combat or warfare, especially within the context of a tribal or clan-based warrior culture society that recognizes a separate warrior class or caste.",
        "title": "Warrior"
    },
    "Women's Suffrage": {
        "image": "Women's suffrage.jpg",
        "summary": "Women's suffrage (also known as female suffrage, woman suffrage or women's right to vote) is the right of women to vote in elections. Limited voting rights were gained by women in Finland, Iceland, Sweden and some Australian colonies and western U.S. states in the late 19th century. National and international organizations formed to coordinate efforts to gain voting rights, especially the International Woman Suffrage Alliance (founded in 1904, Berlin, Germany), and also worked for equal civil rights for women.\nIn 1881, the Isle of Man gave women who owned property the right to vote. In 1893, the British colony of New Zealand, granted women the right to vote. The colony of South Australia, did the same in 1894 and women were able to vote in the next election, which was held in 1895. South Australia also permitted women to stand for election alongside men. In 1899 Western Australia enacted full women's suffrage, enabling women to vote in the constitutional referendum of 31 July 1900 and the 1901 state and federal elections. In 1902 women in the remaining four colonies also acquired the right to vote and stand in federal elections after the six Australian colonies federated to become the Commonwealth of Australia. Discriminatory restrictions against Aboriginal people, including women, voting in national elections, were not completely removed until 1962.\nThe first European country to introduce women's suffrage was the Grand Duchy of Finland, then part of the Russian Empire, which elected the world's first women Members of Parliament in the 1907 parliamentary elections. Norway followed, granting full women's suffrage in 1913.\nMost independent countries enacted women's suffrage in the interwar era, including Canada in 1917, Britain in 1918 and the United States in 1920. Leslie Hume argues that the First World War changed the popular mood:\nThe women's contribution to the war effort challenged the notion of women's physical and mental inferiority and made it more difficult to maintain that women were, both by constitution and temperament, unfit to vote. If women could work in munitions factories, it seemed both ungrateful and illogical to deny them a place in the polling booth. But the vote was much more than simply a reward for war work the point was that women's participation in the war helped to dispel the fears that surrounded women's entry into the public arena.\nLate adopters in Europe were Spain in 1933, France in 1944, Italy in 1946, Greece in 1952, San Marino in 1959, Monaco in 1962, Andorra in 1970, Switzerland in 1971 at federal level, and at local canton level between 1959 in the cantons of Vaud and Neuch\u00e2tel and 1991 in the canton of Appenzell Innerrhoden, and Liechtenstein in 1984. In addition, although women in Portugal obtained suffrage in 1931, this was with stronger restrictions than those of men full gender equality in voting was only granted in 1976.\nThe United States gave women equal voting rights in all states with the Nineteenth Amendment ratified in 1920. Canada and a few Latin American nations passed women's suffrage before World War II while the vast majority of Latin American nations established women's suffrage in the 1940s (see table in Summary below). The last Latin American country to give women the right to vote was Paraguay in 1961.\nIn December 2015, women were first allowed to vote in Saudi Arabia (municipal elections).\nExtended political campaigns by women and their supporters have generally been necessary to gain legislation or constitutional amendments for women's suffrage. In many countries, limited suffrage for women was granted before universal suffrage for men for instance, literate women or property owners were granted suffrage before all men received it. The United Nations encouraged women's suffrage in the years following World War II, and the Convention on the Elimination of All Forms of Discrimination Against Women (1979) identifies it as a basic right with 189 countries currently being parties to this Convention.",
        "title": "Women's suffrage"
    },
    "Workers": {
        "image": "Laborer.jpg",
        "summary": "A laborer is a person who works in one of the construction trades, by tradition, considered unskilled manual labor -- though in practice the laborers are a skilled trade that has reliability and strength as core characteristics. Laborers are employed in the construction industry such as road paving, commercial buildings, bridges, tunnels. Laborers have all blasting, hand tools, power tools, air tools, and small heavy equipment, and act as assistants to other trades as well  such as operators or cement masons. The 1st century BC engineer Vitruvius writes about laborer practices at that time a good crew of laborers is just as valuable as any other aspect of construction. Other than the addition of pneumatics, laborer practices have changed little. With the advent of advanced technology and its introduction into the construction field, the laborers have been quick to include much of this technology as being laborers work.",
        "title": "Laborer"
    },
    "Writing": {
        "image": "Writing.jpg",
        "summary": "Writing is a medium of human communication that represents language and emotion with signs and symbols. In most languages, writing is a complement to speech or spoken language. Writing is not a language, but a tool used to make languages be read. Within a language system, writing relies on many of the same structures as speech, such as vocabulary, grammar, and semantics, with the added dependency of a system of signs or symbols. The result of writing is called text, and the recipient of text is called a reader. Motivations for writing include publication, storytelling, correspondence and diary. Writing has been instrumental in keeping history, maintaining culture, dissemination of knowledge through the media and the formation of legal systems.\nAs human societies emerged, the development of writing was driven by pragmatic exigencies such as exchanging information, maintaining financial accounts, codifying laws and recording history. Around the 4th millennium BCE, the complexity of trade and administration in Mesopotamia outgrew human memory, and writing became a more dependable method of recording and presenting transactions in a permanent form. In both ancient Egypt and Mesoamerica, writing may have evolved through calendric and a political necessity for recording historical and environmental events.",
        "title": "Writing"
    }
}
